------------------------------------------------------------------------------------------
-- CalcStat file
-- Written by Giseldah
-- Version 2.1.3
------------------------------------------------------------------------------------------
local DblCalcDev = 0.00000001;

function CalcStat(SName, SLvl, SParam)

	-- process parameters and parameter defaults

	if type(SName) ~= "string" then
		return "Missing stat name";
	end
	local SN = string.match(SName:upper(),"^%s*(-?%a+%d*%a+)%s*$"); -- allow nested digits in stat name and a starting -
	if SN == nil then
		SN = string.match(SName,"^%s*(-?%a+)%s*$"); -- to allow single character stat name
		if SN == nil then
			return "Illegal stat name";
		end
	end
	SN = string.upper(SN);

	local L = 1; -- default L
	if type(SLvl) == "number" then
		L = SLvl;
	elseif type(SLvl) ~= "nil" then
		return "Illegal level";
	end
	local Lm = L-DblCalcDev;
	local Lp = L+DblCalcDev;

	local N = 1; -- default N
	local C = ""; -- default C
	if type(SParam) == "number" then
		N = SParam;
	elseif type(SParam) == "string" then
		C = SParam;
	elseif type(SParam) ~= "nil" then
		return "Illegal N or C";
	end

	-- binary search tree (generated code)

	if SN < "MINSTRELCDFATETOCRITHIT" then
		if SN < "CREEPBATPROMPOWERP" then
			if SN < "BRWSHAREISBALANCEFINESSE" then
				if SN < "BEORNINGCDBASEVITALITY" then
					if SN < "AWARDILVLGA" then
						if SN < "AWARDILVLAC" then
							if SN < "ARMOURPROGB" then
								if SN < "ARMCATPROGB" then
									if SN < "ACIDMITT" then
										if SN > "-VERSION" then
											if SN == "ACIDMIT" then
												return CalcStat("DmgTypeMit",L,N);
											else
												return 0;
											end
										elseif SN == "-VERSION" then
											return "2.2f";
										else
											return 0;
										end
									elseif SN > "ACIDMITT" then
										if SN < "AGILITYT" then
											if SN == "AGILITY" then
												return CalcStat("Main",L,N);
											else
												return 0;
											end
										elseif SN > "AGILITYT" then
											if SN == "ARMCATMP" then
												return CalcStat("PntMPArmour",L);
											else
												return 0;
											end
										else
											return CalcStat("MainT",L,N);
										end
									else
										return CalcStat("DmgTypeMitT",L,N);
									end
								elseif SN > "ARMCATPROGB" then
									if SN < "ARMOURLOWPNTMP" then
										if SN > "ARMOUR" then
											if SN == "ARMOURLOW" then
												return RoundDblDown(StatLinInter("ArmourLowPntMP","ItemProg","ArmourProgB","",L,C,0));
											else
												return 0;
											end
										elseif SN == "ARMOUR" then
											return RoundDblDown(StatLinInter("ArmourPntMP","ItemProg","ArmourProgB","",L,C,0));
										else
											return 0;
										end
									elseif SN > "ARMOURLOWPNTMP" then
										if SN < "ARMOURPENTADJ" then
											if SN == "ARMOURPENT" then
												return StatLinInter("PntMPArmourPenT","TraitProg","ProgBArmour","ArmourPenTAdj",L,N,0);
											else
												return 0;
											end
										elseif SN > "ARMOURPENTADJ" then
											if SN == "ARMOURPNTMP" then
												return CalcStat("ArmTypeMP",ArmCodeIndex(C,2))*CalcStat("ArmQtyMP",ArmCodeIndex(C,3),ArmCodeIndex(C,2))*CalcStat("ArmCatMP",ArmCodeIndex(C,1));
											else
												return 0;
											end
										else
											if Lm <= 49 then
												return 1;
											elseif Lm <= 50 then
												return 0.8;
											else
												return 1;
											end
										end
									else
										return CalcStat("ArmTypeMP",ArmCodeIndex(C,2))*CalcStat("ArmQtyLowMP",ArmCodeIndex(C,2))*CalcStat("ArmCatMP",ArmCodeIndex(C,1));
									end
								else
									if Lm <= 0 then
										return 0;
									elseif Lm <= 1 then
										return CalcStat("ProgBArmourHeavy",N);
									elseif Lm <= 2 then
										return CalcStat("ProgBArmourMedium",N);
									else
										return CalcStat("ProgBArmourLight",N);
									end
								end
							elseif SN > "ARMOURPROGB" then
								if SN < "ARMQTYRAREMP" then
									if SN < "ARMQTYEPICMP" then
										if SN > "ARMOURT" then
											if SN == "ARMQTYCOMMMP" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({22/30,22/30,0.8,0.8,0.76,0.804,0.8,0.7},L);
												end
											else
												return 0;
											end
										elseif SN == "ARMOURT" then
											return StatLinInter("PntMPArmourT","TraitProg","ProgBArmour","",L,N,0);
										else
											return 0;
										end
									elseif SN > "ARMQTYEPICMP" then
										if SN < "ARMQTYLOWMP" then
											if SN == "ARMQTYINCOMPMP" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({28/30,28/30,0.95,0.95,0.94,0.948,0.95,0.95},L);
												end
											else
												return 0;
											end
										elseif SN > "ARMQTYLOWMP" then
											if SN == "ARMQTYMP" then
												if Lm <= 0 then
													return 0;
												elseif Lm <= 1 then
													return CalcStat("ArmQtyCommMP",N);
												elseif Lm <= 2 then
													return CalcStat("ArmQtyUncomMP",N);
												elseif Lm <= 3 then
													return CalcStat("ArmQtyRareMP",N);
												elseif Lm <= 4 then
													return CalcStat("ArmQtyIncompMP",N);
												else
													return CalcStat("ArmQtyEpicMP",N);
												end
											else
												return 0;
											end
										else
											if Lm <= 0 then
												return 0;
											else
												return DataTableValue({0.3635,0.3635,0.3635,0.3635,0.3635,0.36215,0.3635,0.3635},L);
											end
										end
									else
										if Lm <= 0 then
											return 0;
										else
											return DataTableValue({1,1,1,1,1,1.002,1,1},L);
										end
									end
								elseif SN > "ARMQTYRAREMP" then
									if SN < "AUTOLVLTOILVL" then
										if SN > "ARMQTYUNCOMMP" then
											if SN == "ARMTYPEMP" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({9,9,20,30,15,25,12,32.725},L);
												end
											else
												return 0;
											end
										elseif SN == "ARMQTYUNCOMMP" then
											if Lm <= 0 then
												return 0;
											else
												return DataTableValue({22/30,22/30,0.85,0.85,0.82,0.852,0.85,0.75},L);
											end
										else
											return 0;
										end
									elseif SN > "AUTOLVLTOILVL" then
										if SN < "AWARDILVLAA" then
											if SN == "AWARDILVLA" then
												if Lm <= 75 then
													return L;
												elseif Lm <= 94 then
													return 5*L-304;
												elseif Lm <= 95 then
													return 173;
												elseif Lm <= 100 then
													return 5*L-304;
												elseif Lm <= 101 then
													return 197;
												elseif Lm <= 104 then
													return 4*L-206;
												elseif Lm <= 105 then
													return 218;
												elseif Lm <= 114 then
													return 3*L-30;
												elseif Lm <= 115 then
													return 314;
												elseif Lm <= 120 then
													return 5*L-245;
												elseif Lm <= 130 then
													return 2*L+143;
												elseif Lm <= 140 then
													return RoundDbl(LinFmod(1,435.4,445.4,131,140,L));
												else
													return CalcStat("AwardILvlA",140);
												end
											else
												return 0;
											end
										elseif SN > "AWARDILVLAA" then
											if SN == "AWARDILVLAB" then
												if Lm <= 74 then
													return CalcStat("AwardILvlA",L);
												elseif Lm <= 75 then
													return CalcStat("AwardILvlA",L)+1;
												else
													return CalcStat("AwardILvlA",L);
												end
											else
												return 0;
											end
										else
											if Lm <= 74 then
												return CalcStat("AwardILvlAOld",L);
											elseif Lm <= 75 then
												return CalcStat("AwardILvlAOld",L)+3;
											else
												return CalcStat("AwardILvlAOld",L);
											end
										end
									else
										return CalcStat("AwardILvlCC",L);
									end
								else
									if Lm <= 0 then
										return 0;
									else
										return DataTableValue({26/30,26/30,0.9,0.9,0.88,0.9,0.9,0.8},L);
									end
								end
							else
								return CalcStat("ArmCatProgB",ArmCodeIndex(C,1),L);
							end
						elseif SN > "AWARDILVLAC" then
							if SN < "AWARDILVLDD" then
								if SN < "AWARDILVLCB" then
									if SN < "AWARDILVLBA" then
										if SN > "AWARDILVLAOLD" then
											if SN == "AWARDILVLB" then
												if Lm <= 95 then
													return CalcStat("AwardILvlBOld",L);
												elseif Lm <= 96 then
													return CalcStat("AwardILvlBOld",95);
												else
													return CalcStat("AwardILvlBOld",L);
												end
											else
												return 0;
											end
										elseif SN == "AWARDILVLAOLD" then
											if Lm <= 120 then
												return CalcStat("AwardILvlA",L);
											elseif Lm <= 130 then
												return RoundDbl((14/15)*L+4081/15);
											elseif Lm <= 140 then
												return RoundDbl(LinFmod(1,435.4,445.4,131,140,L));
											else
												return CalcStat("AwardILvlAOld",140);
											end
										else
											return 0;
										end
									elseif SN > "AWARDILVLBA" then
										if SN < "AWARDILVLC" then
											if SN == "AWARDILVLBOLD" then
												if Lm <= 4 then
													return CalcStat("AwardILvlA",1);
												elseif Lm <= 50 then
													return CalcStat("AwardILvlA",L-4);
												elseif Lm <= 54 then
													return CalcStat("AwardILvlA",51);
												elseif Lm <= 75 then
													return CalcStat("AwardILvlA",L-4);
												elseif Lm <= 95 then
													return CalcStat("AwardILvlA",L)+4;
												elseif Lm <= 130 then
													return CalcStat("AwardILvlA",L);
												elseif Lm <= 135 then
													return RoundDbl(LinFmod(1,438.4,443.4,131,135,L));
												elseif Lm <= 140 then
													return RoundDbl(LinFmod(1,444.4,446.4,136,140,L));
												else
													return CalcStat("AwardILvlBOld",140);
												end
											else
												return 0;
											end
										elseif SN > "AWARDILVLC" then
											if SN == "AWARDILVLCA" then
												if Lm <= 95 then
													return CalcStat("AwardILvlC",L);
												elseif Lm <= 100 then
													return CalcStat("AwardILvlC",L)+4;
												else
													return CalcStat("AwardILvlC",L);
												end
											else
												return 0;
											end
										else
											if Lm <= 75 then
												return CalcStat("AwardILvlBOld",L);
											elseif Lm <= 95 then
												return CalcStat("AwardILvlA",L);
											else
												return CalcStat("AwardILvlBOld",L);
											end
										end
									else
										return CalcStat("AwardILvlB",L);
									end
								elseif SN > "AWARDILVLCB" then
									if SN < "AWARDILVLD" then
										if SN > "AWARDILVLCC" then
											if SN == "AWARDILVLCD" then
												if Lm <= 100 then
													return CalcStat("AwardILvlC",L);
												elseif Lm <= 105 then
													return CalcStat("AwardILvlC",L)+4;
												else
													return CalcStat("AwardILvlC",L);
												end
											else
												return 0;
											end
										elseif SN == "AWARDILVLCC" then
											if Lm <= 75 then
												return CalcStat("AwardILvlC",L);
											elseif Lm <= 95 then
												return CalcStat("AwardILvlC",L)+2;
											else
												return CalcStat("AwardILvlC",L);
											end
										else
											return 0;
										end
									elseif SN > "AWARDILVLD" then
										if SN < "AWARDILVLDB" then
											if SN == "AWARDILVLDA" then
												if Lm <= 105 then
													return CalcStat("AwardILvlD",L);
												elseif Lm <= 115 then
													return RoundDbl(LinFmod(1,300,336.5,106,115,L));
												else
													return CalcStat("AwardILvlD",L);
												end
											else
												return 0;
											end
										elseif SN > "AWARDILVLDB" then
											if SN == "AWARDILVLDC" then
												if Lm <= 105 then
													return CalcStat("AwardILvlD",L);
												elseif Lm <= 110 then
													return RoundDbl(LinFmod(1,300,320,106,115,L));
												elseif Lm <= 115 then
													return CalcStat("AwardILvlDC",110);
												else
													return CalcStat("AwardILvlD",L);
												end
											else
												return 0;
											end
										else
											if Lm <= 105 then
												return CalcStat("AwardILvlD",L);
											elseif Lm <= 115 then
												return RoundDbl(LinFmod(1,300,345,106,115,L));
											else
												return CalcStat("AwardILvlD",L);
											end
										end
									else
										if Lm <= 105 then
											return CalcStat("AwardILvlC",L);
										elseif Lm <= 115 then
											return 300;
										elseif Lm <= 130 then
											return CalcStat("AwardILvlC",L)+3;
										else
											return CalcStat("AwardILvlC",L);
										end
									end
								else
									if Lm <= 95 then
										return CalcStat("AwardILvlC",L);
									elseif Lm <= 99 then
										return CalcStat("AwardILvlC",L)+4;
									elseif Lm <= 100 then
										return CalcStat("AwardILvlC",L)+6;
									else
										return CalcStat("AwardILvlC",L);
									end
								end
							elseif SN > "AWARDILVLDD" then
								if SN < "AWARDILVLEC" then
									if SN < "AWARDILVLDG" then
										if SN > "AWARDILVLDE" then
											if SN == "AWARDILVLDF" then
												if Lm <= 105 then
													return CalcStat("AwardILvlD",L);
												elseif Lm <= 110 then
													return CalcStat("AwardILvlDF",111);
												elseif Lm <= 115 then
													return RoundDbl(LinFmod(1,299.5,320.5,106,115,L));
												else
													return CalcStat("AwardILvlD",L);
												end
											else
												return 0;
											end
										elseif SN == "AWARDILVLDE" then
											if Lm <= 105 then
												return CalcStat("AwardILvlD",L);
											elseif Lm <= 115 then
												return RoundDbl(LinFmod(1,300.4,326.4,106,115,L));
											else
												return CalcStat("AwardILvlD",L);
											end
										else
											return 0;
										end
									elseif SN > "AWARDILVLDG" then
										if SN < "AWARDILVLEA" then
											if SN == "AWARDILVLE" then
												if Lm <= 115 then
													return CalcStat("AwardILvlC",L);
												elseif Lm <= 120 then
													return 350;
												else
													return CalcStat("AwardILvlD",L);
												end
											else
												return 0;
											end
										elseif SN > "AWARDILVLEA" then
											if SN == "AWARDILVLEB" then
												if Lm <= 115 then
													return CalcStat("AwardILvlE",L);
												elseif Lm <= 119 then
													return RoundDbl(LinFmod(1,350,390,116,120,L));
												elseif Lm <= 120 then
													return CalcStat("AwardILvlE",120)+38;
												else
													return CalcStat("AwardILvlE",L);
												end
											else
												return 0;
											end
										else
											if Lm <= 115 then
												return CalcStat("AwardILvlE",L);
											elseif Lm <= 119 then
												return RoundDbl(LinFmod(1,350,378,116,120,L));
											elseif Lm <= 120 then
												return CalcStat("AwardILvlE",120)+26;
											else
												return CalcStat("AwardILvlE",L);
											end
										end
									else
										if Lm <= 105 then
											return CalcStat("AwardILvlD",L);
										elseif Lm <= 114 then
											return RoundDbl(LinFmod(1,300,336,106,115,L));
										elseif Lm <= 115 then
											return CalcStat("AwardILvlD",115)+40;
										else
											return CalcStat("AwardILvlD",L);
										end
									end
								elseif SN > "AWARDILVLEC" then
									if SN < "AWARDILVLF" then
										if SN > "AWARDILVLED" then
											if SN == "AWARDILVLEE" then
												if Lm <= 115 then
													return CalcStat("AwardILvlE",L);
												elseif Lm <= 119 then
													return RoundDbl(LinFmod(1,350,366,116,120,L));
												elseif Lm <= 120 then
													return CalcStat("AwardILvlE",120)+14;
												else
													return CalcStat("AwardILvlE",L);
												end
											else
												return 0;
											end
										elseif SN == "AWARDILVLED" then
											if Lm <= 115 then
												return CalcStat("AwardILvlE",L);
											elseif Lm <= 120 then
												return RoundDbl(LinFmod(1,350,370,116,120,L));
											else
												return CalcStat("AwardILvlE",L);
											end
										else
											return 0;
										end
									elseif SN > "AWARDILVLF" then
										if SN < "AWARDILVLFB" then
											if SN == "AWARDILVLFA" then
												if Lm <= 130 then
													return CalcStat("AwardILvlF",L);
												elseif Lm <= 140 then
													return RoundDbl(LinFmod(1,438.4,447.4,131,140,L));
												else
													return CalcStat("AwardILvlFA",140);
												end
											else
												return 0;
											end
										elseif SN > "AWARDILVLFB" then
											if SN == "AWARDILVLG" then
												if Lm <= 115 then
													return CalcStat("AwardILvlC",L);
												elseif Lm <= 120 then
													return CalcStat("AwardILvlC",L)+3;
												elseif Lm <= 130 then
													return 400;
												else
													return CalcStat("AwardILvlC",L);
												end
											else
												return 0;
											end
										else
											if Lm <= 119 then
												return CalcStat("AwardILvlF",L);
											elseif Lm <= 120 then
												return 380;
											elseif Lm <= 129 then
												return CalcStat("AwardILvlF",L);
											elseif Lm <= 130 then
												return 432;
											elseif Lm <= 140 then
												return RoundDbl(LinFmod(1,450.4,478.4,131,140,L));
											else
												return CalcStat("AwardILvlFB",140);
											end
										end
									else
										if Lm <= 40 then
											return LinFmod(1,1,40,1,40,L);
										elseif Lm <= 41 then
											return CalcStat("AwardILvlF",L-1);
										elseif Lm <= 49 then
											return LinFmod(1,41,48,42,49,L);
										elseif Lm <= 50 then
											return CalcStat("AwardILvlF",L-1);
										elseif Lm <= 55 then
											return LinFmod(1,51,55,51,55,L);
										elseif Lm <= 56 then
											return CalcStat("AwardILvlF",L-1);
										elseif Lm <= 59 then
											return LinFmod(1,56,58,57,59,L);
										elseif Lm <= 60 then
											return CalcStat("AwardILvlF",L-1);
										elseif Lm <= 64 then
											return RoundDbl(LinFmod(1,60.6,63,61,64,L));
										elseif Lm <= 65 then
											return CalcStat("AwardILvlF",L-1);
										elseif Lm <= 70 then
											return LinFmod(1,66,70,66,70,L);
										elseif Lm <= 71 then
											return CalcStat("AwardILvlF",L-1);
										elseif Lm <= 74 then
											return LinFmod(1,71,73,72,74,L);
										elseif Lm <= 75 then
											return CalcStat("AwardILvlF",L-1);
										elseif Lm <= 85 then
											return RoundDbl(LinFmod(1,80.4,123.4,76,85,L));
										elseif Lm <= 94 then
											return RoundDbl(LinFmod(1,130,169,86,94,L));
										elseif Lm <= 100 then
											return RoundDbl(LinFmod(1,175,198.4,95,100,L));
										elseif Lm <= 104 then
											return LinFmod(1,201,213,101,104,L);
										elseif Lm <= 105 then
											return 220;
										elseif Lm <= 114 then
											return RoundDbl(LinFmod(1,300,323,106,114,L));
										elseif Lm <= 115 then
											return 324;
										elseif Lm <= 120 then
											return RoundDbl(LinFmod(1,349.6,368.4,116,120,L));
										elseif Lm <= 130 then
											return RoundDbl(LinFmod(1,400.4,416.4,121,130,L));
										else
											return CalcStat("AwardILvlF",130);
										end
									end
								else
									if Lm <= 115 then
										return CalcStat("AwardILvlE",L);
									elseif Lm <= 120 then
										return RoundDbl(LinFmod(1,350,382,116,120,L));
									else
										return CalcStat("AwardILvlE",L);
									end
								end
							else
								if Lm <= 105 then
									return CalcStat("AwardILvlD",L);
								elseif Lm <= 114 then
									return RoundDbl(LinFmod(1,300,327,106,115,L));
								elseif Lm <= 115 then
									return CalcStat("AwardILvlD",115)+30;
								else
									return CalcStat("AwardILvlD",L);
								end
							end
						else
							if Lm <= 74 then
								return CalcStat("AwardILvlA",L);
							elseif Lm <= 75 then
								return CalcStat("AwardILvlA",L)+2;
							else
								return CalcStat("AwardILvlA",L);
							end
						end
					elseif SN > "AWARDILVLGA" then
						if SN < "BASEMORALE" then
							if SN < "AWARDLVLCAP" then
								if SN < "AWARDILVLI" then
									if SN < "AWARDILVLGD" then
										if SN > "AWARDILVLGB" then
											if SN == "AWARDILVLGC" then
												if Lm <= 120 then
													return CalcStat("AwardILvlG",L);
												elseif Lm <= 130 then
													return RoundDbl(LinFmod(1,400.4,408.3,121,130,L));
												else
													return CalcStat("AwardILvlG",L);
												end
											else
												return 0;
											end
										elseif SN == "AWARDILVLGB" then
											if Lm <= 120 then
												return CalcStat("AwardILvlG",L);
											elseif Lm <= 130 then
												return RoundDbl(LinFmod(1,400.4,418.4,121,130,L));
											else
												return CalcStat("AwardILvlG",L);
											end
										else
											return 0;
										end
									elseif SN > "AWARDILVLGD" then
										if SN < "AWARDILVLGF" then
											if SN == "AWARDILVLGE" then
												if Lm <= 120 then
													return CalcStat("AwardILvlG",L);
												elseif Lm <= 130 then
													return RoundDbl(LinFmod(1,400.4,434.4,121,130,L));
												else
													return CalcStat("AwardILvlG",L);
												end
											else
												return 0;
											end
										elseif SN > "AWARDILVLGF" then
											if SN == "AWARDILVLH" then
												if Lm <= 4 then
													return CalcStat("AwardILvlA",1);
												elseif Lm <= 50 then
													return CalcStat("AwardILvlA",L-4);
												elseif Lm <= 54 then
													return CalcStat("AwardILvlA",51);
												elseif Lm <= 75 then
													return CalcStat("AwardILvlA",L-4);
												else
													return L-4;
												end
											else
												return 0;
											end
										else
											if Lm <= 120 then
												return CalcStat("AwardILvlG",L);
											elseif Lm <= 130 then
												return RoundDbl(LinFmod(1,400.4,440.4,121,130,L));
											else
												return CalcStat("AwardILvlG",L);
											end
										end
									else
										if Lm <= 120 then
											return CalcStat("AwardILvlG",L);
										elseif Lm <= 130 then
											return RoundDbl(LinFmod(1,400.4,426.4,121,130,L));
										else
											return CalcStat("AwardILvlG",L);
										end
									end
								elseif SN > "AWARDILVLI" then
									if SN < "AWARDILVLJA" then
										if SN > "AWARDILVLIA" then
											if SN == "AWARDILVLJ" then
												if Lm <= 19 then
													return CalcStat("AwardILvlB",L);
												elseif Lm <= 40 then
													return CalcStat("AwardILvlA",L);
												elseif Lm <= 50 then
													return RoundDbl(LinFmod(1,40.4,47.6,41,50,L));
												elseif Lm <= 120 then
													return CalcStat("AwardILvlG",L);
												elseif Lm <= 130 then
													return CalcStat("AwardILvlD",L);
												elseif Lm <= 140 then
													return RoundDbl(LinFmod(1,450.4,460.4,131,140,L));
												else
													return CalcStat("AwardILvlJ",140);
												end
											else
												return 0;
											end
										elseif SN == "AWARDILVLIA" then
											if Lm <= 44 then
												return CalcStat("AwardILvlI",L);
											elseif Lm <= 55 then
												return RoundDblDown((L-45)/6)+51;
											elseif Lm <= 90 then
												return CalcStat("AwardILvlI",L);
											elseif Lm <= 104 then
												return RoundDblDown((L-91)/5)*25+165;
											elseif Lm <= 105 then
												return CalcStat("LvlToILvl",L);
											elseif Lm <= 110 then
												return CalcStat("LvlToILvl",106)+15;
											elseif Lm <= 115 then
												return CalcStat("LvlToILvl",115)-20;
											elseif Lm <= 120 then
												return CalcStat("LvlToILvl",116)+15;
											elseif Lm <= 125 then
												return CalcStat("LvlToILvl",121)+15;
											elseif Lm <= 130 then
												return CalcStat("LvlToILvl",130)-20;
											elseif Lm <= 135 then
												return CalcStat("LvlToILvl",131)+15;
											elseif Lm <= 140 then
												return CalcStat("LvlToILvl",140)-14;
											else
												return CalcStat("AwardILvlIA",140);
											end
										else
											return 0;
										end
									elseif SN > "AWARDILVLJA" then
										if SN < "AWARDILVLJC" then
											if SN == "AWARDILVLJB" then
												if Lm <= 130 then
													return CalcStat("AwardILvlJ",L);
												elseif Lm <= 140 then
													return RoundDbl(LinFmod(1,450.4,470.4,131,140,L));
												else
													return CalcStat("AwardILvlJB",140);
												end
											else
												return 0;
											end
										elseif SN > "AWARDILVLJC" then
											if SN == "AWARDILVLJD" then
												if Lm <= 130 then
													return CalcStat("AwardILvlJ",L);
												elseif Lm <= 140 then
													return RoundDbl(LinFmod(1,450.4,480.4,131,140,L));
												else
													return CalcStat("AwardILvlJD",140);
												end
											else
												return 0;
											end
										else
											if Lm <= 130 then
												return CalcStat("AwardILvlJ",L);
											elseif Lm <= 140 then
												return RoundDbl(LinFmod(1,450.4,475.4,131,140,L));
											else
												return CalcStat("AwardILvlJC",140);
											end
										end
									else
										if Lm <= 130 then
											return CalcStat("AwardILvlJ",L);
										elseif Lm <= 140 then
											return RoundDbl(LinFmod(1,450.4,465.4,131,140,L));
										else
											return CalcStat("AwardILvlJA",140);
										end
									end
								else
									if Lm <= 44 then
										return 1;
									elseif Lm <= 55 then
										return 52;
									elseif Lm <= 75 then
										return RoundDblDown((L-56)/5)*5+60;
									elseif Lm <= 85 then
										return RoundDblDown((L-76)/5)*29+100;
									elseif Lm <= 95 then
										return RoundDblDown((L-86)/5)*20+155;
									elseif Lm <= 100 then
										return RoundDblDown((L-96)/4)*10+190;
									elseif Lm <= 105 then
										return RoundDblDown((L-101)/4)*35+215;
									elseif Lm <= 110 then
										return CalcStat("LvlToILvl",106)+15;
									elseif Lm <= 115 then
										return CalcStat("LvlToILvl",115);
									elseif Lm <= 119 then
										return CalcStat("LvlToILvl",116)+15;
									elseif Lm <= 120 then
										return CalcStat("LvlToILvl",120);
									elseif Lm <= 125 then
										return CalcStat("LvlToILvl",121)+15;
									elseif Lm <= 130 then
										return CalcStat("LvlToILvl",130);
									elseif Lm <= 135 then
										return CalcStat("LvlToILvl",131)+15;
									elseif Lm <= 140 then
										return CalcStat("LvlToILvl",140);
									else
										return CalcStat("AwardILvlI",140);
									end
								end
							elseif SN > "AWARDLVLCAP" then
								if SN < "BASEAGILITY" then
									if SN < "AXEARMRENDPOS" then
										if SN > "AWARDLVLTOILVL" then
											if SN == "AXEARMOURREND" then
												return -CalcStat("AxeArmRendPos",L);
											else
												return 0;
											end
										elseif SN == "AWARDLVLTOILVL" then
											return CalcStat("AwardILvlC",L);
										else
											return 0;
										end
									elseif SN > "AXEARMRENDPOS" then
										if SN < "BALANCEOFMANEVADE" then
											if SN == "BALANCEOFMANBLOCK" then
												return CalcStat("BlockT",L,0.8);
											else
												return 0;
											end
										elseif SN > "BALANCEOFMANEVADE" then
											if SN == "BALANCEOFMANPARRY" then
												return CalcStat("ParryT",L,0.8);
											else
												return 0;
											end
										else
											return CalcStat("EvadeT",L,1.0);
										end
									else
										if Lm <= 7 then
											return RoundDbl(LinFmod(1,0.5,3.25,1,7,L));
										elseif Lm <= 14 then
											return RoundDbl(LinFmod(1,3.75,8.5,8,14,L));
										elseif Lm <= 30 then
											return RoundDbl(LinFmod(1,9,24.7,15,30,L));
										elseif Lm <= 39 then
											return RoundDbl(LinFmod(1,26.5,37,31,39,L));
										elseif Lm <= 50 then
											return RoundDbl(LinFmod(1,38.5,53,40,50,L));
										elseif Lm <= 52 then
											return 53;
										elseif Lm <= 60 then
											return RoundDbl(LinFmod(1,53.2,64.8,53,60,L));
										elseif Lm <= 77 then
											return RoundDbl(LinFmod(1,66.15,94.8,61,77,L));
										elseif Lm <= 113 then
											return RoundDbl(RoundDbl(L/3-0.5)*1.95+44.1);
										elseif Lm <= 141 then
											return 116;
										elseif Lm <= 181 then
											return RoundDbl(RoundDbl(L/4)*2+46);
										elseif Lm <= 217 then
											return RoundDbl(RoundDbl(L/4)*2+45);
										elseif Lm <= 221 then
											return 153;
										elseif Lm <= 299 then
											return 155;
										elseif Lm <= 308 then
											return RoundDbl(RoundDbl(L/2.6-0.4)*2-73);
										elseif Lm <= 317 then
											return RoundDbl(RoundDbl(L/2.74-0.75)*2-60);
										elseif Lm <= 325 then
											return 172;
										elseif Lm <= 326 then
											return 174;
										elseif Lm <= 500 then
											return ExpFmod(CalcStat("AxeArmRendPos",326),327,1,L,1);
										else
											return CalcStat("AxeArmRendPos",500);
										end
									end
								elseif SN > "BASEAGILITY" then
									if SN < "BASEFATE" then
										if SN > "BASEARMOUR" then
											if SN == "BASEENERGY" then
												if Lm <= 50 then
													return LinFmod(1,10,25,1,50,L)*N;
												elseif Lm <= 60 then
													return LinFmod(1,25,38,50,60,L)*N;
												elseif Lm <= 65 then
													return LinFmod(1,38,51,60,65,L)*N;
												elseif Lm <= 75 then
													return LinFmod(1,51,77,65,75,L)*N;
												elseif Lm <= 85 then
													return LinFmod(1,77,116,75,85,L)*N;
												elseif Lm <= 95 then
													return LinFmod(1,116,168,85,95,L)*N;
												elseif Lm <= 100 then
													return LinFmod(1,168,218,95,100,L)*N;
												elseif Lm <= 105 then
													return LinFmod(1,218,283,100,105,L)*N;
												elseif Lm <= 115 then
													return LinFmod(1,311,440,106,115,L,0)*N;
												elseif Lm <= 120 then
													return LinFmod(1,510,550,116,120,L,0)*N;
												elseif Lm <= 130 then
													return LinFmod(1,630,840,121,130,L,0)*N;
												else
													return LinFmod(1,970,1660,131,140,L,0)*N;
												end
											else
												return 0;
											end
										elseif SN == "BASEARMOUR" then
											return RoundDblUp(CalcStat("BaseMain",L,N));
										else
											return 0;
										end
									elseif SN > "BASEFATE" then
										if SN < "BASEMAIN" then
											if SN == "BASEHEALTH" then
												if Lm <= 50 then
													return LinFmod(1,4,30,1,50,L)*N;
												elseif Lm <= 60 then
													return LinFmod(1,30,45,50,60,L)*N;
												elseif Lm <= 65 then
													return LinFmod(1,45,60,60,65,L)*N;
												elseif Lm <= 75 then
													return LinFmod(1,60,90,65,75,L)*N;
												elseif Lm <= 85 then
													return LinFmod(1,90,135,75,85,L)*N;
												elseif Lm <= 95 then
													return LinFmod(1,135,195,85,95,L)*N;
												elseif Lm <= 100 then
													return LinFmod(1,195,300,95,100,L)*N;
												elseif Lm <= 105 then
													return LinFmod(1,300,390,100,105,L)*N;
												elseif Lm <= 115 then
													return LinFmod(1,430,600,106,115,L,0)*N;
												elseif Lm <= 120 then
													return LinFmod(1,690,750,116,120,L,0)*N;
												elseif Lm <= 130 then
													return LinFmod(1,860,1140,121,130,L,0)*N;
												else
													return LinFmod(1,1310,2250,131,140,L,0)*N;
												end
											else
												return 0;
											end
										elseif SN > "BASEMAIN" then
											if SN == "BASEMIGHT" then
												return RoundDbl(CalcStat("BaseMain",L,N));
											else
												return 0;
											end
										else
											if Lm <= 50 then
												return LinFmod(1,1,10,1,50,L)*N;
											elseif Lm <= 60 then
												return LinFmod(1,10,15,50,60,L)*N;
											elseif Lm <= 65 then
												return LinFmod(1,15,20,60,65,L)*N;
											elseif Lm <= 75 then
												return LinFmod(1,20,30,65,75,L)*N;
											elseif Lm <= 85 then
												return LinFmod(1,30,45,75,85,L)*N;
											elseif Lm <= 95 then
												return LinFmod(1,45,65,85,95,L)*N;
											elseif Lm <= 100 then
												return LinFmod(1,65,100,95,100,L)*N;
											elseif Lm <= 105 then
												return LinFmod(1,100,130,100,105,L)*N;
											elseif Lm <= 115 then
												return LinFmod(1,143,200,106,115,L,0)*N;
											elseif Lm <= 120 then
												return LinFmod(1,230,250,116,120,L,0)*N;
											elseif Lm <= 130 then
												return LinFmod(1,288,380,121,130,L,0)*N;
											else
												return LinFmod(1,440,750,131,140,L,0)*N;
											end
										end
									else
										return RoundDbl(CalcStat("BaseEnergy",L,N));
									end
								else
									return RoundDbl(CalcStat("BaseMain",L,N));
								end
							else
								return 140;
							end
						elseif SN > "BASEMORALE" then
							if SN < "BEORNINGCDAGILITYTOPHYMAS" then
								if SN < "BEOEMISSARYFATE" then
									if SN < "BASEWILL" then
										if SN > "BASEPOWER" then
											if SN == "BASEVITALITY" then
												return RoundDbl(CalcStat("BaseHealth",L,N));
											else
												return 0;
											end
										elseif SN == "BASEPOWER" then
											return RoundDblDown(CalcStat("BaseEnergy",L,N));
										else
											return 0;
										end
									elseif SN > "BASEWILL" then
										if SN < "BATTLELOREPHYMAS" then
											if SN == "BATTLELOREMAS" then
												if Lm <= 105 then
													return CalcStat("Mastery",L,2.5);
												elseif Lm <= 119 then
													return CalcStat("MasteryT",L,1.2);
												elseif Lm <= 120 then
													return CalcStat("MasteryT",L,1.6);
												elseif Lm <= 129 then
													return CalcStat("MasteryT",L,1.2);
												elseif Lm <= 130 then
													return CalcStat("MasteryT",L,1.6);
												elseif Lm <= 139 then
													return CalcStat("MasteryT",L,1.2);
												else
													return CalcStat("MasteryT",L,1.6);
												end
											else
												return 0;
											end
										elseif SN > "BATTLELOREPHYMAS" then
											if SN == "BATTLELORETACMAS" then
												return CalcStat("BattleLoreMas",L);
											else
												return 0;
											end
										else
											return CalcStat("BattleLoreMas",L);
										end
									else
										return RoundDbl(CalcStat("BaseMain",L,N));
									end
								elseif SN > "BEOEMISSARYFATE" then
									if SN < "BEOFEWINNUMBERFATE" then
										if SN > "BEOFATE" then
											if SN == "BEOFERALPRESFATE" then
												return CalcStat("FateT",L,1.0);
											else
												return 0;
											end
										elseif SN == "BEOFATE" then
											return CalcStat("FateT",L,CalcStat("Trait567810Choice",N)*0.4);
										else
											return 0;
										end
									elseif SN > "BEOFEWINNUMBERFATE" then
										if SN < "BEORNINGCDAGILITYTOCRITHIT" then
											if SN == "BEOMIGHTOFTHEWILDMIGHT" then
												return CalcStat("MightT",L,1.0);
											else
												return 0;
											end
										elseif SN > "BEORNINGCDAGILITYTOCRITHIT" then
											if SN == "BEORNINGCDAGILITYTOEVADE" then
												return 2;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return -CalcStat("FateT",L,0.4);
									end
								else
									return CalcStat("FateT",L,1.0);
								end
							elseif SN > "BEORNINGCDAGILITYTOPHYMAS" then
								if SN < "BEORNINGCDBASEICMR" then
									if SN < "BEORNINGCDARMOURTOTACMIT" then
										if SN > "BEORNINGCDARMOURTOOFMIT" then
											if SN == "BEORNINGCDARMOURTOPHYMIT" then
												return 1;
											else
												return 0;
											end
										elseif SN == "BEORNINGCDARMOURTOOFMIT" then
											return 0.2;
										else
											return 0;
										end
									elseif SN > "BEORNINGCDARMOURTOTACMIT" then
										if SN < "BEORNINGCDBASEAGILITY" then
											if SN == "BEORNINGCDARMOURTYPE" then
												return 3;
											else
												return 0;
											end
										elseif SN > "BEORNINGCDBASEAGILITY" then
											if SN == "BEORNINGCDBASEFATE" then
												return CalcStat("ClassBaseFate",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseAgilityM",L);
										end
									else
										return 0.2;
									end
								elseif SN > "BEORNINGCDBASEICMR" then
									if SN < "BEORNINGCDBASEMORALE" then
										if SN > "BEORNINGCDBASEICPR" then
											if SN == "BEORNINGCDBASEMIGHT" then
												return CalcStat("ClassBaseMightM",L);
											else
												return 0;
											end
										elseif SN == "BEORNINGCDBASEICPR" then
											return CalcStat("ClassBaseICPR",L);
										else
											return 0;
										end
									elseif SN > "BEORNINGCDBASEMORALE" then
										if SN < "BEORNINGCDBASENCPR" then
											if SN == "BEORNINGCDBASENCMR" then
												return CalcStat("ClassBaseNCMRM",L);
											else
												return 0;
											end
										elseif SN > "BEORNINGCDBASENCPR" then
											if SN == "BEORNINGCDBASEPOWER" then
												return 10;
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseNCPR",L);
										end
									else
										return CalcStat("ClassBaseMorale",L);
									end
								else
									return CalcStat("ClassBaseICMRM",L);
								end
							else
								return 2;
							end
						else
							return RoundDblDown(CalcStat("BaseHealth",L,N));
						end
					else
						if Lm <= 120 then
							return CalcStat("AwardILvlG",L);
						elseif Lm <= 130 then
							return RoundDbl(LinFmod(1,400.4,412.4,121,130,L));
						else
							return CalcStat("AwardILvlG",L);
						end
					end
				elseif SN > "BEORNINGCDBASEVITALITY" then
					if SN < "BRATMITLIGHT" then
						if SN < "BEORNINGRDTRAITVITALITY" then
							if SN < "BEORNINGCDPHYMITTOOFMIT" then
								if SN < "BEORNINGCDFATETOTACMIT" then
									if SN < "BEORNINGCDFATETOCRITHIT" then
										if SN > "BEORNINGCDBASEWILL" then
											if SN == "BEORNINGCDCANBLOCK" then
												if Lm <= 5 then
													return 0;
												else
													return 1;
												end
											else
												return 0;
											end
										elseif SN == "BEORNINGCDBASEWILL" then
											return CalcStat("ClassBaseWillM",L);
										else
											return 0;
										end
									elseif SN > "BEORNINGCDFATETOCRITHIT" then
										if SN < "BEORNINGCDFATETOICMR" then
											if SN == "BEORNINGCDFATETOFINESSE" then
												return 0.5;
											else
												return 0;
											end
										elseif SN > "BEORNINGCDFATETOICMR" then
											if SN == "BEORNINGCDFATETORESIST" then
												return 0.5;
											else
												return 0;
											end
										else
											return 0.05;
										end
									else
										return 1.5;
									end
								elseif SN > "BEORNINGCDFATETOTACMIT" then
									if SN < "BEORNINGCDMIGHTTOEVADE" then
										if SN > "BEORNINGCDMIGHTTOBLOCK" then
											if SN == "BEORNINGCDMIGHTTOCRITHIT" then
												return 1;
											else
												return 0;
											end
										elseif SN == "BEORNINGCDMIGHTTOBLOCK" then
											return 2;
										else
											return 0;
										end
									elseif SN > "BEORNINGCDMIGHTTOEVADE" then
										if SN < "BEORNINGCDMIGHTTOPHYMAS" then
											if SN == "BEORNINGCDMIGHTTOPARRY" then
												return 3;
											else
												return 0;
											end
										elseif SN > "BEORNINGCDMIGHTTOPHYMAS" then
											if SN == "BEORNINGCDMIGHTTOTACMAS" then
												return 2.5;
											else
												return 0;
											end
										else
											return 2.5;
										end
									else
										return 1;
									end
								else
									return 1;
								end
							elseif SN > "BEORNINGCDPHYMITTOOFMIT" then
								if SN < "BEORNINGCDWILLTOTACMAS" then
									if SN < "BEORNINGCDVITALITYTONCMR" then
										if SN > "BEORNINGCDTACMASTOOUTHEAL" then
											if SN == "BEORNINGCDVITALITYTOMORALE" then
												return 4.8;
											else
												return 0;
											end
										elseif SN == "BEORNINGCDTACMASTOOUTHEAL" then
											return 1;
										else
											return 0;
										end
									elseif SN > "BEORNINGCDVITALITYTONCMR" then
										if SN < "BEORNINGCDWILLTOEVADE" then
											if SN == "BEORNINGCDVITALITYTORESIST" then
												return 1;
											else
												return 0;
											end
										elseif SN > "BEORNINGCDWILLTOEVADE" then
											if SN == "BEORNINGCDWILLTORESIST" then
												return 1;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return 0.12;
									end
								elseif SN > "BEORNINGCDWILLTOTACMAS" then
									if SN < "BEORNINGRDPSVONENAME" then
										if SN > "BEORNINGCDWILLTOTACMIT" then
											if SN == "BEORNINGRDPSVONEFATE" then
												return CalcStat("BeoEmissaryFate",L);
											else
												return 0;
											end
										elseif SN == "BEORNINGCDWILLTOTACMIT" then
											return 1;
										else
											return 0;
										end
									elseif SN > "BEORNINGRDPSVONENAME" then
										if SN < "BEORNINGRDTRAITFATE" then
											if SN == "BEORNINGRDPSVTWONAME" then
												return "";
											else
												return 0;
											end
										elseif SN > "BEORNINGRDTRAITFATE" then
											if SN == "BEORNINGRDTRAITMIGHT" then
												return CalcStat("BeoMightoftheWildMight",L);
											else
												return 0;
											end
										else
											return CalcStat("BeoFewinNumberFate",L);
										end
									else
										return "Emissary";
									end
								else
									return 2;
								end
							else
								return 1;
							end
						elseif SN > "BEORNINGRDTRAITVITALITY" then
							if SN < "BPEPBONUS" then
								if SN < "BLOCKPRATPA" then
									if SN < "BLOCK" then
										if SN > "BEOTHICKHIDEVITALITY" then
											if SN == "BEOVITALITYINCREASE" then
												return CalcStat("VitalityT",L,CalcStat("Trait567810Choice",N)*0.4);
											else
												return 0;
											end
										elseif SN == "BEOTHICKHIDEVITALITY" then
											return CalcStat("VitalityT",L,1.0);
										else
											return 0;
										end
									elseif SN > "BLOCK" then
										if SN < "BLOCKPPRAT" then
											if SN == "BLOCKPBONUS" then
												return CalcStat("BPEPBonus",L);
											else
												return 0;
											end
										elseif SN > "BLOCKPPRAT" then
											if SN == "BLOCKPRATP" then
												return CalcStat("BPEPRatP",L,N);
											else
												return 0;
											end
										else
											return CalcStat("BPEPPRat",L,N);
										end
									else
										return CalcStat("BPE",L,N);
									end
								elseif SN > "BLOCKPRATPA" then
									if SN < "BLOCKPRATPCAP" then
										if SN > "BLOCKPRATPB" then
											if SN == "BLOCKPRATPC" then
												return CalcStat("BPEPRatPC",L);
											else
												return 0;
											end
										elseif SN == "BLOCKPRATPB" then
											return CalcStat("BPEPRatPB",L);
										else
											return 0;
										end
									elseif SN > "BLOCKPRATPCAP" then
										if SN < "BLOCKT" then
											if SN == "BLOCKPRATPCAPR" then
												return CalcStat("BPEPRatPCapR",L);
											else
												return 0;
											end
										elseif SN > "BLOCKT" then
											if SN == "BPE" then
												return StatLinInter("PntMPBPE","ItemProg","ProgBBPE","",L,N,0);
											else
												return 0;
											end
										else
											return CalcStat("BPET",L,N);
										end
									else
										return CalcStat("BPEPRatPCap",L);
									end
								else
									return CalcStat("BPEPRatPA",L);
								end
							elseif SN > "BPEPBONUS" then
								if SN < "BPEPRATPCAPR" then
									if SN < "BPEPRATPA" then
										if SN > "BPEPPRAT" then
											if SN == "BPEPRATP" then
												return CalcPercAB(CalcStat("BPEPRatPA",L),CalcStat("BPEPRatPB",L),CalcStat("BPEPRatPCap",L),N);
											else
												return 0;
											end
										elseif SN == "BPEPPRAT" then
											return CalcRatAB(CalcStat("BPEPRatPA",L),CalcStat("BPEPRatPB",L),CalcStat("BPEPRatPCapR",L),N);
										else
											return 0;
										end
									elseif SN > "BPEPRATPA" then
										if SN < "BPEPRATPC" then
											if SN == "BPEPRATPB" then
												return CalcStat("BRatRounded",L,"BRatLow");
											else
												return 0;
											end
										elseif SN > "BPEPRATPC" then
											if SN == "BPEPRATPCAP" then
												return 13;
											else
												return 0;
											end
										else
											return 0.5;
										end
									else
										return 39;
									end
								elseif SN > "BPEPRATPCAPR" then
									if SN < "BRATHIGH" then
										if SN > "BPET" then
											if SN == "BRATCRITMAGN" then
												if Lm <= 50 then
													return LinFmod(1,700,7000,1,50,L);
												elseif Lm <= 60 then
													return LinFmod(1,7000,10500,50,60,L);
												elseif Lm <= 65 then
													return LinFmod(1,10500,14000,60,65,L);
												elseif Lm <= 75 then
													return LinFmod(1,14000,21000,65,75,L);
												elseif Lm <= 85 then
													return LinFmod(1,21000,31500,75,85,L);
												elseif Lm <= 95 then
													return LinFmod(1,31500,46000,85,95,L);
												elseif Lm <= 100 then
													return LinFmod(1,46000,64000,95,100,L);
												elseif Lm <= 105 then
													return LinFmod(1,64000,85000,100,105,L);
												elseif Lm <= 115 then
													return LinFmod(1,94000,128000,106,115,L);
												elseif Lm <= 120 then
													return LinFmod(1,147000,160000,116,120,L);
												elseif Lm <= 130 then
													return LinFmod(1,184000,240000,121,130,L);
												elseif Lm <= 140 then
													return LinFmod(1,276000,480000,131,140,L);
												else
													return LinFmod(1,552000,960000,141,150,L);
												end
											else
												return 0;
											end
										elseif SN == "BPET" then
											return StatLinInter("PntMPBPE","TraitProg","ProgBBPE","",L,N,0);
										else
											return 0;
										end
									elseif SN > "BRATHIGH" then
										if SN < "BRATMEDIUM" then
											if SN == "BRATLOW" then
												if Lm <= 50 then
													return LinFmod(1,200,2000,1,50,L);
												elseif Lm <= 60 then
													return LinFmod(1,2000,3000,50,60,L);
												elseif Lm <= 65 then
													return LinFmod(1,3000,4000,60,65,L);
												elseif Lm <= 75 then
													return LinFmod(1,4000,6000,65,75,L);
												elseif Lm <= 85 then
													return LinFmod(1,6000,9000,75,85,L);
												elseif Lm <= 95 then
													return LinFmod(1,9000,13000,85,95,L);
												elseif Lm <= 100 then
													return LinFmod(1,13000,18100,95,100,L);
												elseif Lm <= 105 then
													return LinFmod(1,18100,24100,100,105,L);
												elseif Lm <= 115 then
													return LinFmod(1,26500,36000,106,115,L);
												elseif Lm <= 120 then
													return LinFmod(1,41000,45000,116,120,L);
												elseif Lm <= 130 then
													return LinFmod(1,52000,68000,121,130,L);
												elseif Lm <= 140 then
													return LinFmod(1,78000,136000,131,140,L);
												else
													return LinFmod(1,156000,272000,141,150,L);
												end
											else
												return 0;
											end
										elseif SN > "BRATMEDIUM" then
											if SN == "BRATMITHEAVY" then
												return CalcStat("BRatLow",L);
											else
												return 0;
											end
										else
											if Lm <= 50 then
												return LinFmod(1,300,3000,1,50,L);
											elseif Lm <= 60 then
												return LinFmod(1,3000,4500,50,60,L);
											elseif Lm <= 65 then
												return LinFmod(1,4500,6000,60,65,L);
											elseif Lm <= 75 then
												return LinFmod(1,6000,9000,65,75,L);
											elseif Lm <= 85 then
												return LinFmod(1,9000,13500,75,85,L);
											elseif Lm <= 95 then
												return LinFmod(1,13500,19500,85,95,L);
											elseif Lm <= 100 then
												return LinFmod(1,19500,27100,95,100,L);
											elseif Lm <= 105 then
												return LinFmod(1,27100,36000,100,105,L);
											elseif Lm <= 115 then
												return LinFmod(1,40000,54000,106,115,L);
											elseif Lm <= 120 then
												return LinFmod(1,62000,68000,116,120,L);
											elseif Lm <= 130 then
												return LinFmod(1,78000,102000,121,130,L);
											elseif Lm <= 140 then
												return LinFmod(1,117000,204000,131,140,L);
											else
												return LinFmod(1,235000,410000,141,150,L);
											end
										end
									else
										if Lm <= 50 then
											return LinFmod(1,400,4000,1,50,L);
										elseif Lm <= 60 then
											return LinFmod(1,4000,6000,50,60,L);
										elseif Lm <= 65 then
											return LinFmod(1,6000,8000,60,65,L);
										elseif Lm <= 75 then
											return LinFmod(1,8000,12000,65,75,L);
										elseif Lm <= 85 then
											return LinFmod(1,12000,18000,75,85,L);
										elseif Lm <= 95 then
											return LinFmod(1,18000,26000,85,95,L);
										elseif Lm <= 100 then
											return LinFmod(1,26000,36000,95,100,L);
										elseif Lm <= 105 then
											return LinFmod(1,36000,48000,100,105,L);
										elseif Lm <= 115 then
											return LinFmod(1,53000,72000,106,115,L);
										elseif Lm <= 120 then
											return LinFmod(1,83000,90000,116,120,L);
										elseif Lm <= 130 then
											return LinFmod(1,104000,135000,121,130,L);
										elseif Lm <= 140 then
											return LinFmod(1,155000,270000,131,140,L);
										else
											return LinFmod(1,311000,540000,141,150,L);
										end
									end
								else
									return CalcStat("BPEPRatPB",L)*CalcStat("BPEPRatPC",L);
								end
							else
								return 0;
							end
						else
							return CalcStat("BeoThickHideVitality",L);
						end
					elseif SN > "BRATMITLIGHT" then
						if SN < "BRAWLERCDFATETOTACMIT" then
							if SN < "BRAWLERCDBASEICPR" then
								if SN < "BRAWLERCDARMOURTOOFMIT" then
									if SN < "BRATPROGB" then
										if SN > "BRATMITMEDIUM" then
											if SN == "BRATPARTBPE" then
												if Lm <= 50 then
													return LinFmod(1,350,3500,1,50,L);
												elseif Lm <= 60 then
													return LinFmod(1,3500,5300,50,60,L);
												elseif Lm <= 65 then
													return LinFmod(1,5300,7100,60,65,L);
												elseif Lm <= 75 then
													return LinFmod(1,7100,10700,65,75,L);
												elseif Lm <= 85 then
													return LinFmod(1,10700,16100,75,85,L);
												elseif Lm <= 95 then
													return LinFmod(1,16100,23300,85,95,L);
												elseif Lm <= 100 then
													return LinFmod(1,23300,32000,95,100,L);
												elseif Lm <= 105 then
													return LinFmod(1,32000,43000,100,105,L);
												elseif Lm <= 115 then
													return LinFmod(1,47000,65000,106,115,L);
												elseif Lm <= 120 then
													return LinFmod(1,75000,81000,116,120,L);
												elseif Lm <= 130 then
													return LinFmod(1,93000,122000,121,130,L);
												elseif Lm <= 140 then
													return LinFmod(1,140000,244000,131,140,L);
												else
													return LinFmod(1,281000,488000,141,150,L);
												end
											else
												return 0;
											end
										elseif SN == "BRATMITMEDIUM" then
											if Lm <= 50 then
												return LinFmod(1,144,1670,1,50,L);
											elseif Lm <= 60 then
												return LinFmod(1,1670,2500,50,60,L);
											elseif Lm <= 65 then
												return LinFmod(1,2500,3300,60,65,L);
											elseif Lm <= 75 then
												return LinFmod(1,3300,5000,65,75,L);
											elseif Lm <= 85 then
												return LinFmod(1,5000,7500,75,85,L);
											elseif Lm <= 95 then
												return LinFmod(1,7500,10800,85,95,L);
											elseif Lm <= 100 then
												return LinFmod(1,10800,15100,95,100,L);
											elseif Lm <= 105 then
												return LinFmod(1,15100,20100,100,105,L);
											elseif Lm <= 115 then
												return LinFmod(1,22100,30000,106,115,L);
											elseif Lm <= 120 then
												return LinFmod(1,34000,37000,116,120,L);
											elseif Lm <= 130 then
												return LinFmod(1,43000,57000,121,130,L);
											elseif Lm <= 140 then
												return LinFmod(1,65000,113000,131,140,L);
											else
												return LinFmod(1,130000,227000,141,150,L);
											end
										else
											return 0;
										end
									elseif SN > "BRATPROGB" then
										if SN < "BRAWLERCDAGILITYTOEVADE" then
											if SN == "BRATROUNDED" then
												if Lm <= 50 then
													return RoundDbl(CalcStat(C,L));
												elseif Lm <= 105 then
													return RoundDbl(CalcStat(C,L),-1);
												elseif Lm <= 115 then
													return RoundDbl(CalcStat(C,L),-2);
												elseif Lm <= 130 then
													return RoundDbl(CalcStat(C,L),-1);
												else
													return RoundDbl(CalcStat(C,L),-2);
												end
											else
												return 0;
											end
										elseif SN > "BRAWLERCDAGILITYTOEVADE" then
											if SN == "BRAWLERCDAGILITYTOPARRY" then
												return 2;
											else
												return 0;
											end
										else
											return 3;
										end
									else
										if Lm <= 50 then
											return RoundDbl(CalcStat(C,L));
										else
											return CalcStat(C,L);
										end
									end
								elseif SN > "BRAWLERCDARMOURTOOFMIT" then
									if SN < "BRAWLERCDARMOURTYPE" then
										if SN > "BRAWLERCDARMOURTOPHYMIT" then
											if SN == "BRAWLERCDARMOURTOTACMIT" then
												return 0.2;
											else
												return 0;
											end
										elseif SN == "BRAWLERCDARMOURTOPHYMIT" then
											return 1;
										else
											return 0;
										end
									elseif SN > "BRAWLERCDARMOURTYPE" then
										if SN < "BRAWLERCDBASEFATE" then
											if SN == "BRAWLERCDBASEAGILITY" then
												return CalcStat("ClassBaseAgilityM",L);
											else
												return 0;
											end
										elseif SN > "BRAWLERCDBASEFATE" then
											if SN == "BRAWLERCDBASEICMR" then
												return CalcStat("ClassBaseICMRL",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseFate",L);
										end
									else
										return 3;
									end
								else
									return 0.2;
								end
							elseif SN > "BRAWLERCDBASEICPR" then
								if SN < "BRAWLERCDBASEWILL" then
									if SN < "BRAWLERCDBASENCMR" then
										if SN > "BRAWLERCDBASEMIGHT" then
											if SN == "BRAWLERCDBASEMORALE" then
												return CalcStat("ClassBaseMorale",L);
											else
												return 0;
											end
										elseif SN == "BRAWLERCDBASEMIGHT" then
											return CalcStat("ClassBaseMightH",L);
										else
											return 0;
										end
									elseif SN > "BRAWLERCDBASENCMR" then
										if SN < "BRAWLERCDBASEPOWER" then
											if SN == "BRAWLERCDBASENCPR" then
												return CalcStat("ClassBaseNCPR",L);
											else
												return 0;
											end
										elseif SN > "BRAWLERCDBASEPOWER" then
											if SN == "BRAWLERCDBASEVITALITY" then
												return CalcStat("ClassBaseVitality",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBasePower",L);
										end
									else
										return CalcStat("ClassBaseNCMRL",L);
									end
								elseif SN > "BRAWLERCDBASEWILL" then
									if SN < "BRAWLERCDFATETOICMR" then
										if SN > "BRAWLERCDFATETOCRITHIT" then
											if SN == "BRAWLERCDFATETOFINESSE" then
												return 0.5;
											else
												return 0;
											end
										elseif SN == "BRAWLERCDFATETOCRITHIT" then
											return 1.5;
										else
											return 0;
										end
									elseif SN > "BRAWLERCDFATETOICMR" then
										if SN < "BRAWLERCDFATETOPOWER" then
											if SN == "BRAWLERCDFATETONCPR" then
												return 0.05;
											else
												return 0;
											end
										elseif SN > "BRAWLERCDFATETOPOWER" then
											if SN == "BRAWLERCDFATETORESIST" then
												return 0.5;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return 0.025;
									end
								else
									return CalcStat("ClassBaseWillL",L);
								end
							else
								return CalcStat("ClassBaseICPR",L);
							end
						elseif SN > "BRAWLERCDFATETOTACMIT" then
							if SN < "BRGALLINFINESSE" then
								if SN < "BRAWLERCDTACMASTOOUTHEAL" then
									if SN < "BRAWLERCDMIGHTTOFINESSE" then
										if SN > "BRAWLERCDHASPOWER" then
											if SN == "BRAWLERCDMIGHTTOEVADE" then
												return 3;
											else
												return 0;
											end
										elseif SN == "BRAWLERCDHASPOWER" then
											return 1;
										else
											return 0;
										end
									elseif SN > "BRAWLERCDMIGHTTOFINESSE" then
										if SN < "BRAWLERCDMIGHTTOPHYMAS" then
											if SN == "BRAWLERCDMIGHTTOPARRY" then
												return 2;
											else
												return 0;
											end
										elseif SN > "BRAWLERCDMIGHTTOPHYMAS" then
											if SN == "BRAWLERCDPHYMITTOOFMIT" then
												return 1;
											else
												return 0;
											end
										else
											return 3;
										end
									else
										return 1;
									end
								elseif SN > "BRAWLERCDTACMASTOOUTHEAL" then
									if SN < "BRAWLERCDVITALITYTORESIST" then
										if SN > "BRAWLERCDVITALITYTOMORALE" then
											if SN == "BRAWLERCDVITALITYTONCMR" then
												return 0.12;
											else
												return 0;
											end
										elseif SN == "BRAWLERCDVITALITYTOMORALE" then
											return 5;
										else
											return 0;
										end
									elseif SN > "BRAWLERCDVITALITYTORESIST" then
										if SN < "BRAWLERCDWILLTOTACMAS" then
											if SN == "BRAWLERCDWILLTORESIST" then
												return 1;
											else
												return 0;
											end
										elseif SN > "BRAWLERCDWILLTOTACMAS" then
											if SN == "BRAWLERCDWILLTOTACMIT" then
												return 2;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return 0.5;
									end
								else
									return 1;
								end
							elseif SN > "BRGALLINFINESSE" then
								if SN < "BRWAGGPOSTUREPHYMIT" then
									if SN < "BRGREVWEAKNFINESSE" then
										if SN > "BRGALLINONEXPFINESSE" then
											if SN == "BRGREVWEAKNCRITDEF" then
												return -CalcStat("CritDefT",L,0.4);
											else
												return 0;
											end
										elseif SN == "BRGALLINONEXPFINESSE" then
											return -CalcStat("Finesse",L,2);
										else
											return 0;
										end
									elseif SN > "BRGREVWEAKNFINESSE" then
										if SN < "BRGTRICKCNTDEFBPE" then
											if SN == "BRGREVWEAKNRESIST" then
												return -CalcStat("ResistT",L,0.4);
											else
												return 0;
											end
										elseif SN > "BRGTRICKCNTDEFBPE" then
											if SN == "BRGTRICKCNTDEFCRITDEF" then
												return -CalcStat("CritDefT",L,0.8);
											else
												return 0;
											end
										else
											return -CalcStat("BPET",L,1.2);
										end
									else
										return -CalcStat("FinesseT",L,0.4);
									end
								elseif SN > "BRWAGGPOSTUREPHYMIT" then
									if SN < "BRWMAELSTROMMIGHT" then
										if SN < "BRWINNSTRCLEVTECHFINESSE" then
											if SN == "BRWDEFPOSTUREPHYMAS" then
												return -CalcStat("PhyMasT",L,4);
											else
												return 0;
											end
										elseif SN > "BRWINNSTRCLEVTECHFINESSE" then
											if SN == "BRWINNSTRPRECISIONCRITHIT" then
												return CalcStat("CritHitT",L,CalcStat("Trait13510Choice",N)*0.2);
											else
												return 0;
											end
										else
											return CalcStat("FinesseT",L,CalcStat("Trait13510Choice",N)*0.2);
										end
									elseif SN > "BRWMAELSTROMMIGHT" then
										if SN < "BRWRETINTENSITYCRITHIT" then
											if SN == "BRWMIGHTINCREASE" then
												return CalcStat("MightT",L,CalcStat("Trait567810Choice",N)*0.4);
											else
												return 0;
											end
										elseif SN > "BRWRETINTENSITYCRITHIT" then
											if SN == "BRWRETPRECISIONFINESSE" then
												return CalcStat("FinesseT",L,CalcStat("Trait234Choice",N));
											else
												return 0;
											end
										else
											return CalcStat("CritHitT",L,CalcStat("Trait234Choice",N));
										end
									else
										return CalcStat("MightT",L,2);
									end
								else
									return -CalcStat("PhyMitT",L,3);
								end
							else
								return CalcStat("Finesse",L,2);
							end
						else
							return 0.5;
						end
					else
						if Lm <= 50 then
							return LinFmod(1,105,1330,1,50,L);
						elseif Lm <= 60 then
							return LinFmod(1,1330,2000,50,60,L);
						elseif Lm <= 65 then
							return LinFmod(1,2000,2660,60,65,L);
						elseif Lm <= 75 then
							return LinFmod(1,2660,4000,65,75,L);
						elseif Lm <= 85 then
							return LinFmod(1,4000,6000,75,85,L);
						elseif Lm <= 95 then
							return LinFmod(1,6000,8700,85,95,L);
						elseif Lm <= 100 then
							return LinFmod(1,8700,12100,95,100,L);
						elseif Lm <= 105 then
							return LinFmod(1,12100,16100,100,105,L);
						elseif Lm <= 115 then
							return LinFmod(1,17600,24000,106,115,L);
						elseif Lm <= 120 then
							return LinFmod(1,27300,30000,116,120,L);
						elseif Lm <= 130 then
							return LinFmod(1,35000,45000,121,130,L);
						elseif Lm <= 140 then
							return LinFmod(1,52000,91000,131,140,L);
						else
							return LinFmod(1,104000,181000,141,150,L);
						end
					end
				else
					return CalcStat("ClassBaseVitality",L);
				end
			elseif SN > "BRWSHAREISBALANCEFINESSE" then
				if SN < "CHAMPIONCDPHYMITTOOFMIT" then
					if SN < "CAPTAINCDBASENCMR" then
						if SN < "BURGLARCDFATETOPOWER" then
							if SN < "BURGLARCDBASEFATE" then
								if SN < "BURGLARCDAGILITYTOPARRY" then
									if SN < "BRWTACMIT" then
										if SN > "BRWSHAREISHEAVYCRITHIT" then
											if SN == "BRWSHATTFISTARMOUR" then
												return -CalcStat("ArmourT",L,1.6);
											else
												return 0;
											end
										elseif SN == "BRWSHAREISHEAVYCRITHIT" then
											return CalcStat("BrwInnStrPrecisionCritHit",L,3);
										else
											return 0;
										end
									elseif SN > "BRWTACMIT" then
										if SN < "BURGLARCDAGILITYTOCRITHIT" then
											if SN == "BRWVITALITYINCREASE" then
												return CalcStat("VitalityT",L,CalcStat("Trait567810Choice",N)*0.4);
											else
												return 0;
											end
										elseif SN > "BURGLARCDAGILITYTOCRITHIT" then
											if SN == "BURGLARCDAGILITYTOEVADE" then
												return 3;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return CalcStat("TacMitT",L,CalcStat("Trait12345Choice",N)*0.4);
									end
								elseif SN > "BURGLARCDAGILITYTOPARRY" then
									if SN < "BURGLARCDARMOURTOPHYMIT" then
										if SN > "BURGLARCDAGILITYTOPHYMAS" then
											if SN == "BURGLARCDARMOURTOOFMIT" then
												return 0.2;
											else
												return 0;
											end
										elseif SN == "BURGLARCDAGILITYTOPHYMAS" then
											return 3;
										else
											return 0;
										end
									elseif SN > "BURGLARCDARMOURTOPHYMIT" then
										if SN < "BURGLARCDARMOURTYPE" then
											if SN == "BURGLARCDARMOURTOTACMIT" then
												return 0.2;
											else
												return 0;
											end
										elseif SN > "BURGLARCDARMOURTYPE" then
											if SN == "BURGLARCDBASEAGILITY" then
												return CalcStat("ClassBaseAgilityH",L);
											else
												return 0;
											end
										else
											return 2;
										end
									else
										return 1;
									end
								else
									return 2;
								end
							elseif SN > "BURGLARCDBASEFATE" then
								if SN < "BURGLARCDBASEPOWER" then
									if SN < "BURGLARCDBASEMIGHT" then
										if SN > "BURGLARCDBASEICMR" then
											if SN == "BURGLARCDBASEICPR" then
												return CalcStat("ClassBaseICPR",L);
											else
												return 0;
											end
										elseif SN == "BURGLARCDBASEICMR" then
											return CalcStat("ClassBaseICMRL",L);
										else
											return 0;
										end
									elseif SN > "BURGLARCDBASEMIGHT" then
										if SN < "BURGLARCDBASENCMR" then
											if SN == "BURGLARCDBASEMORALE" then
												return CalcStat("ClassBaseMorale",L);
											else
												return 0;
											end
										elseif SN > "BURGLARCDBASENCMR" then
											if SN == "BURGLARCDBASENCPR" then
												return CalcStat("ClassBaseNCPR",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseNCMRL",L);
										end
									else
										return CalcStat("ClassBaseMightM",L);
									end
								elseif SN > "BURGLARCDBASEPOWER" then
									if SN < "BURGLARCDFATETOCRITHIT" then
										if SN > "BURGLARCDBASEVITALITY" then
											if SN == "BURGLARCDBASEWILL" then
												return CalcStat("ClassBaseWillL",L);
											else
												return 0;
											end
										elseif SN == "BURGLARCDBASEVITALITY" then
											return CalcStat("ClassBaseVitality",L);
										else
											return 0;
										end
									elseif SN > "BURGLARCDFATETOCRITHIT" then
										if SN < "BURGLARCDFATETOICMR" then
											if SN == "BURGLARCDFATETOFINESSE" then
												return 0;
											else
												return 0;
											end
										elseif SN > "BURGLARCDFATETOICMR" then
											if SN == "BURGLARCDFATETONCPR" then
												return 0.05;
											else
												return 0;
											end
										else
											return 0.025;
										end
									else
										return 0;
									end
								else
									return CalcStat("ClassBasePower",L);
								end
							else
								return CalcStat("ClassBaseFate",L);
							end
						elseif SN > "BURGLARCDFATETOPOWER" then
							if SN < "C" then
								if SN < "BURGLARCDTACMASTOOUTHEAL" then
									if SN < "BURGLARCDHASPOWER" then
										if SN > "BURGLARCDFATETORESIST" then
											if SN == "BURGLARCDFATETOTACMIT" then
												return 0;
											else
												return 0;
											end
										elseif SN == "BURGLARCDFATETORESIST" then
											return 0;
										else
											return 0;
										end
									elseif SN > "BURGLARCDHASPOWER" then
										if SN < "BURGLARCDMIGHTTOPARRY" then
											if SN == "BURGLARCDMIGHTTOBLOCK" then
												return 3;
											else
												return 0;
											end
										elseif SN > "BURGLARCDMIGHTTOPARRY" then
											if SN == "BURGLARCDPHYMITTOOFMIT" then
												return 1;
											else
												return 0;
											end
										else
											return 2;
										end
									else
										return 1;
									end
								elseif SN > "BURGLARCDTACMASTOOUTHEAL" then
									if SN < "BURGLARCDVITALITYTORESIST" then
										if SN > "BURGLARCDVITALITYTOMORALE" then
											if SN == "BURGLARCDVITALITYTONCMR" then
												return 0.12;
											else
												return 0;
											end
										elseif SN == "BURGLARCDVITALITYTOMORALE" then
											return 4.5;
										else
											return 0;
										end
									elseif SN > "BURGLARCDVITALITYTORESIST" then
										if SN < "BURGLARCDWILLTOTACMAS" then
											if SN == "BURGLARCDWILLTORESIST" then
												return 2;
											else
												return 0;
											end
										elseif SN > "BURGLARCDWILLTOTACMAS" then
											if SN == "BURGLARCDWILLTOTACMIT" then
												return 1;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return 0;
									end
								else
									return 1;
								end
							elseif SN > "C" then
								if SN < "CAPTAINCDARMOURTYPE" then
									if SN < "CAPTAINCDAGILITYTOPARRY" then
										if SN > "CAPTAINCDAGILITYTOCRITHIT" then
											if SN == "CAPTAINCDAGILITYTOEVADE" then
												return 3;
											else
												return 0;
											end
										elseif SN == "CAPTAINCDAGILITYTOCRITHIT" then
											return 1;
										else
											return 0;
										end
									elseif SN > "CAPTAINCDAGILITYTOPARRY" then
										if SN < "CAPTAINCDARMOURTOPHYMIT" then
											if SN == "CAPTAINCDARMOURTOOFMIT" then
												return 0.2;
											else
												return 0;
											end
										elseif SN > "CAPTAINCDARMOURTOPHYMIT" then
											if SN == "CAPTAINCDARMOURTOTACMIT" then
												return 0.2;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return 2;
									end
								elseif SN > "CAPTAINCDARMOURTYPE" then
									if SN < "CAPTAINCDBASEICMR" then
										if SN > "CAPTAINCDBASEAGILITY" then
											if SN == "CAPTAINCDBASEFATE" then
												return CalcStat("ClassBaseFate",L);
											else
												return 0;
											end
										elseif SN == "CAPTAINCDBASEAGILITY" then
											return CalcStat("ClassBaseAgilityL",L);
										else
											return 0;
										end
									elseif SN > "CAPTAINCDBASEICMR" then
										if SN < "CAPTAINCDBASEMIGHT" then
											if SN == "CAPTAINCDBASEICPR" then
												return CalcStat("ClassBaseICPR",L);
											else
												return 0;
											end
										elseif SN > "CAPTAINCDBASEMIGHT" then
											if SN == "CAPTAINCDBASEMORALE" then
												return CalcStat("ClassBaseMorale",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseMightH",L);
										end
									else
										return CalcStat("ClassBaseICMRM",L);
									end
								else
									return 3;
								end
							else
								return C;
							end
						else
							return 1;
						end
					elseif SN > "CAPTAINCDBASENCMR" then
						if SN < "CHAMPIONCDARMOURTOOFMIT" then
							if SN < "CAPTAINCDMIGHTTOPARRY" then
								if SN < "CAPTAINCDFATETOFINESSE" then
									if SN < "CAPTAINCDBASEVITALITY" then
										if SN > "CAPTAINCDBASENCPR" then
											if SN == "CAPTAINCDBASEPOWER" then
												return CalcStat("ClassBasePower",L);
											else
												return 0;
											end
										elseif SN == "CAPTAINCDBASENCPR" then
											return CalcStat("ClassBaseNCPR",L);
										else
											return 0;
										end
									elseif SN > "CAPTAINCDBASEVITALITY" then
										if SN < "CAPTAINCDCANBLOCK" then
											if SN == "CAPTAINCDBASEWILL" then
												return CalcStat("ClassBaseWillM",L);
											else
												return 0;
											end
										elseif SN > "CAPTAINCDCANBLOCK" then
											if SN == "CAPTAINCDFATETOCRITHIT" then
												return 1.5;
											else
												return 0;
											end
										else
											if Lm <= 14 then
												return 0;
											else
												return 1;
											end
										end
									else
										return CalcStat("ClassBaseVitality",L);
									end
								elseif SN > "CAPTAINCDFATETOFINESSE" then
									if SN < "CAPTAINCDFATETOPOWER" then
										if SN > "CAPTAINCDFATETOICMR" then
											if SN == "CAPTAINCDFATETONCPR" then
												return 0.05;
											else
												return 0;
											end
										elseif SN == "CAPTAINCDFATETOICMR" then
											return 0.025;
										else
											return 0;
										end
									elseif SN > "CAPTAINCDFATETOPOWER" then
										if SN < "CAPTAINCDHASPOWER" then
											if SN == "CAPTAINCDFATETOTACMIT" then
												return 0.5;
											else
												return 0;
											end
										elseif SN > "CAPTAINCDHASPOWER" then
											if SN == "CAPTAINCDMIGHTTOBLOCK" then
												return 3;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return 1;
									end
								else
									return 0.5;
								end
							elseif SN > "CAPTAINCDMIGHTTOPARRY" then
								if SN < "CAPTAINCDVITALITYTORESIST" then
									if SN < "CAPTAINCDPHYMITTOOFMIT" then
										if SN > "CAPTAINCDMIGHTTOPHYMAS" then
											if SN == "CAPTAINCDMIGHTTOTACMAS" then
												return 2.5;
											else
												return 0;
											end
										elseif SN == "CAPTAINCDMIGHTTOPHYMAS" then
											return 2.5;
										else
											return 0;
										end
									elseif SN > "CAPTAINCDPHYMITTOOFMIT" then
										if SN < "CAPTAINCDVITALITYTOMORALE" then
											if SN == "CAPTAINCDTACMASTOOUTHEAL" then
												return 1;
											else
												return 0;
											end
										elseif SN > "CAPTAINCDVITALITYTOMORALE" then
											if SN == "CAPTAINCDVITALITYTONCMR" then
												return 0.12;
											else
												return 0;
											end
										else
											return 4.5;
										end
									else
										return 1;
									end
								elseif SN > "CAPTAINCDVITALITYTORESIST" then
									if SN < "CATMINTBEARARMOUR" then
										if SN > "CAPTAINCDWILLTORESIST" then
											if SN == "CAPTAINCDWILLTOTACMIT" then
												return 1;
											else
												return 0;
											end
										elseif SN == "CAPTAINCDWILLTORESIST" then
											return 2;
										else
											return 0;
										end
									elseif SN > "CATMINTBEARARMOUR" then
										if SN < "CHAMPIONCDAGILITYTOEVADE" then
											if SN == "CHAMPIONCDAGILITYTOCRITHIT" then
												return 1;
											else
												return 0;
											end
										elseif SN > "CHAMPIONCDAGILITYTOEVADE" then
											if SN == "CHAMPIONCDAGILITYTOPARRY" then
												return 2;
											else
												return 0;
											end
										else
											return 3;
										end
									else
										return CalcStat("LMCatmintBearArmour",L);
									end
								else
									return 1;
								end
							else
								return 2;
							end
						elseif SN > "CHAMPIONCDARMOURTOOFMIT" then
							if SN < "CHAMPIONCDBASEWILL" then
								if SN < "CHAMPIONCDBASEICPR" then
									if SN < "CHAMPIONCDARMOURTYPE" then
										if SN > "CHAMPIONCDARMOURTOPHYMIT" then
											if SN == "CHAMPIONCDARMOURTOTACMIT" then
												return 0.2;
											else
												return 0;
											end
										elseif SN == "CHAMPIONCDARMOURTOPHYMIT" then
											return 1;
										else
											return 0;
										end
									elseif SN > "CHAMPIONCDARMOURTYPE" then
										if SN < "CHAMPIONCDBASEFATE" then
											if SN == "CHAMPIONCDBASEAGILITY" then
												return CalcStat("ClassBaseAgilityM",L);
											else
												return 0;
											end
										elseif SN > "CHAMPIONCDBASEFATE" then
											if SN == "CHAMPIONCDBASEICMR" then
												return CalcStat("ClassBaseICMRH",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseFate",L);
										end
									else
										return 3;
									end
								elseif SN > "CHAMPIONCDBASEICPR" then
									if SN < "CHAMPIONCDBASENCMR" then
										if SN > "CHAMPIONCDBASEMIGHT" then
											if SN == "CHAMPIONCDBASEMORALE" then
												return CalcStat("ClassBaseMorale",L);
											else
												return 0;
											end
										elseif SN == "CHAMPIONCDBASEMIGHT" then
											return CalcStat("ClassBaseMightH",L);
										else
											return 0;
										end
									elseif SN > "CHAMPIONCDBASENCMR" then
										if SN < "CHAMPIONCDBASEPOWER" then
											if SN == "CHAMPIONCDBASENCPR" then
												return CalcStat("ClassBaseNCPR",L);
											else
												return 0;
											end
										elseif SN > "CHAMPIONCDBASEPOWER" then
											if SN == "CHAMPIONCDBASEVITALITY" then
												return CalcStat("ClassBaseVitality",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBasePower",L);
										end
									else
										return CalcStat("ClassBaseNCMRH",L);
									end
								else
									return CalcStat("ClassBaseICPR",L);
								end
							elseif SN > "CHAMPIONCDBASEWILL" then
								if SN < "CHAMPIONCDFATETORESIST" then
									if SN < "CHAMPIONCDFATETOFINESSE" then
										if SN > "CHAMPIONCDCANBLOCK" then
											if SN == "CHAMPIONCDFATETOCRITHIT" then
												return 1.5;
											else
												return 0;
											end
										elseif SN == "CHAMPIONCDCANBLOCK" then
											if Lm <= 9 then
												return 0;
											else
												return 1;
											end
										else
											return 0;
										end
									elseif SN > "CHAMPIONCDFATETOFINESSE" then
										if SN < "CHAMPIONCDFATETONCPR" then
											if SN == "CHAMPIONCDFATETOICMR" then
												return 0.025;
											else
												return 0;
											end
										elseif SN > "CHAMPIONCDFATETONCPR" then
											if SN == "CHAMPIONCDFATETOPOWER" then
												return 1;
											else
												return 0;
											end
										else
											return 0.05;
										end
									else
										return 0.5;
									end
								elseif SN > "CHAMPIONCDFATETORESIST" then
									if SN < "CHAMPIONCDMIGHTTOEVADE" then
										if SN < "CHAMPIONCDHASPOWER" then
											if SN == "CHAMPIONCDFATETOTACMIT" then
												return 0.5;
											else
												return 0;
											end
										elseif SN > "CHAMPIONCDHASPOWER" then
											if SN == "CHAMPIONCDMIGHTTOCRITHIT" then
												return 1;
											else
												return 0;
											end
										else
											return 1;
										end
									elseif SN > "CHAMPIONCDMIGHTTOEVADE" then
										if SN < "CHAMPIONCDMIGHTTOPHYMAS" then
											if SN == "CHAMPIONCDMIGHTTOPARRY" then
												return 2;
											else
												return 0;
											end
										elseif SN > "CHAMPIONCDMIGHTTOPHYMAS" then
											if SN == "CHAMPIONCDMIGHTTOPHYMIT" then
												return 1;
											else
												return 0;
											end
										else
											return 3;
										end
									else
										return 2;
									end
								else
									return 0.5;
								end
							else
								return CalcStat("ClassBaseWillL",L);
							end
						else
							return 0.2;
						end
					else
						return CalcStat("ClassBaseNCMRM",L);
					end
				elseif SN > "CHAMPIONCDPHYMITTOOFMIT" then
					if SN < "COMBATBASETACHPS" then
						if SN < "CLASSBASEICMRM" then
							if SN < "CHISELICPRL" then
								if SN < "CHAMPIONCDWILLTOTACMAS" then
									if SN < "CHAMPIONCDVITALITYTOMORALE" then
										if SN > "CHAMPIONCDTACMASTOOUTHEAL" then
											if SN == "CHAMPIONCDVITALITYTOBLOCK" then
												return 1;
											else
												return 0;
											end
										elseif SN == "CHAMPIONCDTACMASTOOUTHEAL" then
											return 1;
										else
											return 0;
										end
									elseif SN > "CHAMPIONCDVITALITYTOMORALE" then
										if SN < "CHAMPIONCDVITALITYTORESIST" then
											if SN == "CHAMPIONCDVITALITYTONCMR" then
												return 0.12;
											else
												return 0;
											end
										elseif SN > "CHAMPIONCDVITALITYTORESIST" then
											if SN == "CHAMPIONCDWILLTORESIST" then
												return 2;
											else
												return 0;
											end
										else
											return 0.5;
										end
									else
										return 4.5;
									end
								elseif SN > "CHAMPIONCDWILLTOTACMAS" then
									if SN < "CHISELCRITHITL" then
										if SN > "CHAMPIONCDWILLTOTACMIT" then
											if SN == "CHISELCRITHITH" then
												if Lm <= 105 then
													return RoundDbl(24.24*L);
												else
													return CalcStat("ProgExtHighLinExpRnd",L,CalcStat("ChiselCritHitH",105));
												end
											else
												return 0;
											end
										elseif SN == "CHAMPIONCDWILLTOTACMIT" then
											return 1;
										else
											return 0;
										end
									elseif SN > "CHISELCRITHITL" then
										if SN < "CHISELFINESSEL" then
											if SN == "CHISELFINESSEH" then
												if Lm <= 105 then
													return RoundDbl(8.08*L);
												else
													return CalcStat("ProgExtHighLinExpRnd",L,CalcStat("ChiselFinesseH",105));
												end
											else
												return 0;
											end
										elseif SN > "CHISELFINESSEL" then
											if SN == "CHISELICPRH" then
												if Lm <= 8 then
													return 0;
												elseif Lm <= 31 then
													return 1;
												elseif Lm <= 55 then
													return 2;
												elseif Lm <= 79 then
													return 3;
												elseif Lm <= 104 then
													return 4;
												else
													return 5;
												end
											else
												return 0;
											end
										else
											if Lm <= 105 then
												return RoundDbl(4.04*L);
											else
												return CalcStat("ProgExtHighLinExpRnd",L,CalcStat("ChiselFinesseL",105));
											end
										end
									else
										if Lm <= 105 then
											return RoundDbl(16.16*L);
										else
											return CalcStat("ProgExtHighLinExpRnd",L,CalcStat("ChiselCritHitL",105));
										end
									end
								else
									return 1;
								end
							elseif SN > "CHISELICPRL" then
								if SN < "CHPUNBREAKTACMIT" then
									if SN < "CHPFINESSEINCREASE" then
										if SN > "CHP2HWPNBLOCK" then
											if SN == "CHPCONTRBURNICPR" then
												return CalcStat("ICPRT",L,0.4);
											else
												return 0;
											end
										elseif SN == "CHP2HWPNBLOCK" then
											return CalcStat("BlockT",L,4);
										else
											return 0;
										end
									elseif SN > "CHPFINESSEINCREASE" then
										if SN < "CHPMIGHTINCREASE" then
											if SN == "CHPFLURRYINCRCRITHIT" then
												if Lm <= 80 then
													return RoundDbl(16.16*L);
												else
													return CalcStat("ChpFlurryIncrCritHit",80);
												end
											else
												return 0;
											end
										elseif SN > "CHPMIGHTINCREASE" then
											if SN == "CHPSTALWBLADEVITALITY" then
												return CalcStat("VitalityT",L,CalcStat("Trait567810Choice",N)*0.4);
											else
												return 0;
											end
										else
											return CalcStat("MightT",L,CalcStat("Trait567810Choice",N)*0.4);
										end
									else
										return CalcStat("FinesseT",L,CalcStat("Trait12345Choice",N)*0.4);
									end
								elseif SN > "CHPUNBREAKTACMIT" then
									if SN < "CLASSBASEAGILITYM" then
										if SN > "CLASSBASEAGILITYH" then
											if SN == "CLASSBASEAGILITYL" then
												return CalcStat("BaseAgility",L,0.5);
											else
												return 0;
											end
										elseif SN == "CLASSBASEAGILITYH" then
											return CalcStat("BaseAgility",L,1.5);
										else
											return 0;
										end
									elseif SN > "CLASSBASEAGILITYM" then
										if SN < "CLASSBASEICMRH" then
											if SN == "CLASSBASEFATE" then
												return CalcStat("BaseFate",L,0.70001);
											else
												return 0;
											end
										elseif SN > "CLASSBASEICMRH" then
											if SN == "CLASSBASEICMRL" then
												return 0.15;
											else
												return 0;
											end
										else
											return 0.2;
										end
									else
										return CalcStat("BaseAgility",L,1.0);
									end
								else
									return CalcStat("TacMitT",L,0.4);
								end
							else
								if Lm <= 10 then
									return 0;
								elseif Lm <= 40 then
									return 1;
								elseif Lm <= 70 then
									return 2;
								elseif Lm <= 100 then
									return 3;
								else
									return 4;
								end
							end
						elseif SN > "CLASSBASEICMRM" then
							if SN < "CLASSBASEVITALITY" then
								if SN < "CLASSBASENCMRH" then
									if SN < "CLASSBASEMIGHTH" then
										if SN > "CLASSBASEICPR" then
											if SN == "CLASSBASEICPRADJ" then
												if Lm <= 1 then
													return 1.5*N;
												elseif Lm <= 20 then
													return 1.1*N;
												else
													return N;
												end
											else
												return 0;
											end
										elseif SN == "CLASSBASEICPR" then
											return StatLinInter("PntMPClassBaseICPR","ClassBaseProgPowerRegen","ProgBICPR","ClassBaseICPRAdj",L,N,99);
										else
											return 0;
										end
									elseif SN > "CLASSBASEMIGHTH" then
										if SN < "CLASSBASEMIGHTM" then
											if SN == "CLASSBASEMIGHTL" then
												return CalcStat("BaseMight",L,0.5);
											else
												return 0;
											end
										elseif SN > "CLASSBASEMIGHTM" then
											if SN == "CLASSBASEMORALE" then
												return CalcStat("BaseMorale",L,10.0);
											else
												return 0;
											end
										else
											return CalcStat("BaseMight",L,1.0);
										end
									else
										return CalcStat("BaseMight",L,1.5);
									end
								elseif SN > "CLASSBASENCMRH" then
									if SN < "CLASSBASENCPR" then
										if SN > "CLASSBASENCMRL" then
											if SN == "CLASSBASENCMRM" then
												return 1;
											else
												return 0;
											end
										elseif SN == "CLASSBASENCMRL" then
											return 1;
										else
											return 0;
										end
									elseif SN > "CLASSBASENCPR" then
										if SN < "CLASSBASEPOWER" then
											if SN == "CLASSBASENCPRADJ" then
												if Lm <= 1 then
													return 1.5*N;
												elseif Lm <= 20 then
													return 1.1*N;
												else
													return N;
												end
											else
												return 0;
											end
										elseif SN > "CLASSBASEPOWER" then
											if SN == "CLASSBASEPROGPOWERREGEN" then
												return {{1,20,50,60,65,75,85,95,100,105,115,120,130,140,150},{1,20,50,60,65,75,85,95,100,105,115,120,130,140,150}};
											else
												return 0;
											end
										else
											return CalcStat("BasePower",L,1.0);
										end
									else
										return StatLinInter("PntMPClassBaseNCPR","ClassBaseProgPowerRegen","ProgBNCPR","ClassBaseNCPRAdj",L,N,99);
									end
								else
									return 2;
								end
							elseif SN > "CLASSBASEVITALITY" then
								if SN < "COMBATBASEH" then
									if SN < "CLASSBASEWILLM" then
										if SN > "CLASSBASEWILLH" then
											if SN == "CLASSBASEWILLL" then
												return CalcStat("BaseWill",L,0.5);
											else
												return 0;
											end
										elseif SN == "CLASSBASEWILLH" then
											return CalcStat("BaseWill",L,1.5);
										else
											return 0;
										end
									elseif SN > "CLASSBASEWILLM" then
										if SN < "COMBATBASE" then
											if SN == "CLOTHARMOUR" then
												if Lm <= 50 then
													return L;
												else
													return 50;
												end
											else
												return 0;
											end
										elseif SN > "COMBATBASE" then
											if SN == "COMBATBASECAT" then
												if Lm <= 0 then
													return 0;
												elseif Lm <= 1 then
													return CalcStat("CombatBaseH",N);
												else
													return CalcStat("CombatBaseL",N);
												end
											else
												return 0;
											end
										else
											return CalcStat("CombatBaseCat",WpnCodeIndex(C,1),L)*CalcStat("CombatBaseTypeMP",WpnCodeIndex(C,2))*CalcStat("CombatBaseQtyMPCat",WpnCodeIndex(C,1),WpnCodeIndex(C,3));
										end
									else
										return CalcStat("BaseWill",L,1.0);
									end
								elseif SN > "COMBATBASEH" then
									if SN < "COMBATBASELQTYMP" then
										if SN > "COMBATBASEHQTYMP" then
											if SN == "COMBATBASEL" then
												return 0.8*CalcStat("CombatBasePhyDPS",L);
											else
												return 0;
											end
										elseif SN == "COMBATBASEHQTYMP" then
											if Lm <= 0 then
												return 0;
											else
												return DataTableValue({1,1.02,1.04,1.08,1.12},L);
											end
										else
											return 0;
										end
									elseif SN > "COMBATBASELQTYMP" then
										if SN < "COMBATBASEQTYMPCAT" then
											if SN == "COMBATBASEPHYDPS" then
												if Lm <= 50 then
													return LinFmod(1,2,20,1,50,L);
												elseif Lm <= 60 then
													return LinFmod(1,20,26.6,50,60,L);
												elseif Lm <= 65 then
													return LinFmod(1,26.6,29.1,60,65,L);
												elseif Lm <= 75 then
													return LinFmod(1,29.1,39,65,75,L);
												elseif Lm <= 125 then
													return LinFmod(1,39,52,75,125,L);
												elseif Lm <= 175 then
													return LinFmod(1,52,69,125,175,L);
												elseif Lm <= 200 then
													return LinFmod(1,69,86,175,200,L);
												elseif Lm <= 222 then
													return LinFmod(1,86,108,200,222,L);
												elseif Lm <= 300 then
													return LinFmod(1,108,108,222,300,L);
												elseif Lm <= 350 then
													return LinFmod(1,119,144,301,350,L);
												elseif Lm <= 400 then
													return LinFmod(1,158,180,351,400,L);
												elseif Lm <= 450 then
													return LinFmod(1,198,239,401,450,L);
												elseif Lm <= 500 then
													return LinFmod(1,263,360,451,500,L);
												elseif Lm <= 550 then
													return LinFmod(1,400,540,501,550,L);
												elseif Lm <= 600 then
													return RoundDblDown(RoundDblUp(L/5.5)*25-1935,-1);
												elseif Lm <= 650 then
													return RoundDblDown(RoundDblUp((L-50)/5.5)*36.7-2811,-1);
												else
													return CalcStat("CombatBasePhyDPS",650);
												end
											else
												return 0;
											end
										elseif SN > "COMBATBASEQTYMPCAT" then
											if SN == "COMBATBASETACDPS" then
												if Lm <= 47 then
													return LinFmod(1,0.5,0.5,1,47,L);
												elseif Lm <= 50 then
													return LinFmod(1,0.5,0.8,47,50,L);
												elseif Lm <= 51 then
													return LinFmod(1,1,1,51,51,L);
												elseif Lm <= 60 then
													return LinFmod(1,1.32,6.6,52,60,L);
												elseif Lm <= 65 then
													return LinFmod(1,6.6,9.1,60,65,L);
												elseif Lm <= 75 then
													return LinFmod(1,9.1,19,65,75,L);
												elseif Lm <= 125 then
													return LinFmod(1,19,32,75,125,L);
												elseif Lm <= 175 then
													return LinFmod(1,32,49,125,175,L);
												elseif Lm <= 200 then
													return LinFmod(1,49,66,175,200,L);
												elseif Lm <= 222 then
													return LinFmod(1,66,88,200,222,L);
												elseif Lm <= 299 then
													return LinFmod(1,88,88,222,299,L);
												elseif Lm <= 349 then
													return LinFmod(1,99,124,300,349,L);
												elseif Lm <= 399 then
													return LinFmod(1,138,160,350,399,L);
												elseif Lm <= 449 then
													return LinFmod(1,178,219,400,449,L);
												elseif Lm <= 499 then
													return LinFmod(1,243,340,450,499,L);
												elseif Lm <= 549 then
													return LinFmod(1,380,520,500,549,L);
												elseif Lm <= 599 then
													return RoundDblDown(RoundDblUp((L+1)/5.5)*25-1955,-1);
												elseif Lm <= 649 then
													return RoundDblDown(RoundDblUp((L-49)/5.5)*36.7-2831,-1);
												else
													return CalcStat("CombatBaseTacDPS",649);
												end
											else
												return 0;
											end
										else
											if Lm <= 0 then
												return 0;
											elseif Lm <= 1 then
												return CalcStat("CombatBaseHQtyMP",N);
											else
												return CalcStat("CombatBaseLQtyMP",N);
											end
										end
									else
										return CalcStat("CombatBaseHQtyMP",L);
									end
								else
									return 1.0*CalcStat("CombatBasePhyDPS",L);
								end
							else
								return CalcStat("BaseVitality",L,1.5);
							end
						else
							return 0.175;
						end
					elseif SN > "COMBATBASETACHPS" then
						if SN < "CPTCOVVITALITY" then
							if SN < "COMBATDAMAGEMODPETSADJ" then
								if SN < "COMBATDAMAGEMODHEALTH" then
									if SN < "COMBATBASETACHPSNOCLASS" then
										if SN > "COMBATBASETACHPSBASE" then
											if SN == "COMBATBASETACHPSLVLTOILVL" then
												if Lm <= 75 then
													return LinFmod(1,1,75,1,75,L);
												elseif Lm <= 100 then
													return LinFmod(1,75,200,75,100,L);
												elseif Lm <= 104 then
													return RoundDbl(LinFmod(1,201.3,214.3,101,104,L));
												elseif Lm <= 105 then
													return 222;
												else
													return RoundDbl(CalcStat("LvlToILvl",L));
												end
											else
												return 0;
											end
										elseif SN == "COMBATBASETACHPSBASE" then
											if Lm <= 24 then
												return (-1/300)*L*L+(741739.1304347/3000000)*L+1.75608695652177;
											elseif Lm <= 49 then
												return -0.003725*L*L+0.255*L+1.812153556;
											elseif Lm <= 55 then
												return 0.5+5.659142856;
											elseif Lm <= 549 then
												return CalcStat("CommonTacHPS",L);
											elseif Lm <= 599 then
												return (RoundDblUp((4*L+3)/22)*378-RoundDblUp((L+7)/22))*0.175-6081.6;
											elseif Lm <= 649 then
												return (RoundDblUp((4*L+2)/22)*678-RoundDblUp((L+1)/22))*0.175-11734.1;
											else
												return CalcStat("CombatBaseTacHPSBase",649);
											end
										else
											return 0;
										end
									elseif SN > "COMBATBASETACHPSNOCLASS" then
										if SN < "COMBATDAMAGEMOD" then
											if SN == "COMBATBASETYPEMP" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({1,1.4,1.4},L);
												end
											else
												return 0;
											end
										elseif SN > "COMBATDAMAGEMOD" then
											if SN == "COMBATDAMAGEMODENERGY" then
												return StatLinInter("PntMPCombatDamageMod","TraitProgVital","ProgBEnergy","",L,N,2);
											else
												return 0;
											end
										else
											return StatLinInter("PntMPCombatDamageMod","TraitProgVital","ProgBCombatDamageMod","",L,N,2);
										end
									else
										return CalcStat("CombatBaseTacHPSBase",CalcStat("CombatBaseTacHPSLvlToILvl",L));
									end
								elseif SN > "COMBATDAMAGEMODHEALTH" then
									if SN < "COMBATDAMAGEMODHEALTHMEDIUM" then
										if SN > "COMBATDAMAGEMODHEALTHLOW" then
											if SN == "COMBATDAMAGEMODHEALTHLOWADJ" then
												if Lm <= 1 then
													return 0.144*N;
												elseif Lm <= 25 then
													return 0.324*N;
												elseif Lm <= 50 then
													return 0.576*N;
												else
													return 0.9*N;
												end
											else
												return 0;
											end
										elseif SN == "COMBATDAMAGEMODHEALTHLOW" then
											return StatLinInter("PntMPCombatDamageMod","TraitProgVital","ProgBHealth","CombatDamageModHealthLowAdj",L,N,99);
										else
											return 0;
										end
									elseif SN > "COMBATDAMAGEMODHEALTHMEDIUM" then
										if SN < "COMBATDAMAGEMODNPCS" then
											if SN == "COMBATDAMAGEMODHEALTHMEDIUMADJ" then
												if Lm <= 1 then
													return 0.36*N;
												elseif Lm <= 25 then
													return 0.54*N;
												elseif Lm <= 50 then
													return 0.72*N;
												else
													return 0.9*N;
												end
											else
												return 0;
											end
										elseif SN > "COMBATDAMAGEMODNPCS" then
											if SN == "COMBATDAMAGEMODPETS" then
												return StatLinInter("PntMPCombatDamageMod","TraitProgVital","ProgBCombatDamageMod","CombatDamageModPetsAdj",L,N,99);
											else
												return 0;
											end
										else
											return StatLinInter("PntMPCombatDamageMod","TraitProgVital","ProgBCombatDamageMod","",L,N,99);
										end
									else
										return StatLinInter("PntMPCombatDamageMod","TraitProgVital","ProgBHealth","CombatDamageModHealthMediumAdj",L,N,99);
									end
								else
									return StatLinInter("PntMPCombatDamageMod","TraitProgVital","ProgBHealth","",L,N,2);
								end
							elseif SN > "COMBATDAMAGEMODPETSADJ" then
								if SN < "CONSTSTATC" then
									if SN < "COMBATDAMAGEMODPLAYERSADJ" then
										if SN > "COMBATDAMAGEMODPETSRND" then
											if SN == "COMBATDAMAGEMODPLAYERS" then
												return StatLinInter("PntMPCombatDamageMod","TraitProgVital","ProgBCombatDamageMod","CombatDamageModPlayersAdj",L,N,99);
											else
												return 0;
											end
										elseif SN == "COMBATDAMAGEMODPETSRND" then
											return StatLinInter("PntMPCombatDamageMod","TraitProgVital","ProgBCombatDamageMod","CombatDamageModPetsAdj",L,N,2);
										else
											return 0;
										end
									elseif SN > "COMBATDAMAGEMODPLAYERSADJ" then
										if SN < "COMMONTACHPS" then
											if SN == "COMBATINHEAL" then
												return CalcStat("InHeal",L,2.0);
											else
												return 0;
											end
										elseif SN > "COMMONTACHPS" then
											if SN == "COMMONTACHPSITEMPROG" then
												return {{1,50,60,65,75,125,175,200,222,299,300,349,350,399,400,449,450,499,500,549},{1,50,60,65,75,85,95,100,105,105,106,115,116,120,121,130,131,140,141,150}};
											else
												return 0;
											end
										else
											return StatLinInter("PntMPTacHPS","CommonTacHPSItemProg","ProgBTacHPS","",L,N,99);
										end
									else
										if Lm <= 1 then
											return 0.8*N;
										elseif Lm <= 25 then
											return 0.9*N;
										else
											return N;
										end
									end
								elseif SN > "CONSTSTATC" then
									if SN < "CPTBLADETACMAS" then
										if SN > "CPTBLADECRITDEF" then
											if SN == "CPTBLADEPHYMAS" then
												return CalcStat("PhyMasT",L,1.2);
											else
												return 0;
											end
										elseif SN == "CPTBLADECRITDEF" then
											return CalcStat("CritDefT",L,0.8);
										else
											return 0;
										end
									elseif SN > "CPTBLADETACMAS" then
										if SN < "CPTCOVMAIN" then
											if SN == "CPTCOVFATE" then
												return CalcStat("FateT",L,0.4);
											else
												return 0;
											end
										elseif SN > "CPTCOVMAIN" then
											if SN == "CPTCOVPHYMIT" then
												return CalcStat("PhyMitT",L,2.4);
											else
												return 0;
											end
										else
											return CalcStat("MainT",L,0.4);
										end
									else
										return CalcStat("TacMasT",L,0.8);
									end
								else
									return CalcStat(C,1,L);
								end
							else
								if Lm <= 1 then
									return N;
								elseif Lm <= 25 then
									return 0.4*N;
								elseif Lm <= 50 then
									return 0.5*N;
								elseif Lm <= 60 then
									return 0.6*N;
								elseif Lm <= 65 then
									return 0.7*N;
								elseif Lm <= 75 then
									return 0.8*N;
								elseif Lm <= 85 then
									return 0.85*N;
								elseif Lm <= 95 then
									return 0.9*N;
								elseif Lm <= 100 then
									return 0.95*N;
								else
									return N;
								end
							end
						elseif SN > "CPTCOVVITALITY" then
							if SN < "CREEPAUDACITYDMGP" then
								if SN < "CPTSHIELDTACMAS" then
									if SN < "CPTIDOMEMAIN" then
										if SN > "CPTCRITDEF" then
											if SN == "CPTIDOMEFATE" then
												return CalcStat("FateT",L,0.4);
											else
												return 0;
											end
										elseif SN == "CPTCRITDEF" then
											return CalcStat("CritDef",L,0.6);
										else
											return 0;
										end
									elseif SN > "CPTIDOMEMAIN" then
										if SN < "CPTSHIELDCRITDEF" then
											if SN == "CPTIDOMEVITALITY" then
												return CalcStat("VitalityT",L,0.4);
											else
												return 0;
											end
										elseif SN > "CPTSHIELDCRITDEF" then
											if SN == "CPTSHIELDPHYMAS" then
												return CalcStat("PhyMasT",L,0.8);
											else
												return 0;
											end
										else
											return CalcStat("CritDefT",L,1.2);
										end
									else
										return CalcStat("MainT",L,0.4);
									end
								elseif SN > "CPTSHIELDTACMAS" then
									if SN < "CPTSONGTACMAS" then
										if SN > "CPTSONGCRITDEF" then
											if SN == "CPTSONGPHYMAS" then
												return CalcStat("PhyMasT",L,0.8);
											else
												return 0;
											end
										elseif SN == "CPTSONGCRITDEF" then
											return CalcStat("CritDefT",L,0.8);
										else
											return 0;
										end
									elseif SN > "CPTSONGTACMAS" then
										if SN < "CREEPAUDACITYCOST" then
											if SN == "CREEPAUDACITYCCDP" then
												if Lm <= 0 then
													return 0;
												elseif Lm <= 15 then
													return LinFmod(1,0.5,0.5,1,15,L);
												elseif Lm <= 16 then
													return LinFmod(1,0.5,0.4,15,16,L);
												elseif Lm <= 41 then
													return LinFmod(1,0.4,0.4,16,41,L);
												elseif Lm <= 60 then
													return LinFmod(1,0.4,0.4,41,60,L);
												else
													return CalcStat("CreepAudacityCCDP",60);
												end
											else
												return 0;
											end
										elseif SN > "CREEPAUDACITYCOST" then
											if SN == "CREEPAUDACITYCOSTBASE" then
												if Lm <= 0 then
													return 0;
												elseif Lm <= 2 then
													return 2*L;
												elseif Lm <= 9 then
													return 2*L-1;
												elseif Lm <= 15 then
													return 3*L;
												elseif Lm <= 25 then
													return 6*L;
												elseif Lm <= 29 then
													return 9*L;
												elseif Lm <= 36 then
													return 300;
												else
													return 0;
												end
											else
												return 0;
											end
										else
											return CalcStat("CreepAudacityCostBase",L)*25;
										end
									else
										return CalcStat("TacMasT",L,1.2);
									end
								else
									return CalcStat("TacMasT",L,0.8);
								end
							elseif SN > "CREEPAUDACITYDMGP" then
								if SN < "CREEPAUDACITYTACREDP" then
									if SN < "CREEPAUDACITYREDP" then
										if SN > "CREEPAUDACITYMELDMGP" then
											if SN == "CREEPAUDACITYMELREDP" then
												return CalcStat("CreepAudacityRedP",L);
											else
												return 0;
											end
										elseif SN == "CREEPAUDACITYMELDMGP" then
											return CalcStat("CreepAudacityDmgP",L);
										else
											return 0;
										end
									elseif SN > "CREEPAUDACITYREDP" then
										if SN < "CREEPAUDACITYRNGREDP" then
											if SN == "CREEPAUDACITYRNGDMGP" then
												return CalcStat("CreepAudacityDmgP",L);
											else
												return 0;
											end
										elseif SN > "CREEPAUDACITYRNGREDP" then
											if SN == "CREEPAUDACITYTACDMGP" then
												return CalcStat("CreepAudacityDmgP",L);
											else
												return 0;
											end
										else
											return CalcStat("CreepAudacityRedP",L);
										end
									else
										if Lm <= 0 then
											return 0;
										elseif Lm <= 10 then
											return LinFmod(1,0.55,0.55,1,10,L);
										elseif Lm <= 36 then
											return LinFmod(1,0.55,0.55,10,36,L);
										elseif Lm <= 41 then
											return LinFmod(1,0.55,0.55,36,41,L);
										elseif Lm <= 60 then
											return LinFmod(1,0.55,0.55,41,60,L);
										else
											return CalcStat("CreepAudacityRedP",60);
										end
									end
								elseif SN > "CREEPAUDACITYTACREDP" then
									if SN < "CREEPBATPROMHEALTHP" then
										if SN < "CREEPBATPROMDMGP" then
											if SN == "CREEPBASEPROG" then
												return LinFmod(1,RoundDblLotro(N),RoundDblLotro(100*N),1,140,L);
											else
												return 0;
											end
										elseif SN > "CREEPBATPROMDMGP" then
											if SN == "CREEPBATPROMFINESSE" then
												return 0;
											else
												return 0;
											end
										else
											if Lm <= 0 then
												return 0;
											elseif Lm <= 5 then
												return LinFmod(1,0.005,0.02,1,5,L);
											elseif Lm <= 10 then
												return LinFmod(1,0.02,0.045,5,10,L);
											elseif Lm <= 15 then
												return LinFmod(1,0.045,0.075,10,15,L);
											else
												return CalcStat("CreepBatPromDmgP",15);
											end
										end
									elseif SN > "CREEPBATPROMHEALTHP" then
										if SN < "CREEPBATPROMMELDMGP" then
											if SN == "CREEPBATPROMINHEALP" then
												return 0;
											else
												return 0;
											end
										elseif SN > "CREEPBATPROMMELDMGP" then
											if SN == "CREEPBATPROMOUTHEALP" then
												if Lm <= 0 then
													return 0;
												elseif Lm <= 5 then
													return LinFmod(1,0.02,0.1,1,5,L);
												elseif Lm <= 10 then
													return LinFmod(1,0.1,0.15,5,10,L);
												elseif Lm <= 15 then
													return LinFmod(1,0.15,0.2,10,15,L);
												else
													return CalcStat("CreepBatPromOutHealP",15);
												end
											else
												return 0;
											end
										else
											return CalcStat("CreepBatPromDmgP",L);
										end
									else
										return CalcStat("CreepBatPromVitalP",L);
									end
								else
									return CalcStat("CreepAudacityRedP",L);
								end
							else
								if Lm <= 0 then
									return 0;
								elseif Lm <= 10 then
									return LinFmod(1,1,1.2,1,10,L);
								elseif Lm <= 36 then
									return LinFmod(1,1.2,1.25,10,36,L);
								elseif Lm <= 41 then
									return LinFmod(1,1.25,1.3,36,41,L);
								elseif Lm <= 60 then
									return LinFmod(1,1.3,1.25,41,60,L);
								else
									return CalcStat("CreepAudacityDmgP",60);
								end
							end
						else
							return CalcStat("VitalityT",L,0.4);
						end
					else
						if Lm <= 46 then
							return 0;
						elseif Lm <= 49 then
							return DataTableValue({-0.091142856,-0.18971428,-0.2957143},L-46);
						elseif Lm <= 474 then
							return CalcStat("CombatBaseTacHPSBase",L)-5.659142856;
						elseif Lm <= 475 then
							return 460.62656;
						else
							return CalcStat("CombatBaseTacHPSBase",L)-5.659142856;
						end
					end
				else
					return 1;
				end
			else
				return CalcStat("BrwInnStrClevTechFinesse",L,3);
			end
		elseif SN > "CREEPBATPROMPOWERP" then
			if SN < "HUNTERCDBASEFATE" then
				if SN < "FOODNCPRH" then
					if SN < "DWARFRDTRAITMIGHT" then
						if SN < "CRITMAGNPRATPA" then
							if SN < "CRITHIT" then
								if SN < "CRITDEFPRATP" then
									if SN < "CREEPBATPROMVITALP" then
										if SN > "CREEPBATPROMRNGDMGP" then
											if SN == "CREEPBATPROMTACDMGP" then
												return CalcStat("CreepBatPromDmgP",L);
											else
												return 0;
											end
										elseif SN == "CREEPBATPROMRNGDMGP" then
											return CalcStat("CreepBatPromDmgP",L);
										else
											return 0;
										end
									elseif SN > "CREEPBATPROMVITALP" then
										if SN < "CRITDEFPBONUS" then
											if SN == "CRITDEF" then
												return StatLinInter("PntMPCritDef","ItemProg","ProgBCritDef","",L,N,0);
											else
												return 0;
											end
										elseif SN > "CRITDEFPBONUS" then
											if SN == "CRITDEFPPRAT" then
												return CalcRatAB(CalcStat("CritDefPRatPA",L),CalcStat("CritDefPRatPB",L),CalcStat("CritDefPRatPCapR",L),N);
											else
												return 0;
											end
										else
											return 0;
										end
									else
										if Lm <= 0 then
											return 0;
										elseif Lm <= 5 then
											return LinFmod(1,1.02,1.1,1,5,L);
										elseif Lm <= 10 then
											return LinFmod(1,1.1,1.15,5,10,L);
										elseif Lm <= 15 then
											return LinFmod(1,1.15,1.2,10,15,L);
										else
											return CalcStat("CreepBatPromVitalP",15);
										end
									end
								elseif SN > "CRITDEFPRATP" then
									if SN < "CRITDEFPRATPC" then
										if SN > "CRITDEFPRATPA" then
											if SN == "CRITDEFPRATPB" then
												return CalcStat("BRatRounded",L,"BRatLow");
											else
												return 0;
											end
										elseif SN == "CRITDEFPRATPA" then
											return 240;
										else
											return 0;
										end
									elseif SN > "CRITDEFPRATPC" then
										if SN < "CRITDEFPRATPCAPR" then
											if SN == "CRITDEFPRATPCAP" then
												return 80;
											else
												return 0;
											end
										elseif SN > "CRITDEFPRATPCAPR" then
											if SN == "CRITDEFT" then
												return StatLinInter("PntMPCritDef","TraitProg","ProgBCritDef","",L,N,0);
											else
												return 0;
											end
										else
											return CalcStat("CritDefPRatPB",L)*CalcStat("CritDefPRatPC",L);
										end
									else
										return 0.5;
									end
								else
									return CalcPercAB(CalcStat("CritDefPRatPA",L),CalcStat("CritDefPRatPB",L),CalcStat("CritDefPRatPCap",L),N);
								end
							elseif SN > "CRITHIT" then
								if SN < "CRITHITPRATPC" then
									if SN < "CRITHITPPRAT" then
										if SN > "CRITHITOLD" then
											if SN == "CRITHITPBONUS" then
												return 0;
											else
												return 0;
											end
										elseif SN == "CRITHITOLD" then
											return CalcStat("CritHit",L,N);
										else
											return 0;
										end
									elseif SN > "CRITHITPPRAT" then
										if SN < "CRITHITPRATPA" then
											if SN == "CRITHITPRATP" then
												return CalcPercAB(CalcStat("CritHitPRatPA",L),CalcStat("CritHitPRatPB",L),CalcStat("CritHitPRatPCap",L),N);
											else
												return 0;
											end
										elseif SN > "CRITHITPRATPA" then
											if SN == "CRITHITPRATPB" then
												return CalcStat("BRatRounded",L,"BRatLow");
											else
												return 0;
											end
										else
											return 75;
										end
									else
										return CalcRatAB(CalcStat("CritHitPRatPA",L),CalcStat("CritHitPRatPB",L),CalcStat("CritHitPRatPCapR",L),N);
									end
								elseif SN > "CRITHITPRATPC" then
									if SN < "CRITHITT" then
										if SN > "CRITHITPRATPCAP" then
											if SN == "CRITHITPRATPCAPR" then
												return CalcStat("CritHitPRatPB",L)*CalcStat("CritHitPRatPC",L);
											else
												return 0;
											end
										elseif SN == "CRITHITPRATPCAP" then
											return 25;
										else
											return 0;
										end
									elseif SN > "CRITHITT" then
										if SN < "CRITMAGNPPRAT" then
											if SN == "CRITMAGNPBONUS" then
												return 0;
											else
												return 0;
											end
										elseif SN > "CRITMAGNPPRAT" then
											if SN == "CRITMAGNPRATP" then
												return CalcPercAB(CalcStat("CritMagnPRatPA",L),CalcStat("CritMagnPRatPB",L),CalcStat("CritMagnPRatPCap",L),N);
											else
												return 0;
											end
										else
											return CalcRatAB(CalcStat("CritMagnPRatPA",L),CalcStat("CritMagnPRatPB",L),CalcStat("CritMagnPRatPCapR",L),N);
										end
									else
										return StatLinInter("PntMPCritHit","TraitProg","ProgBCritHit","",L,N,0);
									end
								else
									return 0.5;
								end
							else
								return StatLinInter("PntMPCritHit","ItemProg","ProgBCritHit","",L,N,0);
							end
						elseif SN > "CRITMAGNPRATPA" then
							if SN < "DISEASERESISTT" then
								if SN < "DEVHITPPRAT" then
									if SN < "CRITMAGNPRATPCAP" then
										if SN > "CRITMAGNPRATPB" then
											if SN == "CRITMAGNPRATPC" then
												return 0.5;
											else
												return 0;
											end
										elseif SN == "CRITMAGNPRATPB" then
											return CalcStat("BRatRounded",L,"BRatCritMagn");
										else
											return 0;
										end
									elseif SN > "CRITMAGNPRATPCAP" then
										if SN < "CRYRESISTT" then
											if SN == "CRITMAGNPRATPCAPR" then
												return CalcStat("CritMagnPRatPB",L)*CalcStat("CritMagnPRatPC",L);
											else
												return 0;
											end
										elseif SN > "CRYRESISTT" then
											if SN == "DEVHITPBONUS" then
												return 0;
											else
												return 0;
											end
										else
											return CalcStat("ResistAddT",L,N);
										end
									else
										return 75;
									end
								elseif SN > "DEVHITPPRAT" then
									if SN < "DEVHITPRATPB" then
										if SN > "DEVHITPRATP" then
											if SN == "DEVHITPRATPA" then
												return 30;
											else
												return 0;
											end
										elseif SN == "DEVHITPRATP" then
											return CalcPercAB(CalcStat("DevHitPRatPA",L),CalcStat("DevHitPRatPB",L),CalcStat("DevHitPRatPCap",L),N);
										else
											return 0;
										end
									elseif SN > "DEVHITPRATPB" then
										if SN < "DEVHITPRATPCAP" then
											if SN == "DEVHITPRATPC" then
												return 0.5;
											else
												return 0;
											end
										elseif SN > "DEVHITPRATPCAP" then
											if SN == "DEVHITPRATPCAPR" then
												return CalcStat("DevHitPRatPB",L)*CalcStat("DevHitPRatPC",L);
											else
												return 0;
											end
										else
											return 10;
										end
									else
										return CalcStat("BRatRounded",L,"BRatHigh");
									end
								else
									return CalcRatAB(CalcStat("DevHitPRatPA",L),CalcStat("DevHitPRatPB",L),CalcStat("DevHitPRatPCapR",L),N);
								end
							elseif SN > "DISEASERESISTT" then
								if SN < "DWARFRDPSVONENAME" then
									if SN < "DWARFENDURVITALITY" then
										if SN > "DMGTYPEMIT" then
											if SN == "DMGTYPEMITT" then
												return StatLinInter("PntMPDmgTypeMit","TraitProg","ProgBMitigation","",L,N,0);
											else
												return 0;
											end
										elseif SN == "DMGTYPEMIT" then
											return StatLinInter("PntMPDmgTypeMit","ItemProg","ProgBMitigation","",L,N,0);
										else
											return 0;
										end
									elseif SN > "DWARFENDURVITALITY" then
										if SN < "DWARFLOSTDWARFKDSFATE" then
											if SN == "DWARFFATEFULDWARFFATE" then
												return CalcStat("FateT",L,1.0);
											else
												return 0;
											end
										elseif SN > "DWARFLOSTDWARFKDSFATE" then
											if SN == "DWARFRDPSVONEFATE" then
												return CalcStat("DwarfFatefulDwarfFate",L);
											else
												return 0;
											end
										else
											return -CalcStat("FateT",L,0.4);
										end
									else
										return CalcStat("VitalityT",L,1.0);
									end
								elseif SN > "DWARFRDPSVONENAME" then
									if SN < "DWARFRDTRAITAGILITY" then
										if SN > "DWARFRDPSVTWOBLOCK" then
											if SN == "DWARFRDPSVTWONAME" then
												return "Shield Brawler";
											else
												return 0;
											end
										elseif SN == "DWARFRDPSVTWOBLOCK" then
											return CalcStat("DwarfShieldBrwlBlock",L);
										else
											return 0;
										end
									elseif SN > "DWARFRDTRAITAGILITY" then
										if SN < "DWARFRDTRAITICMR" then
											if SN == "DWARFRDTRAITFATE" then
												return CalcStat("DwarfLostDwarfKdsFate",L);
											else
												return 0;
											end
										elseif SN > "DWARFRDTRAITICMR" then
											if SN == "DWARFRDTRAITICPR" then
												return CalcStat("DwarfUnwearBattleICPR",L);
											else
												return 0;
											end
										else
											return CalcStat("DwarfUnwearBattleICMR",L);
										end
									else
										return CalcStat("DwarfStockyAgility",L);
									end
								else
									return "Fateful Dwarf";
								end
							else
								return CalcStat("ResistAddT",L,N);
							end
						else
							return 225;
						end
					elseif SN > "DWARFRDTRAITMIGHT" then
						if SN < "EVADEPPRAT" then
							if SN < "ELFAGILITYWOODSAGILITY" then
								if SN < "DWARFSTURDINESSMIGHT" then
									if SN < "DWARFRDTRAITPHYMITP" then
										if SN > "DWARFRDTRAITNCMR" then
											if SN == "DWARFRDTRAITNCPR" then
												return CalcStat("DwarfUnwearBattleNCPR",L);
											else
												return 0;
											end
										elseif SN == "DWARFRDTRAITNCMR" then
											return CalcStat("DwarfUnwearBattleNCMR",L);
										else
											return 0;
										end
									elseif SN > "DWARFRDTRAITPHYMITP" then
										if SN < "DWARFSHIELDBRWLBLOCK" then
											if SN == "DWARFRDTRAITVITALITY" then
												return CalcStat("DwarfSturdinessVitality",L);
											else
												return 0;
											end
										elseif SN > "DWARFSHIELDBRWLBLOCK" then
											if SN == "DWARFSTOCKYAGILITY" then
												return CalcStat("AgilityT",L,0.4);
											else
												return 0;
											end
										else
											return CalcStat("BlockT",L,0.8);
										end
									else
										return CalcStat("DwarfSturdinessPhyMitP",L);
									end
								elseif SN > "DWARFSTURDINESSMIGHT" then
									if SN < "DWARFUNWEARBATTLEICMR" then
										if SN > "DWARFSTURDINESSPHYMITP" then
											if SN == "DWARFSTURDINESSVITALITY" then
												return CalcStat("VitalityT",L,1.0);
											else
												return 0;
											end
										elseif SN == "DWARFSTURDINESSPHYMITP" then
											return 1;
										else
											return 0;
										end
									elseif SN > "DWARFUNWEARBATTLEICMR" then
										if SN < "DWARFUNWEARBATTLENCMR" then
											if SN == "DWARFUNWEARBATTLEICPR" then
												return CalcStat("ICPRT",L,0.6);
											else
												return 0;
											end
										elseif SN > "DWARFUNWEARBATTLENCMR" then
											if SN == "DWARFUNWEARBATTLENCPR" then
												return -CalcStat("NCPRT",L,0.4);
											else
												return 0;
											end
										else
											return -CalcStat("NCMRT",L,0.4);
										end
									else
										return CalcStat("ICMRT",L,0.6);
									end
								else
									return CalcStat("MightT",L,1.0);
								end
							elseif SN > "ELFAGILITYWOODSAGILITY" then
								if SN < "ELFRDTRAITFATE" then
									if SN < "ELFRDPSVONEFATE" then
										if SN > "ELFFADINGFIRSTBORNFATE" then
											if SN == "ELFFRIENDOFMANFATE" then
												return CalcStat("FateT",L,1.0);
											else
												return 0;
											end
										elseif SN == "ELFFADINGFIRSTBORNFATE" then
											return -CalcStat("FateT",L,0.4);
										else
											return 0;
										end
									elseif SN > "ELFRDPSVONEFATE" then
										if SN < "ELFRDPSVTWONAME" then
											if SN == "ELFRDPSVONENAME" then
												return "Friend Of Man";
											else
												return 0;
											end
										elseif SN > "ELFRDPSVTWONAME" then
											if SN == "ELFRDTRAITAGILITY" then
												return CalcStat("ElfAgilityWoodsAgility",L);
											else
												return 0;
											end
										else
											return "";
										end
									else
										return CalcStat("ElfFriendOfManFate",L);
									end
								elseif SN > "ELFRDTRAITFATE" then
									if SN < "ELFSORROWFIRSTBORNMORALE" then
										if SN > "ELFRDTRAITMORALE" then
											if SN == "ELFRDTRAITNCMR" then
												return CalcStat("ElfSorrowFirstbornNCMR",L);
											else
												return 0;
											end
										elseif SN == "ELFRDTRAITMORALE" then
											return CalcStat("ElfSorrowFirstbornMorale",L);
										else
											return 0;
										end
									elseif SN > "ELFSORROWFIRSTBORNMORALE" then
										if SN < "EVADE" then
											if SN == "ELFSORROWFIRSTBORNNCMR" then
												return -CalcStat("NCMRT",L,0.4);
											else
												return 0;
											end
										elseif SN > "EVADE" then
											if SN == "EVADEPBONUS" then
												return CalcStat("BPEPBonus",L);
											else
												return 0;
											end
										else
											return CalcStat("BPE",L,N);
										end
									else
										return -CalcStat("MoraleT",L,0.4);
									end
								else
									return CalcStat("ElfFadingFirstbornFate",L);
								end
							else
								return CalcStat("AgilityT",L,1.0);
							end
						elseif SN > "EVADEPPRAT" then
							if SN < "FINESSEPRATP" then
								if SN < "EVADET" then
									if SN < "EVADEPRATPB" then
										if SN > "EVADEPRATP" then
											if SN == "EVADEPRATPA" then
												return CalcStat("BPEPRatPA",L);
											else
												return 0;
											end
										elseif SN == "EVADEPRATP" then
											return CalcStat("BPEPRatP",L,N);
										else
											return 0;
										end
									elseif SN > "EVADEPRATPB" then
										if SN < "EVADEPRATPCAP" then
											if SN == "EVADEPRATPC" then
												return CalcStat("BPEPRatPC",L);
											else
												return 0;
											end
										elseif SN > "EVADEPRATPCAP" then
											if SN == "EVADEPRATPCAPR" then
												return CalcStat("BPEPRatPCapR",L);
											else
												return 0;
											end
										else
											return CalcStat("BPEPRatPCap",L);
										end
									else
										return CalcStat("BPEPRatPB",L);
									end
								elseif SN > "EVADET" then
									if SN < "FEARRESISTT" then
										if SN > "FATE" then
											if SN == "FATET" then
												return RoundDblDown(StatLinInter("PntMPFate","TraitProgVital","ProgBFate","",L,N,0));
											else
												return 0;
											end
										elseif SN == "FATE" then
											return RoundDblDown(StatLinInter("PntMPFate","ItemProgVital","ProgBFate","",L,N,0));
										else
											return 0;
										end
									elseif SN > "FEARRESISTT" then
										if SN < "FINESSEPBONUS" then
											if SN == "FINESSE" then
												return StatLinInter("PntMPFinesse","ItemProg","ProgBFinesse","",L,N,0);
											else
												return 0;
											end
										elseif SN > "FINESSEPBONUS" then
											if SN == "FINESSEPPRAT" then
												return CalcRatAB(CalcStat("FinessePRatPA",L),CalcStat("FinessePRatPB",L),CalcStat("FinessePRatPCapR",L),N);
											else
												return 0;
											end
										else
											return 0;
										end
									else
										return CalcStat("ResistAddT",L,N);
									end
								else
									return CalcStat("BPET",L,N);
								end
							elseif SN > "FINESSEPRATP" then
								if SN < "FIREMIT" then
									if SN < "FINESSEPRATPC" then
										if SN > "FINESSEPRATPA" then
											if SN == "FINESSEPRATPB" then
												return CalcStat("BRatRounded",L,"BRatLow");
											else
												return 0;
											end
										elseif SN == "FINESSEPRATPA" then
											return 150;
										else
											return 0;
										end
									elseif SN > "FINESSEPRATPC" then
										if SN < "FINESSEPRATPCAPR" then
											if SN == "FINESSEPRATPCAP" then
												return 50;
											else
												return 0;
											end
										elseif SN > "FINESSEPRATPCAPR" then
											if SN == "FINESSET" then
												return StatLinInter("PntMPFinesseT","TraitProg","ProgBFinesse","",L,N,0);
											else
												return 0;
											end
										else
											return CalcStat("FinessePRatPB",L)*CalcStat("FinessePRatPC",L);
										end
									else
										return 0.5;
									end
								elseif SN > "FIREMIT" then
									if SN < "FOODNCMRL" then
										if SN < "FOODNCMRBASEPROG" then
											if SN == "FIREMITT" then
												return CalcStat("DmgTypeMitT",L,N);
											else
												return 0;
											end
										elseif SN > "FOODNCMRBASEPROG" then
											if SN == "FOODNCMRH" then
												return CalcStat("FoodNCMRProg",L,1)*N;
											else
												return 0;
											end
										else
											if Lm <= 1 then
												return (N*70.2+210)/60;
											elseif Lm <= 2 then
												return (N*84+216)/120;
											else
												return (N*83.7+270)/90;
											end
										end
									elseif SN > "FOODNCMRL" then
										if SN < "FOODNCMRPROG" then
											if SN == "FOODNCMRM" then
												return CalcStat("FoodNCMRProg",L,3)*N;
											else
												return 0;
											end
										elseif SN > "FOODNCMRPROG" then
											if SN == "FOODNCPRBASEPROG" then
												if Lm <= 1 then
													return (N*75+300)/60;
												elseif Lm <= 2 then
													return (N*100+350)/120;
												else
													return (N*90+337.5)/90;
												end
											else
												return 0;
											end
										else
											if Lm <= 50 then
												return CalcStat("FoodNCMRBaseProg",N,L);
											elseif Lm <= 52 then
												return CalcStat("FoodNCMRBaseProg",N,50);
											elseif Lm <= 77 then
												return CalcStat("FoodNCMRBaseProg",N,L-3);
											elseif Lm <= 111 then
												return CalcStat("FoodNCMRBaseProg",N,RoundDbl((L+143)/3));
											elseif Lm <= 140 then
												return CalcStat("FoodNCMRBaseProg",N,85);
											elseif Lm <= 217 then
												return CalcStat("FoodNCMRBaseProg",N,RoundDbl((L+200)/4));
											elseif Lm <= 221 then
												return CalcStat("FoodNCMRBaseProg",N,104);
											elseif Lm <= 299 then
												return CalcStat("FoodNCMRBaseProg",N,105);
											elseif Lm <= 320 then
												return CalcStat("FoodNCMRBaseProg",N,RoundDbl((L-53)/(7/3)));
											elseif Lm <= 325 then
												return CalcStat("FoodNCMRBaseProg",N,114);
											elseif Lm <= 326 then
												return CalcStat("FoodNCMRBaseProg",N,115);
											else
												return ExpFmod(CalcStat("FoodNCMRProg",326,N),327,1,L,1);
											end
										end
									else
										return CalcStat("FoodNCMRProg",L,2)*N;
									end
								else
									return CalcStat("DmgTypeMit",L,N);
								end
							else
								return CalcPercAB(CalcStat("FinessePRatPA",L),CalcStat("FinessePRatPB",L),CalcStat("FinessePRatPCap",L),N);
							end
						else
							return CalcStat("BPEPPRat",L,N);
						end
					else
						return CalcStat("DwarfSturdinessMight",L);
					end
				elseif SN > "FOODNCPRH" then
					if SN < "GUARDIANCDFATETORESIST" then
						if SN < "GRDTENDERIZET3CRITHIT" then
							if SN < "FREEPAUDACITYTACREDP" then
								if SN < "FREEPAUDACITYMELDMGP" then
									if SN < "FOODNCPRPROG" then
										if SN > "FOODNCPRL" then
											if SN == "FOODNCPRM" then
												return CalcStat("FoodNCPRProg",L,3)*N;
											else
												return 0;
											end
										elseif SN == "FOODNCPRL" then
											return CalcStat("FoodNCPRProg",L,2)*N;
										else
											return 0;
										end
									elseif SN > "FOODNCPRPROG" then
										if SN < "FREEPAUDACITYCCDP" then
											if SN == "FOODRESIST" then
												return StatLinInter("PntMPFoodResist","ItemProg","ProgBResist","",L,N,0);
											else
												return 0;
											end
										elseif SN > "FREEPAUDACITYCCDP" then
											if SN == "FREEPAUDACITYDMGP" then
												if Lm <= 0 then
													return 0;
												elseif Lm <= 15 then
													return LinFmod(1,0.75,0.75,1,15,L);
												elseif Lm <= 16 then
													return LinFmod(1,0.75,1.2,15,16,L);
												elseif Lm <= 36 then
													return LinFmod(1,1.2,1.25,16,36,L);
												elseif Lm <= 60 then
													return LinFmod(1,1.25,1.25,36,60,L);
												else
													return CalcStat("FreepAudacityDmgP",60);
												end
											else
												return 0;
											end
										else
											if Lm <= 0 then
												return 0;
											elseif Lm <= 15 then
												return LinFmod(1,0.5,0.5,1,15,L);
											elseif Lm <= 16 then
												return LinFmod(1,0.5,0.4,15,16,L);
											elseif Lm <= 41 then
												return LinFmod(1,0.4,0.4,16,41,L);
											elseif Lm <= 60 then
												return LinFmod(1,0.4,0.4,41,60,L);
											else
												return CalcStat("FreepAudacityCCDP",60);
											end
										end
									else
										if Lm <= 1 then
											return CalcStat("FoodNCPRBaseProg",N,L);
										elseif Lm <= 6 then
											return CalcStat("FoodNCPRBaseProg",N,L)-0.25;
										elseif Lm <= 24 then
											return CalcStat("FoodNCPRBaseProg",N,L)-0.5;
										elseif Lm <= 48 then
											return CalcStat("FoodNCPRBaseProg",N,L)-0.75;
										elseif Lm <= 61 then
											return RoundDblDown(CalcStat("FoodNCPRProg",48,N))+1;
										elseif Lm <= 66 then
											return RoundDblDown(CalcStat("FoodNCPRProg",48,N))+2;
										elseif Lm <= 72 then
											return RoundDblDown(CalcStat("FoodNCPRProg",48,N))+3;
										elseif Lm <= 326 then
											return RoundDblDown(CalcStat("FoodNCPRProg",48,N))+4;
										else
											return ExpFmod(CalcStat("FoodNCPRProg",326,N),327,1,L,1);
										end
									end
								elseif SN > "FREEPAUDACITYMELDMGP" then
									if SN < "FREEPAUDACITYREDP" then
										if SN > "FREEPAUDACITYMELREDP" then
											if SN == "FREEPAUDACITYMORALEP" then
												if Lm <= 0 then
													return 0;
												elseif Lm <= 15 then
													return LinFmod(1,0.5,1.4,1,15,L);
												elseif Lm <= 16 then
													return LinFmod(1,1.4,1.5,15,16,L);
												elseif Lm <= 36 then
													return LinFmod(1,1.5,1.5,16,36,L);
												elseif Lm <= 41 then
													return LinFmod(1,1.5,1.5,36,41,L);
												else
													return CalcStat("FreepAudacityMoraleP",41);
												end
											else
												return 0;
											end
										elseif SN == "FREEPAUDACITYMELREDP" then
											return CalcStat("FreepAudacityRedP",L);
										else
											return 0;
										end
									elseif SN > "FREEPAUDACITYREDP" then
										if SN < "FREEPAUDACITYRNGREDP" then
											if SN == "FREEPAUDACITYRNGDMGP" then
												return CalcStat("FreepAudacityDmgP",L);
											else
												return 0;
											end
										elseif SN > "FREEPAUDACITYRNGREDP" then
											if SN == "FREEPAUDACITYTACDMGP" then
												return CalcStat("FreepAudacityDmgP",L);
											else
												return 0;
											end
										else
											return CalcStat("FreepAudacityRedP",L);
										end
									else
										if Lm <= 0 then
											return 0;
										elseif Lm <= 15 then
											return LinFmod(1,1.5,1.5,1,15,L);
										elseif Lm <= 16 then
											return LinFmod(1,1.5,0.55,15,16,L);
										elseif Lm <= 36 then
											return LinFmod(1,0.55,0.55,16,36,L);
										elseif Lm <= 60 then
											return LinFmod(1,0.55,0.55,36,60,L);
										else
											return CalcStat("FreepAudacityRedP",60);
										end
									end
								else
									return CalcStat("FreepAudacityDmgP",L);
								end
							elseif SN > "FREEPAUDACITYTACREDP" then
								if SN < "FREEPBATPROMVITALP" then
									if SN < "FREEPBATPROMMELDMGP" then
										if SN > "FREEPBATPROMDMGP" then
											if SN == "FREEPBATPROMHEALTHP" then
												return CalcStat("FreepBatPromVitalP",L);
											else
												return 0;
											end
										elseif SN == "FREEPBATPROMDMGP" then
											if Lm <= 0 then
												return 0;
											elseif Lm <= 1 then
												return 0.005;
											elseif Lm <= 14 then
												return LinFmod(1,0.005,0.065,2,14,L);
											else
												return 0.075;
											end
										else
											return 0;
										end
									elseif SN > "FREEPBATPROMMELDMGP" then
										if SN < "FREEPBATPROMRNGDMGP" then
											if SN == "FREEPBATPROMPOWERP" then
												return CalcStat("FreepBatPromVitalP",L);
											else
												return 0;
											end
										elseif SN > "FREEPBATPROMRNGDMGP" then
											if SN == "FREEPBATPROMTACDMGP" then
												return CalcStat("FreepBatPromDmgP",L);
											else
												return 0;
											end
										else
											return CalcStat("FreepBatPromDmgP",L);
										end
									else
										return CalcStat("FreepBatPromDmgP",L);
									end
								elseif SN > "FREEPBATPROMVITALP" then
									if SN < "GRDCRITDEF" then
										if SN > "FROSTMIT" then
											if SN == "FROSTMITT" then
												return CalcStat("DmgTypeMitT",L,N);
											else
												return 0;
											end
										elseif SN == "FROSTMIT" then
											return CalcStat("DmgTypeMit",L,N);
										else
											return 0;
										end
									elseif SN > "GRDCRITDEF" then
										if SN < "GRDTENDERIZECRITHIT" then
											if SN == "GRDRELENTLASSFINESSE" then
												return CalcStat("FinesseT",L,CalcStat("Trait12345Choice",N)*0.2);
											else
												return 0;
											end
										elseif SN > "GRDTENDERIZECRITHIT" then
											if SN == "GRDTENDERIZET2CRITHIT" then
												return CalcStat("CritHitT",L,CalcStat("Trait12345Choice",N)*0.4);
											else
												return 0;
											end
										else
											return CalcStat("CritHitT",L,CalcStat("Trait12345Choice",N)*0.2);
										end
									else
										return CalcStat("CritDef",L);
									end
								else
									if Lm <= 0 then
										return 0;
									elseif Lm <= 5 then
										return LinFmod(1,1.02,1.1,1,5,L);
									elseif Lm <= 10 then
										return LinFmod(1,1.1,1.15,5,10,L);
									elseif Lm <= 15 then
										return LinFmod(1,1.15,1.2,10,15,L);
									else
										return CalcStat("FreepBatPromVitalP",15);
									end
								end
							else
								return CalcStat("FreepAudacityRedP",L);
							end
						elseif SN > "GRDTENDERIZET3CRITHIT" then
							if SN < "GUARDIANCDBASEICPR" then
								if SN < "GUARDIANCDARMOURTOOFMIT" then
									if SN < "GRDWARDTACTTACMIT" then
										if SN > "GRDTENDERIZET4CRITHIT" then
											if SN == "GRDTENDERIZET5CRITHIT" then
												return CalcStat("CritHitT",L,CalcStat("Trait58121620Choice",N)*0.2);
											else
												return 0;
											end
										elseif SN == "GRDTENDERIZET4CRITHIT" then
											return CalcStat("CritHitT",L,CalcStat("Trait47101316Choice",N)*0.2);
										else
											return 0;
										end
									elseif SN > "GRDWARDTACTTACMIT" then
										if SN < "GUARDIANCDAGILITYTOEVADE" then
											if SN == "GUARDIANCDAGILITYTOCRITHIT" then
												return 1;
											else
												return 0;
											end
										elseif SN > "GUARDIANCDAGILITYTOEVADE" then
											if SN == "GUARDIANCDAGILITYTOPARRY" then
												return 2;
											else
												return 0;
											end
										else
											return 3;
										end
									else
										return CalcStat("TacMitT",L,CalcStat("Trait12345Choice",N)*0.2);
									end
								elseif SN > "GUARDIANCDARMOURTOOFMIT" then
									if SN < "GUARDIANCDARMOURTYPE" then
										if SN > "GUARDIANCDARMOURTOPHYMIT" then
											if SN == "GUARDIANCDARMOURTOTACMIT" then
												return 0.2;
											else
												return 0;
											end
										elseif SN == "GUARDIANCDARMOURTOPHYMIT" then
											return 1;
										else
											return 0;
										end
									elseif SN > "GUARDIANCDARMOURTYPE" then
										if SN < "GUARDIANCDBASEFATE" then
											if SN == "GUARDIANCDBASEAGILITY" then
												return CalcStat("ClassBaseAgilityM",L);
											else
												return 0;
											end
										elseif SN > "GUARDIANCDBASEFATE" then
											if SN == "GUARDIANCDBASEICMR" then
												return CalcStat("ClassBaseICMRH",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseFate",L);
										end
									else
										return 3;
									end
								else
									return 0.2;
								end
							elseif SN > "GUARDIANCDBASEICPR" then
								if SN < "GUARDIANCDBASEWILL" then
									if SN < "GUARDIANCDBASENCMR" then
										if SN > "GUARDIANCDBASEMIGHT" then
											if SN == "GUARDIANCDBASEMORALE" then
												return CalcStat("ClassBaseMorale",L);
											else
												return 0;
											end
										elseif SN == "GUARDIANCDBASEMIGHT" then
											return CalcStat("ClassBaseMightH",L);
										else
											return 0;
										end
									elseif SN > "GUARDIANCDBASENCMR" then
										if SN < "GUARDIANCDBASEPOWER" then
											if SN == "GUARDIANCDBASENCPR" then
												return CalcStat("ClassBaseNCPR",L);
											else
												return 0;
											end
										elseif SN > "GUARDIANCDBASEPOWER" then
											if SN == "GUARDIANCDBASEVITALITY" then
												return CalcStat("ClassBaseVitality",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBasePower",L);
										end
									else
										return CalcStat("ClassBaseNCMRH",L);
									end
								elseif SN > "GUARDIANCDBASEWILL" then
									if SN < "GUARDIANCDFATETOFINESSE" then
										if SN > "GUARDIANCDCANBLOCK" then
											if SN == "GUARDIANCDFATETOCRITHIT" then
												return 1.5;
											else
												return 0;
											end
										elseif SN == "GUARDIANCDCANBLOCK" then
											return 1;
										else
											return 0;
										end
									elseif SN > "GUARDIANCDFATETOFINESSE" then
										if SN < "GUARDIANCDFATETONCPR" then
											if SN == "GUARDIANCDFATETOICMR" then
												return 0.025;
											else
												return 0;
											end
										elseif SN > "GUARDIANCDFATETONCPR" then
											if SN == "GUARDIANCDFATETOPOWER" then
												return 1;
											else
												return 0;
											end
										else
											return 0.05;
										end
									else
										return 0.5;
									end
								else
									return CalcStat("ClassBaseWillL",L);
								end
							else
								return CalcStat("ClassBaseICPR",L);
							end
						else
							return CalcStat("CritHitT",L,CalcStat("Trait357912Choice",N)*0.2);
						end
					elseif SN > "GUARDIANCDFATETORESIST" then
						if SN < "HNTARMOURRENDPARRY" then
							if SN < "HELFFADINGFIRSTBORNFATE" then
								if SN < "GUARDIANCDTACMASTOOUTHEAL" then
									if SN < "GUARDIANCDMIGHTTOBLOCK" then
										if SN > "GUARDIANCDFATETOTACMIT" then
											if SN == "GUARDIANCDHASPOWER" then
												return 1;
											else
												return 0;
											end
										elseif SN == "GUARDIANCDFATETOTACMIT" then
											return 0.5;
										else
											return 0;
										end
									elseif SN > "GUARDIANCDMIGHTTOBLOCK" then
										if SN < "GUARDIANCDMIGHTTOPHYMAS" then
											if SN == "GUARDIANCDMIGHTTOPARRY" then
												return 2;
											else
												return 0;
											end
										elseif SN > "GUARDIANCDMIGHTTOPHYMAS" then
											if SN == "GUARDIANCDPHYMITTOOFMIT" then
												return 1;
											else
												return 0;
											end
										else
											return 3;
										end
									else
										return 3;
									end
								elseif SN > "GUARDIANCDTACMASTOOUTHEAL" then
									if SN < "GUARDIANCDVITALITYTORESIST" then
										if SN > "GUARDIANCDVITALITYTOMORALE" then
											if SN == "GUARDIANCDVITALITYTONCMR" then
												return 0.12;
											else
												return 0;
											end
										elseif SN == "GUARDIANCDVITALITYTOMORALE" then
											return 4.8;
										else
											return 0;
										end
									elseif SN > "GUARDIANCDVITALITYTORESIST" then
										if SN < "GUARDIANCDWILLTOTACMAS" then
											if SN == "GUARDIANCDWILLTORESIST" then
												return 2;
											else
												return 0;
											end
										elseif SN > "GUARDIANCDWILLTOTACMAS" then
											if SN == "GUARDIANCDWILLTOTACMIT" then
												return 1;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return 0.5;
									end
								else
									return 1;
								end
							elseif SN > "HELFFADINGFIRSTBORNFATE" then
								if SN < "HIGHELFRDPSVTWONAME" then
									if SN < "HELFSORROWUNDYINGWILL" then
										if SN > "HELFPEACEELDARMORALE" then
											if SN == "HELFPEACEELDARNCMR" then
												return CalcStat("NCMRT",L,0.6);
											else
												return 0;
											end
										elseif SN == "HELFPEACEELDARMORALE" then
											return CalcStat("MoraleT",L,1.0);
										else
											return 0;
										end
									elseif SN > "HELFSORROWUNDYINGWILL" then
										if SN < "HIGHELFRDPSVONENAME" then
											if SN == "HELFTHOSEWHOREMAINWILL" then
												return CalcStat("WillT",L,1.0);
											else
												return 0;
											end
										elseif SN > "HIGHELFRDPSVONENAME" then
											if SN == "HIGHELFRDPSVONEWILL" then
												return CalcStat("HElfThoseWhoRemainWill",L);
											else
												return 0;
											end
										else
											return "Those Who Remain";
										end
									else
										return -CalcStat("WillT",L,0.4);
									end
								elseif SN > "HIGHELFRDPSVTWONAME" then
									if SN < "HIGHELFRDTRAITNCMR" then
										if SN > "HIGHELFRDTRAITFATE" then
											if SN == "HIGHELFRDTRAITMORALE" then
												return CalcStat("HElfPeaceEldarMorale",L);
											else
												return 0;
											end
										elseif SN == "HIGHELFRDTRAITFATE" then
											return CalcStat("HElfFadingFirstbornFate",L);
										else
											return 0;
										end
									elseif SN > "HIGHELFRDTRAITNCMR" then
										if SN < "HNTARMOURRENDBLOCK" then
											if SN == "HIGHELFRDTRAITWILL" then
												return CalcStat("HElfSorrowUndyingWill",L);
											else
												return 0;
											end
										elseif SN > "HNTARMOURRENDBLOCK" then
											if SN == "HNTARMOURRENDEVADE" then
												return -CalcStat("EvadeT",L,CalcStat("Trait23456Choice",N)*0.4);
											else
												return 0;
											end
										else
											return -CalcStat("ShieldBlock",L,CalcStat("Trait23456Choice",N)*0.4);
										end
									else
										return CalcStat("HElfPeaceEldarNCMR",L);
									end
								else
									return "";
								end
							else
								return -CalcStat("FateT",L,0.4);
							end
						elseif SN > "HNTARMOURRENDPARRY" then
							if SN < "HOBBITRDTRAITVITALITY" then
								if SN < "HNTRAPIDFIRESEL" then
									if SN < "HNTCAMPFIRENCPR" then
										if SN > "HNTBREACHFINDERRNGMIT" then
											if SN == "HNTCAMPFIRENCMR" then
												return CalcStat("NCMRT",L,1.2);
											else
												return 0;
											end
										elseif SN == "HNTBREACHFINDERRNGMIT" then
											return (-20)*L;
										else
											return 0;
										end
									elseif SN > "HNTCAMPFIRENCPR" then
										if SN < "HNTPURGEPOISONRESIST" then
											if SN == "HNTPRECISIONSTANCEFINESSE" then
												return CalcStat("FinesseT",L,1.6);
											else
												return 0;
											end
										elseif SN > "HNTPURGEPOISONRESIST" then
											if SN == "HNTRAPIDFIREPHYMAS" then
												return CalcStat("PhyMasT",L,CalcStat("HntRapidFireSel",N)*0.2);
											else
												return 0;
											end
										else
											return CalcStat("PoisonResistT",L,4);
										end
									else
										return CalcStat("NCPRT",L,1.2);
									end
								elseif SN > "HNTRAPIDFIRESEL" then
									if SN < "HOBBITRDPSVONENAME" then
										if SN > "HNTSTRENGTHSTANCECRITHIT" then
											if SN == "HOBBITRDPSVONEMIGHT" then
												return CalcStat("HobHobbitStatureMight",L);
											else
												return 0;
											end
										elseif SN == "HNTSTRENGTHSTANCECRITHIT" then
											return CalcStat("CritHitT",L,4);
										else
											return 0;
										end
									elseif SN > "HOBBITRDPSVONENAME" then
										if SN < "HOBBITRDTRAITMIGHT" then
											if SN == "HOBBITRDPSVTWONAME" then
												return "";
											else
												return 0;
											end
										elseif SN > "HOBBITRDTRAITMIGHT" then
											if SN == "HOBBITRDTRAITNCMR" then
												return CalcStat("HobRapidRecoveryNCMR",L);
											else
												return 0;
											end
										else
											return CalcStat("HobSmallSizeMight",L);
										end
									else
										return "Hobbit-stature";
									end
								else
									if Lm <= 0 then
										return 0;
									elseif Lm <= 8 then
										return L+2;
									elseif Lm <= 10 then
										return 2*L-6;
									else
										return CalcStat("HntRapidFireSel",10);
									end
								end
							elseif SN > "HOBBITRDTRAITVITALITY" then
								if SN < "HUNTERCDAGILITYTOEVADE" then
									if SN < "HOBRAPIDRECOVERYNCMR" then
										if SN > "HOBHOBBITSTATUREMIGHT" then
											if SN == "HOBHOBBITTOUGHNVITALITY" then
												return CalcStat("VitalityT",L,1.0);
											else
												return 0;
											end
										elseif SN == "HOBHOBBITSTATUREMIGHT" then
											return CalcStat("MightT",L,1.0);
										else
											return 0;
										end
									elseif SN > "HOBRAPIDRECOVERYNCMR" then
										if SN < "HOPEMORALEP" then
											if SN == "HOBSMALLSIZEMIGHT" then
												return -CalcStat("MightT",L,0.4);
											else
												return 0;
											end
										elseif SN > "HOPEMORALEP" then
											if SN == "HUNTERCDAGILITYTOCRITHIT" then
												return 1;
											else
												return 0;
											end
										else
											if Lm <= 5 then
												return DataTableValue({-0.99,-0.97,-0.95,-0.9,-0.85,-0.8,-0.65,-0.6,-0.5,-0.4,-0.3,-0.2,-0.15,-0.1,-0.05,0,0.01,0.02,0.03,0.04,0.05},L+16);
											else
												return 0.05;
											end
										end
									else
										return CalcStat("NCMRT",L,0.6);
									end
								elseif SN > "HUNTERCDAGILITYTOEVADE" then
									if SN < "HUNTERCDARMOURTOPHYMIT" then
										if SN < "HUNTERCDAGILITYTOPHYMAS" then
											if SN == "HUNTERCDAGILITYTOPARRY" then
												return 2;
											else
												return 0;
											end
										elseif SN > "HUNTERCDAGILITYTOPHYMAS" then
											if SN == "HUNTERCDARMOURTOOFMIT" then
												return 0.2;
											else
												return 0;
											end
										else
											return 3;
										end
									elseif SN > "HUNTERCDARMOURTOPHYMIT" then
										if SN < "HUNTERCDARMOURTYPE" then
											if SN == "HUNTERCDARMOURTOTACMIT" then
												return 0.2;
											else
												return 0;
											end
										elseif SN > "HUNTERCDARMOURTYPE" then
											if SN == "HUNTERCDBASEAGILITY" then
												return CalcStat("ClassBaseAgilityH",L);
											else
												return 0;
											end
										else
											return 2;
										end
									else
										return 1;
									end
								else
									return 3;
								end
							else
								return CalcStat("HobHobbitToughnVitality",L);
							end
						else
							return -CalcStat("ParryT",L,CalcStat("Trait23456Choice",N)*0.4);
						end
					else
						return 0.5;
					end
				else
					return CalcStat("FoodNCPRProg",L,1)*N;
				end
			elseif SN > "HUNTERCDBASEFATE" then
				if SN < "LOREMASTERCDMIGHTTOBLOCK" then
					if SN < "ITEMPROGVIRTUEMORALE" then
						if SN < "HUNTERCDWILLTOTACMIT" then
							if SN < "HUNTERCDFATETOPOWER" then
								if SN < "HUNTERCDBASEPOWER" then
									if SN < "HUNTERCDBASEMIGHT" then
										if SN > "HUNTERCDBASEICMR" then
											if SN == "HUNTERCDBASEICPR" then
												return CalcStat("ClassBaseICPR",L);
											else
												return 0;
											end
										elseif SN == "HUNTERCDBASEICMR" then
											return CalcStat("ClassBaseICMRM",L);
										else
											return 0;
										end
									elseif SN > "HUNTERCDBASEMIGHT" then
										if SN < "HUNTERCDBASENCMR" then
											if SN == "HUNTERCDBASEMORALE" then
												return CalcStat("ClassBaseMorale",L);
											else
												return 0;
											end
										elseif SN > "HUNTERCDBASENCMR" then
											if SN == "HUNTERCDBASENCPR" then
												return CalcStat("ClassBaseNCPR",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseNCMRM",L);
										end
									else
										return CalcStat("ClassBaseMightM",L);
									end
								elseif SN > "HUNTERCDBASEPOWER" then
									if SN < "HUNTERCDFATETOCRITHIT" then
										if SN > "HUNTERCDBASEVITALITY" then
											if SN == "HUNTERCDBASEWILL" then
												return CalcStat("ClassBaseWillL",L);
											else
												return 0;
											end
										elseif SN == "HUNTERCDBASEVITALITY" then
											return CalcStat("ClassBaseVitality",L);
										else
											return 0;
										end
									elseif SN > "HUNTERCDFATETOCRITHIT" then
										if SN < "HUNTERCDFATETOICMR" then
											if SN == "HUNTERCDFATETOFINESSE" then
												return 0.5;
											else
												return 0;
											end
										elseif SN > "HUNTERCDFATETOICMR" then
											if SN == "HUNTERCDFATETONCPR" then
												return 0.05;
											else
												return 0;
											end
										else
											return 0.025;
										end
									else
										return 1.5;
									end
								else
									return CalcStat("ClassBasePower",L);
								end
							elseif SN > "HUNTERCDFATETOPOWER" then
								if SN < "HUNTERCDTACMASTOOUTHEAL" then
									if SN < "HUNTERCDHASPOWER" then
										if SN > "HUNTERCDFATETORESIST" then
											if SN == "HUNTERCDFATETOTACMIT" then
												return 0.5;
											else
												return 0;
											end
										elseif SN == "HUNTERCDFATETORESIST" then
											return 0.5;
										else
											return 0;
										end
									elseif SN > "HUNTERCDHASPOWER" then
										if SN < "HUNTERCDMIGHTTOPARRY" then
											if SN == "HUNTERCDMIGHTTOBLOCK" then
												return 3;
											else
												return 0;
											end
										elseif SN > "HUNTERCDMIGHTTOPARRY" then
											if SN == "HUNTERCDPHYMITTOOFMIT" then
												return 1;
											else
												return 0;
											end
										else
											return 2;
										end
									else
										return 1;
									end
								elseif SN > "HUNTERCDTACMASTOOUTHEAL" then
									if SN < "HUNTERCDVITALITYTORESIST" then
										if SN > "HUNTERCDVITALITYTOMORALE" then
											if SN == "HUNTERCDVITALITYTONCMR" then
												return 0.12;
											else
												return 0;
											end
										elseif SN == "HUNTERCDVITALITYTOMORALE" then
											return 4;
										else
											return 0;
										end
									elseif SN > "HUNTERCDVITALITYTORESIST" then
										if SN < "HUNTERCDWILLTORESIST" then
											if SN == "HUNTERCDVITALITYTOTACMIT" then
												return 0.5;
											else
												return 0;
											end
										elseif SN > "HUNTERCDWILLTORESIST" then
											if SN == "HUNTERCDWILLTOTACMAS" then
												return 1;
											else
												return 0;
											end
										else
											return 2;
										end
									else
										return 0.5;
									end
								else
									return 1;
								end
							else
								return 1;
							end
						elseif SN > "HUNTERCDWILLTOTACMIT" then
							if SN < "INHEALPBONUS" then
								if SN < "INDMGPRATP" then
									if SN < "ICPR" then
										if SN > "ICMR" then
											if SN == "ICMRT" then
												return StatLinInter("PntMPICMR","TraitProgVital","ProgBICMR","",L,N,1);
											else
												return 0;
											end
										elseif SN == "ICMR" then
											return StatLinInter("PntMPICMR","ItemProgVital","ProgBICMR","",L,N,1);
										else
											return 0;
										end
									elseif SN > "ICPR" then
										if SN < "INDMGPBONUS" then
											if SN == "ICPRT" then
												return StatLinInter("PntMPICPR","TraitProgVital","ProgBICPR","",L,N,99);
											else
												return 0;
											end
										elseif SN > "INDMGPBONUS" then
											if SN == "INDMGPPRAT" then
												return CalcRatAB(CalcStat("InDmgPRatPA",L),CalcStat("InDmgPRatPB",L),CalcStat("InDmgPRatPCapR",L),N);
											else
												return 0;
											end
										else
											return 0;
										end
									else
										return StatLinInter("PntMPICPR","ItemProgVital","ProgBICPR","",L,N,99);
									end
								elseif SN > "INDMGPRATP" then
									if SN < "INDMGPRATPC" then
										if SN > "INDMGPRATPA" then
											if SN == "INDMGPRATPB" then
												return CalcStat("BRatRounded",L,"BRatLow");
											else
												return 0;
											end
										elseif SN == "INDMGPRATPA" then
											return 1200;
										else
											return 0;
										end
									elseif SN > "INDMGPRATPC" then
										if SN < "INDMGPRATPCAPR" then
											if SN == "INDMGPRATPCAP" then
												return 400;
											else
												return 0;
											end
										elseif SN > "INDMGPRATPCAPR" then
											if SN == "INHEAL" then
												return StatLinInter("PntMPInHeal","ItemProg","ProgBInHeal","",L,N,0);
											else
												return 0;
											end
										else
											return CalcStat("InDmgPRatPB",L)*CalcStat("InDmgPRatPC",L);
										end
									else
										return 0.5;
									end
								else
									return CalcPercAB(CalcStat("InDmgPRatPA",L),CalcStat("InDmgPRatPB",L),CalcStat("InDmgPRatPCap",L),N);
								end
							elseif SN > "INHEALPBONUS" then
								if SN < "INHEALPRATPCAPR" then
									if SN < "INHEALPRATPA" then
										if SN > "INHEALPPRAT" then
											if SN == "INHEALPRATP" then
												return CalcPercAB(CalcStat("InHealPRatPA",L),CalcStat("InHealPRatPB",L),CalcStat("InHealPRatPCap",L),N);
											else
												return 0;
											end
										elseif SN == "INHEALPPRAT" then
											return CalcRatAB(CalcStat("InHealPRatPA",L),CalcStat("InHealPRatPB",L),CalcStat("InHealPRatPCapR",L),N);
										else
											return 0;
										end
									elseif SN > "INHEALPRATPA" then
										if SN < "INHEALPRATPC" then
											if SN == "INHEALPRATPB" then
												return CalcStat("BRatRounded",L,"BRatLow");
											else
												return 0;
											end
										elseif SN > "INHEALPRATPC" then
											if SN == "INHEALPRATPCAP" then
												return 25;
											else
												return 0;
											end
										else
											return 0.5;
										end
									else
										return 75;
									end
								elseif SN > "INHEALPRATPCAPR" then
									if SN < "INSTRPOWER" then
										if SN > "INHEALT" then
											if SN == "INSTRMORALE" then
												if Lm <= 105 then
													return RoundDbl(4.04*L);
												else
													return CalcStat("ProgExtLowExpRnd",L,CalcStat("InstrMorale",105));
												end
											else
												return 0;
											end
										elseif SN == "INHEALT" then
											return StatLinInter("PntMPInHeal","TraitProg","ProgBInHeal","",L,N,0);
										else
											return 0;
										end
									elseif SN > "INSTRPOWER" then
										if SN < "ITEMPROGCLASSIC" then
											if SN == "ITEMPROG" then
												return {{1,25,79,80,200,225,300,349,350,399,400,449,450,499,500,549},{1,25,75,76,100,105,106,115,116,120,121,130,131,140,141,150}};
											else
												return 0;
											end
										elseif SN > "ITEMPROGCLASSIC" then
											if SN == "ITEMPROGVIRTUEMASTERY" then
												return {{0,1,25,79,80,200,225,300,349,350,400,449,450,499,500,549},{0,1,25,75,76,100,105,106,115,116,121,130,131,140,141,150}};
											else
												return 0;
											end
										else
											return {{1,79,80,200,225,300,349,350,399,400,449,450,499,500,549},{1,75,76,100,105,106,115,116,120,121,130,131,140,141,150}};
										end
									else
										if Lm <= 9 then
											return RoundDbl(0.95*L+12.6);
										elseif Lm <= 18 then
											return RoundDbl(1.95*L+3);
										elseif Lm <= 26 then
											return RoundDbl(2.95*L-15.55);
										elseif Lm <= 35 then
											return RoundDbl(3.95*L-42.15);
										elseif Lm <= 42 then
											return RoundDbl(4.95*L-77.7);
										elseif Lm <= 45 then
											return RoundDbl(5.95*L-120.35);
										elseif Lm <= 105 then
											return RoundDbl(6*L-124);
										else
											return CalcStat("ProgExtMpExpRnd",L,CalcStat("InstrPower",105));
										end
									end
								else
									return CalcStat("InHealPRatPB",L)*CalcStat("InHealPRatPC",L);
								end
							else
								return 0;
							end
						else
							return 1;
						end
					elseif SN > "ITEMPROGVIRTUEMORALE" then
						if SN < "LMSWSTAFFBUGMORALE" then
							if SN < "LMEAGLENOBILITYICPR" then
								if SN < "LIGHTMITT" then
									if SN < "LEVELCAP" then
										if SN > "ITEMPROGVITAL" then
											if SN == "L" then
												return L;
											else
												return 0;
											end
										elseif SN == "ITEMPROGVITAL" then
											return {{1,25,50,60,79,80,200,225,300,349,350,399,400,449,450,499},{1,25,50,60,75,76,100,105,106,115,116,120,121,130,131,140}};
										else
											return 0;
										end
									elseif SN > "LEVELCAP" then
										if SN < "LI2REFORGEILVL" then
											if SN == "LI2ILVLCAP" then
												return 495;
											else
												return 0;
											end
										elseif SN > "LI2REFORGEILVL" then
											if SN == "LIGHTMIT" then
												return CalcStat("DmgTypeMit",L,N);
											else
												return 0;
											end
										else
											if Lm <= 135 then
												return CalcStat("AwardILvlI",L);
											else
												return N;
											end
										end
									else
										return 140;
									end
								elseif SN > "LIGHTMITT" then
									if SN < "LINEAR1TOCAP" then
										if SN > "LIGHTNINGMIT" then
											if SN == "LIGHTNINGMITT" then
												return CalcStat("DmgTypeMitT",L,N);
											else
												return 0;
											end
										elseif SN == "LIGHTNINGMIT" then
											return CalcStat("DmgTypeMit",L,N);
										else
											return 0;
										end
									elseif SN > "LINEAR1TOCAP" then
										if SN < "LMANCIENTWISDOMWILL" then
											if SN == "LMANCIENTCRAFTARMOUR" then
												return -CalcStat("ArmourT",L,2.4);
											else
												return 0;
											end
										elseif SN > "LMANCIENTWISDOMWILL" then
											if SN == "LMCATMINTBEARARMOUR" then
												return CalcStat("BaseArmour",L,15);
											else
												return 0;
											end
										else
											if Lm <= 105 then
												return RoundDbl(1.1*L);
											else
												return CalcStat("ProgExtLowExpRnd",L,CalcStat("LmAncientWisdomWill",105));
											end
										end
									else
										return LinFmod(1,1,N,1,CalcStat("LevelCap",L),L);
									end
								else
									return CalcStat("DmgTypeMitT",L,N);
								end
							elseif SN > "LMEAGLENOBILITYICPR" then
								if SN < "LMPREPFORWARPETTACMAS" then
									if SN < "LMKNOWLEDGELMCRYRES" then
										if SN > "LMEVASIONRAVENARMOUR" then
											if SN == "LMHEARTYDIETMORALE" then
												return CalcStat("Morale",L,CalcStat("Trait12345Choice",N)*0.4);
											else
												return 0;
											end
										elseif SN == "LMEVASIONRAVENARMOUR" then
											return CalcStat("ArmourT",L,0.8);
										else
											return 0;
										end
									elseif SN > "LMKNOWLEDGELMCRYRES" then
										if SN < "LMKNOWLEDGELMSONGRES" then
											if SN == "LMKNOWLEDGELMPHYRES" then
												return -CalcStat("PhyResistT",L,0.6);
											else
												return 0;
											end
										elseif SN > "LMKNOWLEDGELMSONGRES" then
											if SN == "LMKNOWLEDGELMTACRES" then
												return -CalcStat("TacResistT",L,0.6);
											else
												return 0;
											end
										else
											return -CalcStat("SongResistT",L,0.6);
										end
									else
										return -CalcStat("CryResistT",L,0.6);
									end
								elseif SN > "LMPREPFORWARPETTACMAS" then
									if SN < "LMRAVENSHOTRAVWINGTACMIT" then
										if SN > "LMPREPFORWARTACMAS" then
											if SN == "LMRAVENSHOTRAVWINGFIXTACMIT" then
												return CalcStat("TacMitT",L,2);
											else
												return 0;
											end
										elseif SN == "LMPREPFORWARTACMAS" then
											return CalcStat("TacMasT",L,CalcStat("Trait12345Choice",N)*0.4);
										else
											return 0;
										end
									elseif SN > "LMRAVENSHOTRAVWINGTACMIT" then
										if SN < "LMRINGOFFIREEVADE" then
											if SN == "LMRINGOFFIREBLOCK" then
												return -CalcStat("BlockT",L,2.4);
											else
												return 0;
											end
										elseif SN > "LMRINGOFFIREEVADE" then
											if SN == "LMRINGOFFIREPARRY" then
												return -CalcStat("ParryT",L,2.4);
											else
												return 0;
											end
										else
											return -CalcStat("EvadeT",L,2.4);
										end
									else
										return CalcStat("TacMit",L,2);
									end
								else
									return CalcStat("TacMas",L,3.0);
								end
							else
								return CalcStat("ICPRT",L,0.8);
							end
						elseif SN > "LMSWSTAFFBUGMORALE" then
							if SN < "LOREMASTERCDBASEICPR" then
								if SN < "LOREMASTERCDARMOURTOOFMIT" then
									if SN < "LOEPASSIVE" then
										if SN > "LMSWSTAFFBUGPARRY" then
											if SN == "LOE" then
												return 2*N;
											else
												return 0;
											end
										elseif SN == "LMSWSTAFFBUGPARRY" then
											if Lm <= 105 then
												return RoundDbl(44.44*L);
											else
												return CalcStat("ProgExtHighLinExpRnd",L,CalcStat("LmSwStaffBugParry",105));
											end
										else
											return 0;
										end
									elseif SN > "LOEPASSIVE" then
										if SN < "LOREMASTERCDAGILITYTOEVADE" then
											if SN == "LOREMASTERCDAGILITYTOCRITHIT" then
												return 1;
											else
												return 0;
											end
										elseif SN > "LOREMASTERCDAGILITYTOEVADE" then
											if SN == "LOREMASTERCDAGILITYTOPARRY" then
												return 2;
											else
												return 0;
											end
										else
											return 3;
										end
									else
										if Lm <= 115 then
											return 0;
										elseif Lm <= 119 then
											return 20*L-2300;
										else
											return CalcStat("LoEPassive",119);
										end
									end
								elseif SN > "LOREMASTERCDARMOURTOOFMIT" then
									if SN < "LOREMASTERCDARMOURTYPE" then
										if SN > "LOREMASTERCDARMOURTOPHYMIT" then
											if SN == "LOREMASTERCDARMOURTOTACMIT" then
												return 0.2;
											else
												return 0;
											end
										elseif SN == "LOREMASTERCDARMOURTOPHYMIT" then
											return 1;
										else
											return 0;
										end
									elseif SN > "LOREMASTERCDARMOURTYPE" then
										if SN < "LOREMASTERCDBASEFATE" then
											if SN == "LOREMASTERCDBASEAGILITY" then
												return CalcStat("ClassBaseAgilityL",L);
											else
												return 0;
											end
										elseif SN > "LOREMASTERCDBASEFATE" then
											if SN == "LOREMASTERCDBASEICMR" then
												return CalcStat("ClassBaseICMRL",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseFate",L);
										end
									else
										return 1;
									end
								else
									return 0.2;
								end
							elseif SN > "LOREMASTERCDBASEICPR" then
								if SN < "LOREMASTERCDBASEWILL" then
									if SN < "LOREMASTERCDBASENCMR" then
										if SN > "LOREMASTERCDBASEMIGHT" then
											if SN == "LOREMASTERCDBASEMORALE" then
												return CalcStat("ClassBaseMorale",L);
											else
												return 0;
											end
										elseif SN == "LOREMASTERCDBASEMIGHT" then
											return CalcStat("ClassBaseMightM",L);
										else
											return 0;
										end
									elseif SN > "LOREMASTERCDBASENCMR" then
										if SN < "LOREMASTERCDBASEPOWER" then
											if SN == "LOREMASTERCDBASENCPR" then
												return CalcStat("ClassBaseNCPR",L);
											else
												return 0;
											end
										elseif SN > "LOREMASTERCDBASEPOWER" then
											if SN == "LOREMASTERCDBASEVITALITY" then
												return CalcStat("ClassBaseVitality",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBasePower",L);
										end
									else
										return CalcStat("ClassBaseNCMRL",L);
									end
								elseif SN > "LOREMASTERCDBASEWILL" then
									if SN < "LOREMASTERCDFATETOPOWER" then
										if SN < "LOREMASTERCDFATETOICMR" then
											if SN == "LOREMASTERCDFATETOCRITHIT" then
												return 1.5;
											else
												return 0;
											end
										elseif SN > "LOREMASTERCDFATETOICMR" then
											if SN == "LOREMASTERCDFATETONCPR" then
												return 0.05;
											else
												return 0;
											end
										else
											return 0.025;
										end
									elseif SN > "LOREMASTERCDFATETOPOWER" then
										if SN < "LOREMASTERCDFATETOTACMIT" then
											if SN == "LOREMASTERCDFATETORESIST" then
												return 0.5;
											else
												return 0;
											end
										elseif SN > "LOREMASTERCDFATETOTACMIT" then
											if SN == "LOREMASTERCDHASPOWER" then
												return 1;
											else
												return 0;
											end
										else
											return 0.5;
										end
									else
										return 1;
									end
								else
									return CalcStat("ClassBaseWillH",L);
								end
							else
								return CalcStat("ClassBaseICPR",L);
							end
						else
							if Lm <= 105 then
								return RoundDbl(LinFmod(1,16.2,696.9,1,105,L));
							else
								return CalcStat("ProgExtLowExpRnd",L,CalcStat("LmSwStaffBugMorale",105));
							end
						end
					else
						return {{0,1,2,50,80,200,225,300,349,350,399,400,449,450,499,500},{0,1,2,50,76,100,105,106,115,116,120,121,130,131,140,141}};
					end
				elseif SN > "LOREMASTERCDMIGHTTOBLOCK" then
					if SN < "MARINERCDBASEVITALITY" then
						if SN < "MANRDPSVONEWILL" then
							if SN < "LVLBONUSPHYDMG" then
								if SN < "LOREMASTERCDVITALITYTOTACMIT" then
									if SN < "LOREMASTERCDTACMASTOOUTHEAL" then
										if SN > "LOREMASTERCDMIGHTTOPARRY" then
											if SN == "LOREMASTERCDPHYMITTOOFMIT" then
												return 1;
											else
												return 0;
											end
										elseif SN == "LOREMASTERCDMIGHTTOPARRY" then
											return 2;
										else
											return 0;
										end
									elseif SN > "LOREMASTERCDTACMASTOOUTHEAL" then
										if SN < "LOREMASTERCDVITALITYTONCMR" then
											if SN == "LOREMASTERCDVITALITYTOMORALE" then
												return 4;
											else
												return 0;
											end
										elseif SN > "LOREMASTERCDVITALITYTONCMR" then
											if SN == "LOREMASTERCDVITALITYTORESIST" then
												return 0.5;
											else
												return 0;
											end
										else
											return 0.12;
										end
									else
										return 1;
									end
								elseif SN > "LOREMASTERCDVITALITYTOTACMIT" then
									if SN < "LOREMASTERCDWILLTORESIST" then
										if SN > "LOREMASTERCDWILLTOEVADE" then
											if SN == "LOREMASTERCDWILLTOFINESSE" then
												return 1;
											else
												return 0;
											end
										elseif SN == "LOREMASTERCDWILLTOEVADE" then
											return 1;
										else
											return 0;
										end
									elseif SN > "LOREMASTERCDWILLTORESIST" then
										if SN < "LOREMASTERCDWILLTOTACMIT" then
											if SN == "LOREMASTERCDWILLTOTACMAS" then
												return 3;
											else
												return 0;
											end
										elseif SN > "LOREMASTERCDWILLTOTACMIT" then
											if SN == "LVLBONUSMORRES" then
												return 0.1;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return 2;
									end
								else
									return 0.5;
								end
							elseif SN > "LVLBONUSPHYDMG" then
								if SN < "MAIN" then
									if SN < "LVLBONUSTACDMG" then
										if SN > "LVLBONUSPOWRES" then
											if SN == "LVLBONUSRUNEOFRES" then
												if Lm <= 104 then
													return LinFmod(1,5,206.0766,1,104,L)*N;
												elseif Lm <= 105 then
													return 600*N;
												elseif Lm <= 106 then
													return ExpFmod(CalcStat("LvlBonusRuneofRes",105,N),106,10,L,nil);
												elseif Lm <= 115 then
													return ExpFmod(CalcStat("LvlBonusRuneofRes",106,N),107,5.5,L,nil);
												elseif Lm <= 116 then
													return ExpFmod(CalcStat("LvlBonusRuneofRes",115,N),116,20,L,nil);
												elseif Lm <= 120 then
													return ExpFmod(CalcStat("LvlBonusRuneofRes",116,N),117,10,L,nil);
												elseif Lm <= 121 then
													return ExpFmod(CalcStat("LvlBonusRuneofRes",120,N),121,20,L,nil);
												elseif Lm <= 130 then
													return ExpFmod(CalcStat("LvlBonusRuneofRes",121,N),122,5.5,L,nil);
												elseif Lm <= 131 then
													return ExpFmod(CalcStat("LvlBonusRuneofRes",130,N),131,20,L,nil);
												elseif Lm <= 140 then
													return ExpFmod(CalcStat("LvlBonusRuneofRes",131,N),132,5.5,L,nil);
												else
													return CalcStat("LvlBonusRuneofRes",140,N);
												end
											else
												return 0;
											end
										elseif SN == "LVLBONUSPOWRES" then
											return CalcStat("SkillPowerCost",L,N);
										else
											return 0;
										end
									elseif SN > "LVLBONUSTACDMG" then
										if SN < "LVLEXPCOSTTOT" then
											if SN == "LVLEXPCOST" then
												if Lm <= 1 then
													return 0;
												elseif Lm <= 5 then
													return RoundDbl(12.5*L*L+12.5666666666667*L+24.8666666666667);
												elseif Lm <= 10 then
													return RoundDbl(33.8*L*L-179.48*L+452.6);
												elseif Lm <= 15 then
													return RoundDbl(55.05*L*L-583.77*L+2370.5);
												elseif Lm <= 20 then
													return RoundDbl(76.2*L*L-1196.96*L+6809);
												elseif Lm <= 25 then
													return RoundDbl(97.4*L*L-2023*L+14849.8);
												elseif Lm <= 30 then
													return RoundDbl(118.7*L*L-3066.02 *L+27612.8);
												elseif Lm <= 35 then
													return RoundDbl(139.95*L*L-4319.23*L+46084.1);
												elseif Lm <= 40 then
													return RoundDbl(161.2*L*L-5785.04*L+71356.2);
												elseif Lm <= 45 then
													return RoundDbl(182.5*L*L-7467.38*L+104569.8);
												elseif Lm <= 50 then
													return RoundDbl(203.8*L*L-9363.48*L+146761.8);
												elseif Lm <= 55 then
													return RoundDbl(225.05*L*L-11467.77*L+198851.3);
												elseif Lm <= 60 then
													return RoundDbl(246.3*L*L-13784.46*L+261988);
												elseif Lm <= 70 then
													return RoundDbl(ExpFmod(CalcStat("LvlExpCost",60),61,5.071,L,nil,3.485));
												elseif Lm <= 75 then
													return RoundDbl(ExpFmod(CalcStat("LvlExpCost",70),71,5.072,L,nil,-0.95));
												else
													return ExpFmod(CalcStat("LvlExpCost",75),76,5,L,0,-0.5);
												end
											else
												return 0;
											end
										elseif SN > "LVLEXPCOSTTOT" then
											if SN == "LVLTOILVL" then
												if Lm <= 106 then
													return LinFmod(1,225,300,105,106,L);
												elseif Lm <= 115 then
													return LinFmod(1,300,349,106,115,L);
												elseif Lm <= 116 then
													return LinFmod(1,349,350,115,116,L);
												elseif Lm <= 120 then
													return LinFmod(1,350,399,116,120,L);
												elseif Lm <= 121 then
													return LinFmod(1,399,400,120,121,L);
												elseif Lm <= 130 then
													return LinFmod(1,400,449,121,130,L);
												elseif Lm <= 131 then
													return LinFmod(1,449,450,130,131,L);
												elseif Lm <= 140 then
													return LinFmod(1,450,499,131,140,L);
												elseif Lm <= 141 then
													return LinFmod(1,499,500,140,141,L);
												else
													return LinFmod(1,500,549,141,150,L);
												end
											else
												return 0;
											end
										else
											if Lm <= 1 then
												return 0;
											else
												return CalcStat("LvlExpCostTot",L-1)+CalcStat("LvlExpCost",L);
											end
										end
									else
										return 0.1;
									end
								elseif SN > "MAIN" then
									if SN < "MANEASILYINSPINHEALP" then
										if SN > "MAINT" then
											if SN == "MANDIMMANKINDWILL" then
												return -CalcStat("WillT",L,0.4);
											else
												return 0;
											end
										elseif SN == "MAINT" then
											return RoundDblDown(StatLinInter("PntMPMain","TraitProg","ProgBMain","",L,N,0));
										else
											return 0;
										end
									elseif SN > "MANEASILYINSPINHEALP" then
										if SN < "MANGIFTOFMENFATE" then
											if SN == "MANFOURTHAGEWILL" then
												return CalcStat("WillT",L,1.0);
											else
												return 0;
											end
										elseif SN > "MANGIFTOFMENFATE" then
											if SN == "MANRDPSVONENAME" then
												return "Man of the Fourth Age";
											else
												return 0;
											end
										else
											return CalcStat("FateT",L,1.0);
										end
									else
										return 5;
									end
								else
									return RoundDblDown(StatLinInter("PntMPMain","ItemProg","ProgBMain","",L,N,0));
								end
							else
								return 0.1;
							end
						elseif SN > "MANRDPSVONEWILL" then
							if SN < "MARINERCDAGILITYTOPHYMAS" then
								if SN < "MANRDTRAITMIGHT" then
									if SN < "MANRDPSVTWONAME" then
										if SN > "MANRDPSVTWOBLOCK" then
											if SN == "MANRDPSVTWOEVADE" then
												return CalcStat("BalanceOfManEvade",L);
											else
												return 0;
											end
										elseif SN == "MANRDPSVTWOBLOCK" then
											return CalcStat("BalanceOfManBlock",L);
										else
											return 0;
										end
									elseif SN > "MANRDPSVTWONAME" then
										if SN < "MANRDTRAITFATE" then
											if SN == "MANRDPSVTWOPARRY" then
												return CalcStat("BalanceOfManParry",L);
											else
												return 0;
											end
										elseif SN > "MANRDTRAITFATE" then
											if SN == "MANRDTRAITINHEALP" then
												return CalcStat("ManEasilyInspInHealP",L);
											else
												return 0;
											end
										else
											return CalcStat("ManGiftOfMenFate",L);
										end
									else
										return "Balance of Man";
									end
								elseif SN > "MANRDTRAITMIGHT" then
									if SN < "MARINERCDAGILITYTOCRITHIT" then
										if SN > "MANRDTRAITWILL" then
											if SN == "MANSTRONGMENMIGHT" then
												return CalcStat("MightT",L,1.0);
											else
												return 0;
											end
										elseif SN == "MANRDTRAITWILL" then
											return CalcStat("ManDimMankindWill",L);
										else
											return 0;
										end
									elseif SN > "MARINERCDAGILITYTOCRITHIT" then
										if SN < "MARINERCDAGILITYTOFINESSE" then
											if SN == "MARINERCDAGILITYTOEVADE" then
												return 4;
											else
												return 0;
											end
										elseif SN > "MARINERCDAGILITYTOFINESSE" then
											if SN == "MARINERCDAGILITYTOPARRY" then
												return 2;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return 4;
									end
								else
									return CalcStat("ManStrongMenMight",L);
								end
							elseif SN > "MARINERCDAGILITYTOPHYMAS" then
								if SN < "MARINERCDBASEICMR" then
									if SN < "MARINERCDARMOURTOTACMIT" then
										if SN > "MARINERCDARMOURTOOFMIT" then
											if SN == "MARINERCDARMOURTOPHYMIT" then
												return 1;
											else
												return 0;
											end
										elseif SN == "MARINERCDARMOURTOOFMIT" then
											return 0.2;
										else
											return 0;
										end
									elseif SN > "MARINERCDARMOURTOTACMIT" then
										if SN < "MARINERCDBASEAGILITY" then
											if SN == "MARINERCDARMOURTYPE" then
												return 2;
											else
												return 0;
											end
										elseif SN > "MARINERCDBASEAGILITY" then
											if SN == "MARINERCDBASEFATE" then
												return CalcStat("ClassBaseFate",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseAgilityM",L);
										end
									else
										return 0.2;
									end
								elseif SN > "MARINERCDBASEICMR" then
									if SN < "MARINERCDBASEMORALE" then
										if SN > "MARINERCDBASEICPR" then
											if SN == "MARINERCDBASEMIGHT" then
												return CalcStat("ClassBaseMightM",L);
											else
												return 0;
											end
										elseif SN == "MARINERCDBASEICPR" then
											return CalcStat("ClassBaseICPR",L);
										else
											return 0;
										end
									elseif SN > "MARINERCDBASEMORALE" then
										if SN < "MARINERCDBASENCPR" then
											if SN == "MARINERCDBASENCMR" then
												return CalcStat("ClassBaseNCMRL",L);
											else
												return 0;
											end
										elseif SN > "MARINERCDBASENCPR" then
											if SN == "MARINERCDBASEPOWER" then
												return CalcStat("ClassBasePower",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseNCPR",L);
										end
									else
										return CalcStat("ClassBaseMorale",L);
									end
								else
									return CalcStat("ClassBaseICMRL",L);
								end
							else
								return 3;
							end
						else
							return CalcStat("ManFourthAgeWill",L);
						end
					elseif SN > "MARINERCDBASEVITALITY" then
						if SN < "MINCALLEARENDILLIGHTMIT" then
							if SN < "MARINERCDVITALITYTONCMR" then
								if SN < "MARINERCDMIGHTTOFINESSE" then
									if SN < "MARINERCDFATETOPOWER" then
										if SN > "MARINERCDBASEWILL" then
											if SN == "MARINERCDFATETONCPR" then
												return 0.07;
											else
												return 0;
											end
										elseif SN == "MARINERCDBASEWILL" then
											return CalcStat("ClassBaseWillM",L);
										else
											return 0;
										end
									elseif SN > "MARINERCDFATETOPOWER" then
										if SN < "MARINERCDMIGHTTOCRITHIT" then
											if SN == "MARINERCDHASPOWER" then
												return 1;
											else
												return 0;
											end
										elseif SN > "MARINERCDMIGHTTOCRITHIT" then
											if SN == "MARINERCDMIGHTTOEVADE" then
												return 2;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return 1;
									end
								elseif SN > "MARINERCDMIGHTTOFINESSE" then
									if SN < "MARINERCDPHYMITTOOFMIT" then
										if SN > "MARINERCDMIGHTTOPARRY" then
											if SN == "MARINERCDMIGHTTOPHYMAS" then
												return 6;
											else
												return 0;
											end
										elseif SN == "MARINERCDMIGHTTOPARRY" then
											return 4;
										else
											return 0;
										end
									elseif SN > "MARINERCDPHYMITTOOFMIT" then
										if SN < "MARINERCDVITALITYTOICMR" then
											if SN == "MARINERCDTACMASTOOUTHEAL" then
												return 1;
											else
												return 0;
											end
										elseif SN > "MARINERCDVITALITYTOICMR" then
											if SN == "MARINERCDVITALITYTOMORALE" then
												return 4;
											else
												return 0;
											end
										else
											return 0.012;
										end
									else
										return 1;
									end
								else
									return 1;
								end
							elseif SN > "MARINERCDVITALITYTONCMR" then
								if SN < "MARINERCDWILLTOTACMIT" then
									if SN < "MARINERCDWILLTOPARRY" then
										if SN > "MARINERCDWILLTOFINESSE" then
											if SN == "MARINERCDWILLTOOUTHEAL" then
												return 2;
											else
												return 0;
											end
										elseif SN == "MARINERCDWILLTOFINESSE" then
											return 2;
										else
											return 0;
										end
									elseif SN > "MARINERCDWILLTOPARRY" then
										if SN < "MARINERCDWILLTOPHYMIT" then
											if SN == "MARINERCDWILLTOPHYMAS" then
												return 2;
											else
												return 0;
											end
										elseif SN > "MARINERCDWILLTOPHYMIT" then
											if SN == "MARINERCDWILLTORESIST" then
												return 3;
											else
												return 0;
											end
										else
											return 2;
										end
									else
										return 1;
									end
								elseif SN > "MARINERCDWILLTOTACMIT" then
									if SN < "MASTERYT" then
										if SN > "MASTERY" then
											if SN == "MASTERYOLD" then
												return CalcStat("Mastery",L,N);
											else
												return 0;
											end
										elseif SN == "MASTERY" then
											return StatLinInter("PntMPMastery","ItemProg","ProgBMastery","",L,N,0);
										else
											return 0;
										end
									elseif SN > "MASTERYT" then
										if SN < "MIGHT" then
											if SN == "MATHOMLVLTOILVL" then
												return CalcStat("AwardLvlToILvl",L);
											else
												return 0;
											end
										elseif SN > "MIGHT" then
											if SN == "MIGHTT" then
												return CalcStat("MainT",L,N);
											else
												return 0;
											end
										else
											return CalcStat("Main",L,N);
										end
									else
										return StatLinInter("PntMPMastery","TraitProg","ProgBMastery","",L,N,0);
									end
								else
									return 2;
								end
							else
								return 0.12;
							end
						elseif SN > "MINCALLEARENDILLIGHTMIT" then
							if SN < "MINSTRELCDARMOURTOPHYMIT" then
								if SN < "MINECHOESBATTLERESIST" then
									if SN < "MINCOMPOSURERESIST" then
										if SN > "MINCALLOROMELIGHTMIT" then
											if SN == "MINCALLOROMEMELLIGHTMIT" then
												return -CalcStat("LightMitT",L,1.4);
											else
												return 0;
											end
										elseif SN == "MINCALLOROMELIGHTMIT" then
											return -CalcStat("LightMitT",L,1.2);
										else
											return 0;
										end
									elseif SN > "MINCOMPOSURERESIST" then
										if SN < "MINCOURAGERESIST" then
											if SN == "MINCOMPOSURETACMIT" then
												return CalcStat("TacMitT",L,1.0);
											else
												return 0;
											end
										elseif SN > "MINCOURAGERESIST" then
											if SN == "MINECHOESBATTLECRITDEF" then
												return -CalcStat("CritDefT",L,2.0);
											else
												return 0;
											end
										else
											return CalcStat("FearResistT",L,1.0);
										end
									else
										return CalcStat("ResistT",L,1.6);
									end
								elseif SN > "MINECHOESBATTLERESIST" then
									if SN < "MINSTRELCDAGILITYTOCRITHIT" then
										if SN > "MINENDMORALE" then
											if SN == "MINPIERCINGBALFINESSE" then
												return CalcStat("FinesseT",L,CalcStat("Trait12345Choice",N)*0.4);
											else
												return 0;
											end
										elseif SN == "MINENDMORALE" then
											return CalcStat("MoraleT",L,CalcStat("Trait12345Choice",N)*0.8);
										else
											return 0;
										end
									elseif SN > "MINSTRELCDAGILITYTOCRITHIT" then
										if SN < "MINSTRELCDAGILITYTOPARRY" then
											if SN == "MINSTRELCDAGILITYTOEVADE" then
												return 3;
											else
												return 0;
											end
										elseif SN > "MINSTRELCDAGILITYTOPARRY" then
											if SN == "MINSTRELCDARMOURTOOFMIT" then
												return 0.2;
											else
												return 0;
											end
										else
											return 2;
										end
									else
										return 1;
									end
								else
									return -CalcStat("SongResistT",L,1.0);
								end
							elseif SN > "MINSTRELCDARMOURTOPHYMIT" then
								if SN < "MINSTRELCDBASEMIGHT" then
									if SN < "MINSTRELCDBASEAGILITY" then
										if SN > "MINSTRELCDARMOURTOTACMIT" then
											if SN == "MINSTRELCDARMOURTYPE" then
												return 1;
											else
												return 0;
											end
										elseif SN == "MINSTRELCDARMOURTOTACMIT" then
											return 0.2;
										else
											return 0;
										end
									elseif SN > "MINSTRELCDBASEAGILITY" then
										if SN < "MINSTRELCDBASEICMR" then
											if SN == "MINSTRELCDBASEFATE" then
												return CalcStat("ClassBaseFate",L);
											else
												return 0;
											end
										elseif SN > "MINSTRELCDBASEICMR" then
											if SN == "MINSTRELCDBASEICPR" then
												return CalcStat("ClassBaseICPR",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseICMRL",L);
										end
									else
										return CalcStat("ClassBaseAgilityM",L);
									end
								elseif SN > "MINSTRELCDBASEMIGHT" then
									if SN < "MINSTRELCDBASEPOWER" then
										if SN < "MINSTRELCDBASENCMR" then
											if SN == "MINSTRELCDBASEMORALE" then
												return CalcStat("ClassBaseMorale",L);
											else
												return 0;
											end
										elseif SN > "MINSTRELCDBASENCMR" then
											if SN == "MINSTRELCDBASENCPR" then
												return CalcStat("ClassBaseNCPR",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseNCMRL",L);
										end
									elseif SN > "MINSTRELCDBASEPOWER" then
										if SN < "MINSTRELCDBASEWILL" then
											if SN == "MINSTRELCDBASEVITALITY" then
												return CalcStat("ClassBaseVitality",L);
											else
												return 0;
											end
										elseif SN > "MINSTRELCDBASEWILL" then
											if SN == "MINSTRELCDCANBLOCK" then
												if Lm <= 19 then
													return 0;
												else
													return 1;
												end
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseWillH",L);
										end
									else
										return CalcStat("ClassBasePower",L);
									end
								else
									return CalcStat("ClassBaseMightL",L);
								end
							else
								return 1;
							end
						else
							return -CalcStat("LightMitT",L,1.2);
						end
					else
						return CalcStat("ClassBaseVitality",L);
					end
				else
					return 3;
				end
			else
				return CalcStat("ClassBaseFate",L);
			end
		else
			return CalcStat("CreepBatPromVitalP",L);
		end
	elseif SN > "MINSTRELCDFATETOCRITHIT" then
		if SN < "TPENCHOICE" then
			if SN < "PNTMPMORALEVIRTUES" then
				if SN < "PARTBPEPRATP" then
					if SN < "MITMEDIUMPRATPCAPR" then
						if SN < "MINTOTRESIST" then
							if SN < "MINSTRELCDVITALITYTOTACMIT" then
								if SN < "MINSTRELCDMIGHTTOBLOCK" then
									if SN < "MINSTRELCDFATETOPOWER" then
										if SN > "MINSTRELCDFATETOICMR" then
											if SN == "MINSTRELCDFATETONCPR" then
												return 0.05;
											else
												return 0;
											end
										elseif SN == "MINSTRELCDFATETOICMR" then
											return 0.025;
										else
											return 0;
										end
									elseif SN > "MINSTRELCDFATETOPOWER" then
										if SN < "MINSTRELCDFATETOTACMIT" then
											if SN == "MINSTRELCDFATETORESIST" then
												return 0.5;
											else
												return 0;
											end
										elseif SN > "MINSTRELCDFATETOTACMIT" then
											if SN == "MINSTRELCDHASPOWER" then
												return 1;
											else
												return 0;
											end
										else
											return 0.5;
										end
									else
										return 1;
									end
								elseif SN > "MINSTRELCDMIGHTTOBLOCK" then
									if SN < "MINSTRELCDTACMASTOOUTHEAL" then
										if SN > "MINSTRELCDMIGHTTOPARRY" then
											if SN == "MINSTRELCDPHYMITTOOFMIT" then
												return 1;
											else
												return 0;
											end
										elseif SN == "MINSTRELCDMIGHTTOPARRY" then
											return 2;
										else
											return 0;
										end
									elseif SN > "MINSTRELCDTACMASTOOUTHEAL" then
										if SN < "MINSTRELCDVITALITYTONCMR" then
											if SN == "MINSTRELCDVITALITYTOMORALE" then
												return 4;
											else
												return 0;
											end
										elseif SN > "MINSTRELCDVITALITYTONCMR" then
											if SN == "MINSTRELCDVITALITYTORESIST" then
												return 0.5;
											else
												return 0;
											end
										else
											return 0.12;
										end
									else
										return 1;
									end
								else
									return 3;
								end
							elseif SN > "MINSTRELCDVITALITYTOTACMIT" then
								if SN < "MINTIMEECHOESBATTLERESIST" then
									if SN < "MINSTRELCDWILLTORESIST" then
										if SN > "MINSTRELCDWILLTOEVADE" then
											if SN == "MINSTRELCDWILLTOFINESSE" then
												return 1;
											else
												return 0;
											end
										elseif SN == "MINSTRELCDWILLTOEVADE" then
											return 1;
										else
											return 0;
										end
									elseif SN > "MINSTRELCDWILLTORESIST" then
										if SN < "MINSTRELCDWILLTOTACMIT" then
											if SN == "MINSTRELCDWILLTOTACMAS" then
												return 3;
											else
												return 0;
											end
										elseif SN > "MINSTRELCDWILLTOTACMIT" then
											if SN == "MINTACMAS" then
												return CalcStat("TacMasT",L,CalcStat("Trait12345Choice",N)*0.4);
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return 2;
									end
								elseif SN > "MINTIMEECHOESBATTLERESIST" then
									if SN < "MINTOTFATE" then
										if SN > "MINTOTCRITHIT" then
											if SN == "MINTOTCRITHITSEL" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({0,0,0,0.4,0.6,0},L);
												end
											else
												return 0;
											end
										elseif SN == "MINTOTCRITHIT" then
											return CalcStat("CritHitT",L,CalcStat("MinToTCritHitSel",N));
										else
											return 0;
										end
									elseif SN > "MINTOTFATE" then
										if SN < "MINTOTFINESSE" then
											if SN == "MINTOTFATESEL" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({0.2,0.3,0.4,0.5,0.6,0},L);
												end
											else
												return 0;
											end
										elseif SN > "MINTOTFINESSE" then
											if SN == "MINTOTFINESSESEL" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({0,0,0.2,0.4,0.6,0},L);
												end
											else
												return 0;
											end
										else
											return CalcStat("FinesseT",L,CalcStat("MinToTFinesseSel",N));
										end
									else
										return CalcStat("FateT",L,CalcStat("MinToTFateSel",N));
									end
								else
									return -CalcStat("SongResistT",L,0.6);
								end
							else
								return 0.5;
							end
						elseif SN > "MINTOTRESIST" then
							if SN < "MITLIGHTPPRAT" then
								if SN < "MITHEAVYPRATPA" then
									if SN < "MINTOTVITALITYSEL" then
										if SN > "MINTOTRESISTSEL" then
											if SN == "MINTOTVITALITY" then
												return CalcStat("VitalityT",L,CalcStat("MinToTVitalitySel",N));
											else
												return 0;
											end
										elseif SN == "MINTOTRESISTSEL" then
											if Lm <= 0 then
												return 0;
											else
												return DataTableValue({0,0.2,0.3,0.4,0.5,0},L);
											end
										else
											return 0;
										end
									elseif SN > "MINTOTVITALITYSEL" then
										if SN < "MITHEAVYPPRAT" then
											if SN == "MITHEAVYPBONUS" then
												return 0;
											else
												return 0;
											end
										elseif SN > "MITHEAVYPPRAT" then
											if SN == "MITHEAVYPRATP" then
												return CalcPercAB(CalcStat("MitHeavyPRatPA",L),CalcStat("MitHeavyPRatPB",L),CalcStat("MitHeavyPRatPCap",L),N);
											else
												return 0;
											end
										else
											return CalcRatAB(CalcStat("MitHeavyPRatPA",L),CalcStat("MitHeavyPRatPB",L),CalcStat("MitHeavyPRatPCapR",L),N);
										end
									else
										if Lm <= 0 then
											return 0;
										else
											return DataTableValue({0,0,0,0,0.4,0},L);
										end
									end
								elseif SN > "MITHEAVYPRATPA" then
									if SN < "MITHEAVYPRATPCAP" then
										if SN > "MITHEAVYPRATPB" then
											if SN == "MITHEAVYPRATPC" then
												return 0.5;
											else
												return 0;
											end
										elseif SN == "MITHEAVYPRATPB" then
											return CalcStat("BRatRounded",L,"BRatMitHeavy");
										else
											return 0;
										end
									elseif SN > "MITHEAVYPRATPCAP" then
										if SN < "MITIGATION" then
											if SN == "MITHEAVYPRATPCAPR" then
												return CalcStat("MitHeavyPRatPB",L)*CalcStat("MitHeavyPRatPC",L);
											else
												return 0;
											end
										elseif SN > "MITIGATION" then
											if SN == "MITLIGHTPBONUS" then
												return 0;
											else
												return 0;
											end
										else
											return StatLinInter("PntMPMitigation","ItemProg","ProgBMitigation","",L,N,0);
										end
									else
										return 60;
									end
								else
									return 180;
								end
							elseif SN > "MITLIGHTPPRAT" then
								if SN < "MITMEDIUMPBONUS" then
									if SN < "MITLIGHTPRATPB" then
										if SN > "MITLIGHTPRATP" then
											if SN == "MITLIGHTPRATPA" then
												return 120;
											else
												return 0;
											end
										elseif SN == "MITLIGHTPRATP" then
											return CalcPercAB(CalcStat("MitLightPRatPA",L),CalcStat("MitLightPRatPB",L),CalcStat("MitLightPRatPCap",L),N);
										else
											return 0;
										end
									elseif SN > "MITLIGHTPRATPB" then
										if SN < "MITLIGHTPRATPCAP" then
											if SN == "MITLIGHTPRATPC" then
												return 0.5;
											else
												return 0;
											end
										elseif SN > "MITLIGHTPRATPCAP" then
											if SN == "MITLIGHTPRATPCAPR" then
												return CalcStat("MitLightPRatPB",L)*CalcStat("MitLightPRatPC",L);
											else
												return 0;
											end
										else
											return 40;
										end
									else
										return CalcStat("BRatRounded",L,"BRatMitLight");
									end
								elseif SN > "MITMEDIUMPBONUS" then
									if SN < "MITMEDIUMPRATPA" then
										if SN > "MITMEDIUMPPRAT" then
											if SN == "MITMEDIUMPRATP" then
												return CalcPercAB(CalcStat("MitMediumPRatPA",L),CalcStat("MitMediumPRatPB",L),CalcStat("MitMediumPRatPCap",L),N);
											else
												return 0;
											end
										elseif SN == "MITMEDIUMPPRAT" then
											return CalcRatAB(CalcStat("MitMediumPRatPA",L),CalcStat("MitMediumPRatPB",L),CalcStat("MitMediumPRatPCapR",L),N);
										else
											return 0;
										end
									elseif SN > "MITMEDIUMPRATPA" then
										if SN < "MITMEDIUMPRATPC" then
											if SN == "MITMEDIUMPRATPB" then
												return CalcStat("BRatRounded",L,"BRatMitMedium");
											else
												return 0;
											end
										elseif SN > "MITMEDIUMPRATPC" then
											if SN == "MITMEDIUMPRATPCAP" then
												return 50;
											else
												return 0;
											end
										else
											return 0.5;
										end
									else
										return 150;
									end
								else
									return 0;
								end
							else
								return CalcRatAB(CalcStat("MitLightPRatPA",L),CalcStat("MitLightPRatPB",L),CalcStat("MitLightPRatPCapR",L),N);
							end
						else
							return CalcStat("ResistT",L,CalcStat("MinToTResistSel",N));
						end
					elseif SN > "MITMEDIUMPRATPCAPR" then
						if SN < "OUTHEALT" then
							if SN < "OUTDMGPRATPA" then
								if SN < "NCMRT" then
									if SN < "MORALET" then
										if SN > "MORALE" then
											if SN == "MORALEADJ" then
												if Lm <= 25 then
													return 0.5;
												elseif Lm <= 50 then
													return 0.6;
												elseif Lm <= 60 then
													return 0.7;
												elseif Lm <= 79 then
													return 0.8;
												elseif Lm <= 80 then
													return 0.9;
												else
													return 1;
												end
											else
												return 0;
											end
										elseif SN == "MORALE" then
											return StatLinInter("PntMPMorale","ItemProgVital","ProgBMorale","MoraleAdj",L,N,0);
										else
											return 0;
										end
									elseif SN > "MORALET" then
										if SN < "N" then
											if SN == "MORALETADJ" then
												if Lm <= 25 then
													return 0.5;
												elseif Lm <= 50 then
													return 0.6;
												elseif Lm <= 60 then
													return 0.7;
												elseif Lm <= 65 then
													return 0.8;
												elseif Lm <= 75 then
													return 0.9;
												else
													return 1;
												end
											else
												return 0;
											end
										elseif SN > "N" then
											if SN == "NCMR" then
												return StatLinInter("PntMPNCMR","ItemProgVital","ProgBNCMR","",L,N,1);
											else
												return 0;
											end
										else
											return N;
										end
									else
										return StatLinInter("PntMPMorale","TraitProgVital","ProgBMorale","MoraleTAdj",L,N,0);
									end
								elseif SN > "NCMRT" then
									if SN < "OFFSET" then
										if SN > "NCPR" then
											if SN == "NCPRT" then
												return StatLinInter("PntMPNCPR","TraitProgVital","ProgBNCPR","",L,N,99);
											else
												return 0;
											end
										elseif SN == "NCPR" then
											return StatLinInter("PntMPNCPR","ItemProgClassic","ProgBNCPR","",L,N,99);
										else
											return 0;
										end
									elseif SN > "OFFSET" then
										if SN < "OUTDMGPPRAT" then
											if SN == "OUTDMGPBONUS" then
												return 0;
											else
												return 0;
											end
										elseif SN > "OUTDMGPPRAT" then
											if SN == "OUTDMGPRATP" then
												return CalcPercAB(CalcStat("OutDmgPRatPA",L),CalcStat("OutDmgPRatPB",L),CalcStat("OutDmgPRatPCap",L),N);
											else
												return 0;
											end
										else
											return CalcRatAB(CalcStat("OutDmgPRatPA",L),CalcStat("OutDmgPRatPB",L),CalcStat("OutDmgPRatPCapR",L),N);
										end
									else
										return L+N;
									end
								else
									return StatLinInter("PntMPNCMR","TraitProgVital","ProgBNCMR","",L,N,1);
								end
							elseif SN > "OUTDMGPRATPA" then
								if SN < "OUTHEALPPRAT" then
									if SN < "OUTDMGPRATPCAP" then
										if SN > "OUTDMGPRATPB" then
											if SN == "OUTDMGPRATPC" then
												return 0.5;
											else
												return 0;
											end
										elseif SN == "OUTDMGPRATPB" then
											return CalcStat("BRatRounded",L,"BRatMedium");
										else
											return 0;
										end
									elseif SN > "OUTDMGPRATPCAP" then
										if SN < "OUTHEAL" then
											if SN == "OUTDMGPRATPCAPR" then
												return CalcStat("OutDmgPRatPB",L)*CalcStat("OutDmgPRatPC",L);
											else
												return 0;
											end
										elseif SN > "OUTHEAL" then
											if SN == "OUTHEALPBONUS" then
												return 0;
											else
												return 0;
											end
										else
											return StatLinInter("PntMPOutHeal","ItemProg","ProgBOutHeal","",L,N,0);
										end
									else
										return 200;
									end
								elseif SN > "OUTHEALPPRAT" then
									if SN < "OUTHEALPRATPB" then
										if SN > "OUTHEALPRATP" then
											if SN == "OUTHEALPRATPA" then
												return 210;
											else
												return 0;
											end
										elseif SN == "OUTHEALPRATP" then
											return CalcPercAB(CalcStat("OutHealPRatPA",L),CalcStat("OutHealPRatPB",L),CalcStat("OutHealPRatPCap",L),N);
										else
											return 0;
										end
									elseif SN > "OUTHEALPRATPB" then
										if SN < "OUTHEALPRATPCAP" then
											if SN == "OUTHEALPRATPC" then
												return 0.5;
											else
												return 0;
											end
										elseif SN > "OUTHEALPRATPCAP" then
											if SN == "OUTHEALPRATPCAPR" then
												return CalcStat("OutHealPRatPB",L)*CalcStat("OutHealPRatPC",L);
											else
												return 0;
											end
										else
											return 70;
										end
									else
										return CalcStat("BRatRounded",L,"BRatHigh");
									end
								else
									return CalcRatAB(CalcStat("OutHealPRatPA",L),CalcStat("OutHealPRatPB",L),CalcStat("OutHealPRatPCapR",L),N);
								end
							else
								return 600;
							end
						elseif SN > "OUTHEALT" then
							if SN < "PARTBLOCKMITPRATPA" then
								if SN < "PARRYPRATPC" then
									if SN < "PARRYPPRAT" then
										if SN > "PARRY" then
											if SN == "PARRYPBONUS" then
												return CalcStat("BPEPBonus",L);
											else
												return 0;
											end
										elseif SN == "PARRY" then
											return CalcStat("BPE",L,N);
										else
											return 0;
										end
									elseif SN > "PARRYPPRAT" then
										if SN < "PARRYPRATPA" then
											if SN == "PARRYPRATP" then
												return CalcStat("BPEPRatP",L,N);
											else
												return 0;
											end
										elseif SN > "PARRYPRATPA" then
											if SN == "PARRYPRATPB" then
												return CalcStat("BPEPRatPB",L);
											else
												return 0;
											end
										else
											return CalcStat("BPEPRatPA",L);
										end
									else
										return CalcStat("BPEPPRat",L,N);
									end
								elseif SN > "PARRYPRATPC" then
									if SN < "PARRYT" then
										if SN > "PARRYPRATPCAP" then
											if SN == "PARRYPRATPCAPR" then
												return CalcStat("BPEPRatPCapR",L);
											else
												return 0;
											end
										elseif SN == "PARRYPRATPCAP" then
											return CalcStat("BPEPRatPCap",L);
										else
											return 0;
										end
									elseif SN > "PARRYT" then
										if SN < "PARTBLOCKMITPPRAT" then
											if SN == "PARTBLOCKMITPBONUS" then
												return CalcStat("PartMitPBonus",L);
											else
												return 0;
											end
										elseif SN > "PARTBLOCKMITPPRAT" then
											if SN == "PARTBLOCKMITPRATP" then
												return CalcStat("PartMitPRatP",L,N);
											else
												return 0;
											end
										else
											return CalcStat("PartMitPPRat",L,N);
										end
									else
										return CalcStat("BPET",L,N);
									end
								else
									return CalcStat("BPEPRatPC",L);
								end
							elseif SN > "PARTBLOCKMITPRATPA" then
								if SN < "PARTBLOCKPRATP" then
									if SN < "PARTBLOCKMITPRATPCAP" then
										if SN > "PARTBLOCKMITPRATPB" then
											if SN == "PARTBLOCKMITPRATPC" then
												return CalcStat("PartMitPRatPC",L);
											else
												return 0;
											end
										elseif SN == "PARTBLOCKMITPRATPB" then
											return CalcStat("PartMitPRatPB",L);
										else
											return 0;
										end
									elseif SN > "PARTBLOCKMITPRATPCAP" then
										if SN < "PARTBLOCKPBONUS" then
											if SN == "PARTBLOCKMITPRATPCAPR" then
												return CalcStat("PartMitPRatPCapR",L);
											else
												return 0;
											end
										elseif SN > "PARTBLOCKPBONUS" then
											if SN == "PARTBLOCKPPRAT" then
												return CalcStat("PartBPEPPRat",L,N);
											else
												return 0;
											end
										else
											return CalcStat("PartBPEPBonus",L);
										end
									else
										return CalcStat("PartMitPRatPCap",L);
									end
								elseif SN > "PARTBLOCKPRATP" then
									if SN < "PARTBLOCKPRATPCAP" then
										if SN < "PARTBLOCKPRATPB" then
											if SN == "PARTBLOCKPRATPA" then
												return CalcStat("PartBPEPRatPA",L);
											else
												return 0;
											end
										elseif SN > "PARTBLOCKPRATPB" then
											if SN == "PARTBLOCKPRATPC" then
												return CalcStat("PartBPEPRatPC",L);
											else
												return 0;
											end
										else
											return CalcStat("PartBPEPRatPB",L);
										end
									elseif SN > "PARTBLOCKPRATPCAP" then
										if SN < "PARTBPEPBONUS" then
											if SN == "PARTBLOCKPRATPCAPR" then
												return CalcStat("PartBPEPRatPCapR",L);
											else
												return 0;
											end
										elseif SN > "PARTBPEPBONUS" then
											if SN == "PARTBPEPPRAT" then
												return CalcRatAB(CalcStat("PartBPEPRatPA",L),CalcStat("PartBPEPRatPB",L),CalcStat("PartBPEPRatPCapR",L),N);
											else
												return 0;
											end
										else
											return 0;
										end
									else
										return CalcStat("PartBPEPRatPCap",L);
									end
								else
									return CalcStat("PartBPEPRatP",L,N);
								end
							else
								return CalcStat("PartMitPRatPA",L);
							end
						else
							return StatLinInter("PntMPOutHeal","TraitProg","ProgBOutHeal","",L,N,0);
						end
					else
						return CalcStat("MitMediumPRatPB",L)*CalcStat("MitMediumPRatPC",L);
					end
				elseif SN > "PARTBPEPRATP" then
					if SN < "PHYDMGPRATPB" then
						if SN < "PARTMITPRATPCAP" then
							if SN < "PARTEVADEPBONUS" then
								if SN < "PARTEVADEMITPPRAT" then
									if SN < "PARTBPEPRATPC" then
										if SN > "PARTBPEPRATPA" then
											if SN == "PARTBPEPRATPB" then
												return CalcStat("BRatRounded",L,"BRatPartBPE");
											else
												return 0;
											end
										elseif SN == "PARTBPEPRATPA" then
											return 75;
										else
											return 0;
										end
									elseif SN > "PARTBPEPRATPC" then
										if SN < "PARTBPEPRATPCAPR" then
											if SN == "PARTBPEPRATPCAP" then
												return 25;
											else
												return 0;
											end
										elseif SN > "PARTBPEPRATPCAPR" then
											if SN == "PARTEVADEMITPBONUS" then
												return CalcStat("PartMitPBonus",L);
											else
												return 0;
											end
										else
											return CalcStat("PartBPEPRatPB",L)*CalcStat("PartBPEPRatPC",L);
										end
									else
										return 0.5;
									end
								elseif SN > "PARTEVADEMITPPRAT" then
									if SN < "PARTEVADEMITPRATPB" then
										if SN > "PARTEVADEMITPRATP" then
											if SN == "PARTEVADEMITPRATPA" then
												return CalcStat("PartMitPRatPA",L);
											else
												return 0;
											end
										elseif SN == "PARTEVADEMITPRATP" then
											return CalcStat("PartMitPRatP",L,N);
										else
											return 0;
										end
									elseif SN > "PARTEVADEMITPRATPB" then
										if SN < "PARTEVADEMITPRATPCAP" then
											if SN == "PARTEVADEMITPRATPC" then
												return CalcStat("PartMitPRatPC",L);
											else
												return 0;
											end
										elseif SN > "PARTEVADEMITPRATPCAP" then
											if SN == "PARTEVADEMITPRATPCAPR" then
												return CalcStat("PartMitPRatPCapR",L);
											else
												return 0;
											end
										else
											return CalcStat("PartMitPRatPCap",L);
										end
									else
										return CalcStat("PartMitPRatPB",L);
									end
								else
									return CalcStat("PartMitPPRat",L,N);
								end
							elseif SN > "PARTEVADEPBONUS" then
								if SN < "PARTEVADEPRATPCAPR" then
									if SN < "PARTEVADEPRATPA" then
										if SN > "PARTEVADEPPRAT" then
											if SN == "PARTEVADEPRATP" then
												return CalcStat("PartBPEPRatP",L,N);
											else
												return 0;
											end
										elseif SN == "PARTEVADEPPRAT" then
											return CalcStat("PartBPEPPRat",L,N);
										else
											return 0;
										end
									elseif SN > "PARTEVADEPRATPA" then
										if SN < "PARTEVADEPRATPC" then
											if SN == "PARTEVADEPRATPB" then
												return CalcStat("PartBPEPRatPB",L);
											else
												return 0;
											end
										elseif SN > "PARTEVADEPRATPC" then
											if SN == "PARTEVADEPRATPCAP" then
												return CalcStat("PartBPEPRatPCap",L);
											else
												return 0;
											end
										else
											return CalcStat("PartBPEPRatPC",L);
										end
									else
										return CalcStat("PartBPEPRatPA",L);
									end
								elseif SN > "PARTEVADEPRATPCAPR" then
									if SN < "PARTMITPRATP" then
										if SN > "PARTMITPBONUS" then
											if SN == "PARTMITPPRAT" then
												return CalcRatAB(CalcStat("PartMitPRatPA",L),CalcStat("PartMitPRatPB",L),CalcStat("PartMitPRatPCapR",L),N);
											else
												return 0;
											end
										elseif SN == "PARTMITPBONUS" then
											return 0.1;
										else
											return 0;
										end
									elseif SN > "PARTMITPRATP" then
										if SN < "PARTMITPRATPB" then
											if SN == "PARTMITPRATPA" then
												return 105;
											else
												return 0;
											end
										elseif SN > "PARTMITPRATPB" then
											if SN == "PARTMITPRATPC" then
												return 0.5;
											else
												return 0;
											end
										else
											return CalcStat("BRatRounded",L,"BRatPartBPE");
										end
									else
										return CalcPercAB(CalcStat("PartMitPRatPA",L),CalcStat("PartMitPRatPB",L),CalcStat("PartMitPRatPCap",L),N);
									end
								else
									return CalcStat("PartBPEPRatPCapR",L);
								end
							else
								return CalcStat("PartBPEPBonus",L);
							end
						elseif SN > "PARTMITPRATPCAP" then
							if SN < "PARTPARRYPRATPB" then
								if SN < "PARTPARRYMITPRATPC" then
									if SN < "PARTPARRYMITPPRAT" then
										if SN > "PARTMITPRATPCAPR" then
											if SN == "PARTPARRYMITPBONUS" then
												return CalcStat("PartMitPBonus",L);
											else
												return 0;
											end
										elseif SN == "PARTMITPRATPCAPR" then
											return CalcStat("PartMitPRatPB",L)*CalcStat("PartMitPRatPC",L);
										else
											return 0;
										end
									elseif SN > "PARTPARRYMITPPRAT" then
										if SN < "PARTPARRYMITPRATPA" then
											if SN == "PARTPARRYMITPRATP" then
												return CalcStat("PartMitPRatP",L,N);
											else
												return 0;
											end
										elseif SN > "PARTPARRYMITPRATPA" then
											if SN == "PARTPARRYMITPRATPB" then
												return CalcStat("PartMitPRatPB",L);
											else
												return 0;
											end
										else
											return CalcStat("PartMitPRatPA",L);
										end
									else
										return CalcStat("PartMitPPRat",L,N);
									end
								elseif SN > "PARTPARRYMITPRATPC" then
									if SN < "PARTPARRYPBONUS" then
										if SN > "PARTPARRYMITPRATPCAP" then
											if SN == "PARTPARRYMITPRATPCAPR" then
												return CalcStat("PartMitPRatPCapR",L);
											else
												return 0;
											end
										elseif SN == "PARTPARRYMITPRATPCAP" then
											return CalcStat("PartMitPRatPCap",L);
										else
											return 0;
										end
									elseif SN > "PARTPARRYPBONUS" then
										if SN < "PARTPARRYPRATP" then
											if SN == "PARTPARRYPPRAT" then
												return CalcStat("PartBPEPPRat",L,N);
											else
												return 0;
											end
										elseif SN > "PARTPARRYPRATP" then
											if SN == "PARTPARRYPRATPA" then
												return CalcStat("PartBPEPRatPA",L);
											else
												return 0;
											end
										else
											return CalcStat("PartBPEPRatP",L,N);
										end
									else
										return CalcStat("PartBPEPBonus",L);
									end
								else
									return CalcStat("PartMitPRatPC",L);
								end
							elseif SN > "PARTPARRYPRATPB" then
								if SN < "PERKPHYMIT" then
									if SN < "PARTPARRYPRATPCAPR" then
										if SN > "PARTPARRYPRATPC" then
											if SN == "PARTPARRYPRATPCAP" then
												return CalcStat("PartBPEPRatPCap",L);
											else
												return 0;
											end
										elseif SN == "PARTPARRYPRATPC" then
											return CalcStat("PartBPEPRatPC",L);
										else
											return 0;
										end
									elseif SN > "PARTPARRYPRATPCAPR" then
										if SN < "PERKNCMR" then
											if SN == "PERKMORALE" then
												return DataTableValue({10,20,30,40},L);
											else
												return 0;
											end
										elseif SN > "PERKNCMR" then
											if SN == "PERKNCPR" then
												return CalcStat("FoodNCPRL",L);
											else
												return 0;
											end
										else
											return CalcStat("FoodNCMRL",L);
										end
									else
										return CalcStat("PartBPEPRatPCapR",L);
									end
								elseif SN > "PERKPHYMIT" then
									if SN < "PHYDMGPBONUS" then
										if SN > "PERKPOWER" then
											if SN == "PERKTACMIT" then
												return CalcStat("TacMitT",L,0.2*N);
											else
												return 0;
											end
										elseif SN == "PERKPOWER" then
											return DataTableValue({10,20,30,40},L);
										else
											return 0;
										end
									elseif SN > "PHYDMGPBONUS" then
										if SN < "PHYDMGPRATP" then
											if SN == "PHYDMGPPRAT" then
												return CalcStat("OutDmgPPRat",L,N);
											else
												return 0;
											end
										elseif SN > "PHYDMGPRATP" then
											if SN == "PHYDMGPRATPA" then
												return CalcStat("OutDmgPRatPA",L);
											else
												return 0;
											end
										else
											return CalcStat("OutDmgPRatP",L,N);
										end
									else
										return CalcStat("OutDmgPBonus",L);
									end
								else
									return CalcStat("PhyMitT",L,0.2*N);
								end
							else
								return CalcStat("PartBPEPRatPB",L);
							end
						else
							return 35;
						end
					elseif SN > "PHYDMGPRATPB" then
						if SN < "PHYMITMPRATPB" then
							if SN < "PHYMITHPRATPCAP" then
								if SN < "PHYMIT" then
									if SN < "PHYDMGPRATPCAPR" then
										if SN > "PHYDMGPRATPC" then
											if SN == "PHYDMGPRATPCAP" then
												return CalcStat("OutDmgPRatPCap",L);
											else
												return 0;
											end
										elseif SN == "PHYDMGPRATPC" then
											return CalcStat("OutDmgPRatPC",L);
										else
											return 0;
										end
									elseif SN > "PHYDMGPRATPCAPR" then
										if SN < "PHYMASOLD" then
											if SN == "PHYMAS" then
												return CalcStat("Mastery",L,N);
											else
												return 0;
											end
										elseif SN > "PHYMASOLD" then
											if SN == "PHYMAST" then
												return CalcStat("MasteryT",L,N);
											else
												return 0;
											end
										else
											return CalcStat("Mastery",L,N);
										end
									else
										return CalcStat("OutDmgPRatPCapR",L);
									end
								elseif SN > "PHYMIT" then
									if SN < "PHYMITHPRATP" then
										if SN > "PHYMITHPBONUS" then
											if SN == "PHYMITHPPRAT" then
												return CalcStat("MitHeavyPPRat",L,N);
											else
												return 0;
											end
										elseif SN == "PHYMITHPBONUS" then
											return CalcStat("MitHeavyPBonus",L);
										else
											return 0;
										end
									elseif SN > "PHYMITHPRATP" then
										if SN < "PHYMITHPRATPB" then
											if SN == "PHYMITHPRATPA" then
												return CalcStat("MitHeavyPRatPA",L);
											else
												return 0;
											end
										elseif SN > "PHYMITHPRATPB" then
											if SN == "PHYMITHPRATPC" then
												return CalcStat("MitHeavyPRatPC",L);
											else
												return 0;
											end
										else
											return CalcStat("MitHeavyPRatPB",L);
										end
									else
										return CalcStat("MitHeavyPRatP",L,N);
									end
								else
									return StatLinInter("PntMPPhyMit","ItemProg","ProgBMitigation","",L,N,0);
								end
							elseif SN > "PHYMITHPRATPCAP" then
								if SN < "PHYMITLPRATPC" then
									if SN < "PHYMITLPPRAT" then
										if SN > "PHYMITHPRATPCAPR" then
											if SN == "PHYMITLPBONUS" then
												return CalcStat("MitLightPBonus",L);
											else
												return 0;
											end
										elseif SN == "PHYMITHPRATPCAPR" then
											return CalcStat("MitHeavyPRatPCapR",L);
										else
											return 0;
										end
									elseif SN > "PHYMITLPPRAT" then
										if SN < "PHYMITLPRATPA" then
											if SN == "PHYMITLPRATP" then
												return CalcStat("MitLightPRatP",L,N);
											else
												return 0;
											end
										elseif SN > "PHYMITLPRATPA" then
											if SN == "PHYMITLPRATPB" then
												return CalcStat("MitLightPRatPB",L);
											else
												return 0;
											end
										else
											return CalcStat("MitLightPRatPA",L);
										end
									else
										return CalcStat("MitLightPPRat",L,N);
									end
								elseif SN > "PHYMITLPRATPC" then
									if SN < "PHYMITMPBONUS" then
										if SN > "PHYMITLPRATPCAP" then
											if SN == "PHYMITLPRATPCAPR" then
												return CalcStat("MitLightPRatPCapR",L);
											else
												return 0;
											end
										elseif SN == "PHYMITLPRATPCAP" then
											return CalcStat("MitLightPRatPCap",L);
										else
											return 0;
										end
									elseif SN > "PHYMITMPBONUS" then
										if SN < "PHYMITMPRATP" then
											if SN == "PHYMITMPPRAT" then
												return CalcStat("MitMediumPPRat",L,N);
											else
												return 0;
											end
										elseif SN > "PHYMITMPRATP" then
											if SN == "PHYMITMPRATPA" then
												return CalcStat("MitMediumPRatPA",L);
											else
												return 0;
											end
										else
											return CalcStat("MitMediumPRatP",L,N);
										end
									else
										return CalcStat("MitMediumPBonus",L);
									end
								else
									return CalcStat("MitLightPRatPC",L);
								end
							else
								return CalcStat("MitHeavyPRatPCap",L);
							end
						elseif SN > "PHYMITMPRATPB" then
							if SN < "PNTMPCOMBATDAMAGEMOD" then
								if SN < "PNTMPARMOUR" then
									if SN < "PHYMITMPRATPCAPR" then
										if SN > "PHYMITMPRATPC" then
											if SN == "PHYMITMPRATPCAP" then
												return CalcStat("MitMediumPRatPCap",L);
											else
												return 0;
											end
										elseif SN == "PHYMITMPRATPC" then
											return CalcStat("MitMediumPRatPC",L);
										else
											return 0;
										end
									elseif SN > "PHYMITMPRATPCAPR" then
										if SN < "PHYRESISTT" then
											if SN == "PHYMITT" then
												return StatLinInter("PntMPPhyMit","TraitProg","ProgBMitigation","",L,N,0);
											else
												return 0;
											end
										elseif SN > "PHYRESISTT" then
											if SN == "PLAYERBASEMORALE" then
												return 52.5;
											else
												return 0;
											end
										else
											return CalcStat("ResistAddT",L,N);
										end
									else
										return CalcStat("MitMediumPRatPCapR",L);
									end
								elseif SN > "PNTMPARMOUR" then
									if SN < "PNTMPARMOURVIRTUES" then
										if SN > "PNTMPARMOURPENT" then
											if SN == "PNTMPARMOURT" then
												return 25/1200;
											else
												return 0;
											end
										elseif SN == "PNTMPARMOURPENT" then
											return 72/1200;
										else
											return 0;
										end
									elseif SN > "PNTMPARMOURVIRTUES" then
										if SN < "PNTMPCLASSBASEICPR" then
											if SN == "PNTMPBPE" then
												return 42/1200;
											else
												return 0;
											end
										elseif SN > "PNTMPCLASSBASEICPR" then
											if SN == "PNTMPCLASSBASENCPR" then
												return 0.25;
											else
												return 0;
											end
										else
											return 0.125;
										end
									else
										return 24/1200;
									end
								else
									return 4.4/1200;
								end
							elseif SN > "PNTMPCOMBATDAMAGEMOD" then
								if SN < "PNTMPFOODRESIST" then
									if SN < "PNTMPDMGTYPEMIT" then
										if SN > "PNTMPCRITDEF" then
											if SN == "PNTMPCRITHIT" then
												return 24/1200;
											else
												return 0;
											end
										elseif SN == "PNTMPCRITDEF" then
											return 40/1200;
										else
											return 0;
										end
									elseif SN > "PNTMPDMGTYPEMIT" then
										if SN < "PNTMPFINESSE" then
											if SN == "PNTMPFATE" then
												return 1.25;
											else
												return 0;
											end
										elseif SN > "PNTMPFINESSE" then
											if SN == "PNTMPFINESSET" then
												return 36/1200;
											else
												return 0;
											end
										else
											return 40/1200;
										end
									else
										return 60/1200;
									end
								elseif SN > "PNTMPFOODRESIST" then
									if SN < "PNTMPMAIN" then
										if SN < "PNTMPICPR" then
											if SN == "PNTMPICMR" then
												return 0.015;
											else
												return 0;
											end
										elseif SN > "PNTMPICPR" then
											if SN == "PNTMPINHEAL" then
												return 40/1200;
											else
												return 0;
											end
										else
											return 0.0625;
										end
									elseif SN > "PNTMPMAIN" then
										if SN < "PNTMPMITIGATION" then
											if SN == "PNTMPMASTERY" then
												return 17/1200;
											else
												return 0;
											end
										elseif SN > "PNTMPMITIGATION" then
											if SN == "PNTMPMORALE" then
												return 1;
											else
												return 0;
											end
										else
											return 28/1200;
										end
									else
										return 0.5;
									end
								else
									return 30/1200;
								end
							else
								return 300/1200;
							end
						else
							return CalcStat("MitMediumPRatPB",L);
						end
					else
						return CalcStat("OutDmgPRatPB",L);
					end
				else
					return CalcPercAB(CalcStat("PartBPEPRatPA",L),CalcStat("PartBPEPRatPB",L),CalcStat("PartBPEPRatPCap",L),N);
				end
			elseif SN > "PNTMPMORALEVIRTUES" then
				if SN < "RUNEKEEPERCDBASEWILL" then
					if SN < "REPFATEH" then
						if SN < "PROGBFINESSE" then
							if SN < "POWER" then
								if SN < "PNTMPRESIST" then
									if SN < "PNTMPOUTHEAL" then
										if SN > "PNTMPNCMR" then
											if SN == "PNTMPNCPR" then
												return 0.5;
											else
												return 0;
											end
										elseif SN == "PNTMPNCMR" then
											return 0.15;
										else
											return 0;
										end
									elseif SN > "PNTMPOUTHEAL" then
										if SN < "PNTMPPOWER" then
											if SN == "PNTMPPHYMIT" then
												return 36/1200;
											else
												return 0;
											end
										elseif SN > "PNTMPPOWER" then
											if SN == "PNTMPPOWERT" then
												return 0.6666;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return 10/1200;
									end
								elseif SN > "PNTMPRESIST" then
									if SN < "PNTMPTACMIT" then
										if SN > "PNTMPSHIELDBLOCK" then
											if SN == "PNTMPTACHPS" then
												return 0.0875;
											else
												return 0;
											end
										elseif SN == "PNTMPSHIELDBLOCK" then
											return 80/1200;
										else
											return 0;
										end
									elseif SN > "PNTMPTACMIT" then
										if SN < "PNTMPVITALITYT" then
											if SN == "PNTMPVITALITY" then
												return 0.175;
											else
												return 0;
											end
										elseif SN > "PNTMPVITALITYT" then
											if SN == "POISONRESISTT" then
												return CalcStat("ResistAddT",L,N);
											else
												return 0;
											end
										else
											return 0.225;
										end
									else
										return 36/1200;
									end
								else
									return 36/1200;
								end
							elseif SN > "POWER" then
								if SN < "PROGBCOMBATDAMAGEMOD" then
									if SN < "PROGBARMOURHEAVY" then
										if SN > "POWERT" then
											if SN == "PROGBARMOUR" then
												return CalcStat("BRatProgB",L,"BRatMitMedium");
											else
												return 0;
											end
										elseif SN == "POWERT" then
											return StatLinInter("PntMPPowerT","TraitProgVital","ProgBPower","",L,N,0);
										else
											return 0;
										end
									elseif SN > "PROGBARMOURHEAVY" then
										if SN < "PROGBARMOURMEDIUM" then
											if SN == "PROGBARMOURLIGHT" then
												return CalcStat("BRatProgB",L,"BRatMitLight");
											else
												return 0;
											end
										elseif SN > "PROGBARMOURMEDIUM" then
											if SN == "PROGBBPE" then
												return CalcStat("BRatProgB",L,"BRatLow");
											else
												return 0;
											end
										else
											return CalcStat("BRatProgB",L,"BRatMitMedium");
										end
									else
										return CalcStat("BRatProgB",L,"BRatMitHeavy");
									end
								elseif SN > "PROGBCOMBATDAMAGEMOD" then
									if SN < "PROGBCRITDEF" then
										if SN > "PROGBCOMBATDAMAGEMODADJ" then
											if SN == "PROGBCOMBATDAMAGEMODPNTMP" then
												return 10/90;
											else
												return 0;
											end
										elseif SN == "PROGBCOMBATDAMAGEMODADJ" then
											if Lm <= 50 then
												return LinFmod(1,0.1125,0.27,1,50,L);
											elseif Lm <= 60 then
												return LinFmod(1,0.27,0.26334,50,60,L);
											elseif Lm <= 65 then
												return LinFmod(1,0.26334,0.22588875,60,65,L);
											elseif Lm <= 75 then
												return LinFmod(1,0.22588875,0.219375,65,75,L);
											elseif Lm <= 85 then
												return LinFmod(1,0.219375,0.2106,75,85,L);
											elseif Lm <= 95 then
												return LinFmod(1,0.2106,0.207796153846154,85,95,L);
											elseif Lm <= 100 then
												return LinFmod(1,0.207796153846154,0.1935,95,100,L);
											elseif Lm <= 105 then
												return LinFmod(1,0.1935,0.18478125,100,105,L);
											elseif Lm <= 115 then
												return LinFmod(1,0.18478125,0.16875,105,115,L);
											elseif Lm <= 120 then
												return LinFmod(1,0.16875,0.171,115,120,L);
											elseif Lm <= 130 then
												return LinFmod(1,0.171,0.15535,120,130,L);
											elseif Lm <= 140 then
												return LinFmod(1,0.15535,0.12,130,140,L);
											else
												return LinFmod(1,0.12,0.09,140,150,L);
											end
										else
											return 0;
										end
									elseif SN > "PROGBCRITDEF" then
										if SN < "PROGBENERGY" then
											if SN == "PROGBCRITHIT" then
												return CalcStat("BRatProgB",L,"BRatLow");
											else
												return 0;
											end
										elseif SN > "PROGBENERGY" then
											if SN == "PROGBFATE" then
												return CalcStat("ProgBEnergy",L);
											else
												return 0;
											end
										else
											if Lm <= 50 then
												return LinFmod(1,4,8,1,50,L);
											elseif Lm <= 60 then
												return LinFmod(1,8,10.6,50,60,L);
											elseif Lm <= 65 then
												return LinFmod(1,10.6,13.2,60,65,L);
											elseif Lm <= 75 then
												return LinFmod(1,13.2,19.8,65,75,L);
											elseif Lm <= 85 then
												return LinFmod(1,19.8,29.8,75,85,L);
											elseif Lm <= 95 then
												return LinFmod(1,29.8,39.6,85,95,L);
											elseif Lm <= 100 then
												return LinFmod(1,39.6,52,95,100,L);
											elseif Lm <= 105 then
												return LinFmod(1,52,70,100,105,L);
											elseif Lm <= 115 then
												return LinFmod(1,78,106,106,115,L);
											elseif Lm <= 120 then
												return LinFmod(1,122,132,116,120,L);
											elseif Lm <= 130 then
												return LinFmod(1,152,198,121,130,L);
											elseif Lm <= 140 then
												return LinFmod(1,228,396,131,140,L);
											else
												return LinFmod(1,456,800,141,150,L);
											end
										end
									else
										return CalcStat("BRatProgB",L,"BRatLow");
									end
								else
									return StatLinInter("ProgBCombatDamageModPntMP","TraitProgVital","BRatHigh","ProgBCombatDamageModAdj",L,N,99);
								end
							else
								return StatLinInter("PntMPPower","ItemProgVital","ProgBPower","",L,N,0);
							end
						elseif SN > "PROGBFINESSE" then
							if SN < "PROGBTACHPS" then
								if SN < "PROGBMITIGATION" then
									if SN < "PROGBICPR" then
										if SN > "PROGBHEALTH" then
											if SN == "PROGBICMR" then
												return CalcStat("ProgBHealth",L);
											else
												return 0;
											end
										elseif SN == "PROGBHEALTH" then
											if Lm <= 50 then
												return LinFmod(1,8,60,1,50,L);
											elseif Lm <= 60 then
												return LinFmod(1,60,80,50,60,L);
											elseif Lm <= 65 then
												return LinFmod(1,80,100,60,65,L);
											elseif Lm <= 75 then
												return LinFmod(1,100,150,65,75,L);
											elseif Lm <= 85 then
												return LinFmod(1,150,226,75,85,L);
											elseif Lm <= 95 then
												return LinFmod(1,226,300,85,95,L);
											elseif Lm <= 100 then
												return LinFmod(1,300,450,95,100,L);
											elseif Lm <= 105 then
												return LinFmod(1,450,600,100,105,L);
											elseif Lm <= 115 then
												return LinFmod(1,660,900,106,115,L);
											elseif Lm <= 120 then
												return LinFmod(1,1040,1120,116,120,L);
											elseif Lm <= 130 then
												return LinFmod(1,1280,1680,121,130,L);
											elseif Lm <= 140 then
												return LinFmod(1,1940,3360,131,140,L);
											else
												return LinFmod(1,3860,6800,141,150,L);
											end
										else
											return 0;
										end
									elseif SN > "PROGBICPR" then
										if SN < "PROGBMAIN" then
											if SN == "PROGBINHEAL" then
												return CalcStat("BRatProgB",L,"BRatLow");
											else
												return 0;
											end
										elseif SN > "PROGBMAIN" then
											if SN == "PROGBMASTERY" then
												return CalcStat("BRatProgB",L,"BRatMedium");
											else
												return 0;
											end
										else
											return CalcStat("StdProg",L);
										end
									else
										return CalcStat("ProgBEnergy",L);
									end
								elseif SN > "PROGBMITIGATION" then
									if SN < "PROGBNCPR" then
										if SN > "PROGBMORALE" then
											if SN == "PROGBNCMR" then
												return CalcStat("ProgBHealth",L);
											else
												return 0;
											end
										elseif SN == "PROGBMORALE" then
											return CalcStat("ProgBHealth",L);
										else
											return 0;
										end
									elseif SN > "PROGBNCPR" then
										if SN < "PROGBPOWER" then
											if SN == "PROGBOUTHEAL" then
												return CalcStat("BRatProgB",L,"BRatHigh");
											else
												return 0;
											end
										elseif SN > "PROGBPOWER" then
											if SN == "PROGBRESIST" then
												return CalcStat("BRatProgB",L,"BRatMedium");
											else
												return 0;
											end
										else
											return CalcStat("ProgBEnergy",L);
										end
									else
										return CalcStat("ProgBEnergy",L);
									end
								else
									return CalcStat("BRatProgB",L,"BRatMitMedium");
								end
							elseif SN > "PROGBTACHPS" then
								if SN < "PROGEXTLOWEXPRND" then
									if SN < "PROGEXTCOMHIGHRND" then
										if SN > "PROGBVITALITY" then
											if SN == "PROGEXTCOMHIGHRAW" then
												if Lm <= 121 then
													return ExpFmod(N,121,20,L,nil);
												elseif Lm <= 125 then
													return ExpFmod(CalcStat("ProgExtComHighRaw",121,N),122,5.5,L,nil);
												elseif Lm <= 126 then
													return ExpFmod(CalcStat("ProgExtComHighRaw",125,N),126,20,L,nil);
												elseif Lm <= 130 then
													return ExpFmod(CalcStat("ProgExtComHighRaw",126,N),127,5.5,L,nil);
												elseif Lm <= 131 then
													return ExpFmod(CalcStat("ProgExtComHighRaw",130,N),131,20,L,nil);
												elseif Lm <= 140 then
													return ExpFmod(CalcStat("ProgExtComHighRaw",131,N),132,5.5,L,nil);
												else
													return CalcStat("ProgExtComHighRaw",140,N);
												end
											else
												return 0;
											end
										elseif SN == "PROGBVITALITY" then
											return CalcStat("ProgBHealth",L);
										else
											return 0;
										end
									elseif SN > "PROGEXTCOMHIGHRND" then
										if SN < "PROGEXTCOMLOWRND" then
											if SN == "PROGEXTCOMLOWRAW" then
												if Lm <= 116 then
													return ExpFmod(N,116,20,L,nil);
												elseif Lm <= 120 then
													return ExpFmod(CalcStat("ProgExtComLowRaw",116,N),117,5.5,L,nil);
												else
													return CalcStat("ProgExtComHighRaw",L,CalcStat("ProgExtComLowRaw",120,N));
												end
											else
												return 0;
											end
										elseif SN > "PROGEXTCOMLOWRND" then
											if SN == "PROGEXTHIGHLINEXPRND" then
												if Lm <= 115 then
													return LinFmod(N,2,4,106,115,L,-1);
												else
													return CalcStat("ProgExtComLowRnd",L,CalcStat("ProgExtHighLinExpRnd",115,N));
												end
											else
												return 0;
											end
										else
											if Lm <= 116 then
												return ExpFmod(N,116,20,L,0);
											elseif Lm <= 120 then
												return ExpFmod(CalcStat("ProgExtComLowRnd",116,N),117,5.5,L,0);
											else
												return CalcStat("ProgExtComHighRnd",L,CalcStat("ProgExtComLowRnd",120,N));
											end
										end
									else
										if Lm <= 121 then
											return ExpFmod(N,121,20,L,0);
										elseif Lm <= 125 then
											return ExpFmod(CalcStat("ProgExtComHighRnd",121,N),122,5.5,L,0);
										elseif Lm <= 126 then
											return ExpFmod(CalcStat("ProgExtComHighRnd",125,N),126,20,L,0);
										elseif Lm <= 130 then
											return ExpFmod(CalcStat("ProgExtComHighRnd",126,N),127,5.5,L,0);
										elseif Lm <= 131 then
											return ExpFmod(CalcStat("ProgExtComHighRnd",130,N),131,20,L,0);
										elseif Lm <= 140 then
											return ExpFmod(CalcStat("ProgExtComHighRnd",131,N),132,5.5,L,0);
										else
											return CalcStat("ProgExtComHighRnd",140,N);
										end
									end
								elseif SN > "PROGEXTLOWEXPRND" then
									if SN < "REPAGILITYH" then
										if SN > "PROGEXTMEDEXPRAW" then
											if SN == "PROGEXTMPEXPRND" then
												if Lm <= 114 then
													return ExpFmod(N,106,7.5,L,0);
												elseif Lm <= 115 then
													return 2*N;
												elseif Lm <= 119 then
													return ExpFmod(CalcStat("ProgExtMpExpRnd",115,N),116,25,L,0);
												elseif Lm <= 120 then
													return RoundDbl((16/3)*N);
												else
													return CalcStat("ProgExtComHighRnd",L,CalcStat("ProgExtMpExpRnd",120,N));
												end
											else
												return 0;
											end
										elseif SN == "PROGEXTMEDEXPRAW" then
											if Lm <= 106 then
												return ExpFmod(N,106,10,L,nil);
											elseif Lm <= 115 then
												return ExpFmod(CalcStat("ProgExtMedExpRaw",106,N),107,5.5,L,nil);
											else
												return CalcStat("ProgExtComLowRaw",L,CalcStat("ProgExtMedExpRaw",115,N));
											end
										else
											return 0;
										end
									elseif SN > "REPAGILITYH" then
										if SN < "REPCRITDEF" then
											if SN == "REPAGILITYL" then
												return CalcStat("RepMainL",L);
											else
												return 0;
											end
										elseif SN > "REPCRITDEF" then
											if SN == "REPCRITHIT" then
												if Lm <= 50 then
													return LinFmod(1,300,496,1,50,L);
												elseif Lm <= 85 then
													return LinFmod(1,496,636,50,85,L);
												elseif Lm <= 105 then
													return LinFmod(1,636,716,85,105,L);
												else
													return LinFmod(1,716,776,105,120,L);
												end
											else
												return 0;
											end
										else
											if Lm <= 50 then
												return LinFmod(1,900,1488,1,50,L);
											elseif Lm <= 85 then
												return LinFmod(1,1488,1908,50,85,L);
											elseif Lm <= 105 then
												return LinFmod(1,1908,2148,85,105,L);
											else
												return LinFmod(1,2148,2328,105,120,L);
											end
										end
									else
										return CalcStat("RepMainH",L);
									end
								else
									if Lm <= 115 then
										return ExpFmod(N,106,5.5,L,0);
									else
										return CalcStat("ProgExtComLowRnd",L,CalcStat("ProgExtLowExpRnd",115,N));
									end
								end
							else
								return CalcStat("ProgBHealth",L);
							end
						else
							return CalcStat("BRatProgB",L,"BRatLow");
						end
					elseif SN > "REPFATEH" then
						if SN < "RIVERHOBBITRDPSVTWONAME" then
							if SN < "RESIST" then
								if SN < "REPMORALE" then
									if SN < "REPMAINH" then
										if SN > "REPFATEL" then
											if SN == "REPFINESSE" then
												if Lm <= 50 then
													return LinFmod(1,322,557,1,50,L);
												elseif Lm <= 85 then
													return LinFmod(1,557,749.9477,50,85,L);
												elseif Lm <= 105 then
													return LinFmod(1,749.9477,859.1634,85,105,L);
												else
													return LinFmod(1,859.1634,939.2549,105,120,L);
												end
											else
												return 0;
											end
										elseif SN == "REPFATEL" then
											return CalcStat("RepMainL",L);
										else
											return 0;
										end
									elseif SN > "REPMAINH" then
										if SN < "REPMIGHTH" then
											if SN == "REPMAINL" then
												if Lm <= 50 then
													return RoundDblDown(LinFmod(1,53,102,1,50,L));
												elseif Lm <= 85 then
													return RoundDblDown(LinFmod(1,102,137,50,85,L));
												elseif Lm <= 105 then
													return RoundDblDown(LinFmod(1,137,157,85,105,L));
												else
													return RoundDblDown(LinFmod(1,157,172,105,120,L));
												end
											else
												return 0;
											end
										elseif SN > "REPMIGHTH" then
											if SN == "REPMIGHTL" then
												return CalcStat("RepMainL",L);
											else
												return 0;
											end
										else
											return CalcStat("RepMainH",L);
										end
									else
										if Lm <= 50 then
											return RoundDblDown(LinFmod(1,80,153,1,50,L));
										elseif Lm <= 85 then
											return RoundDblDown(LinFmod(1,153,206,50,85,L));
										elseif Lm <= 105 then
											return RoundDblDown(LinFmod(1,206,236,85,105,L));
										else
											return RoundDblDown(LinFmod(1,236,258,105,120,L));
										end
									end
								elseif SN > "REPMORALE" then
									if SN < "REPVITALITYH" then
										if SN > "REPPOWER" then
											if SN == "REPTACMIT" then
												if Lm <= 50 then
													return LinFmod(1,675,1116,1,50,L);
												elseif Lm <= 85 then
													return LinFmod(1,1116,1431,50,85,L);
												elseif Lm <= 105 then
													return LinFmod(1,1431,1611,85,105,L);
												else
													return LinFmod(1,1611,1746,105,120,L);
												end
											else
												return 0;
											end
										elseif SN == "REPPOWER" then
											if Lm <= 50 then
												return LinFmod(1,94,212,1,50,L);
											elseif Lm <= 85 then
												return LinFmod(1,212,296,50,85,L);
											elseif Lm <= 105 then
												return LinFmod(1,296,344,85,105,L);
											else
												return LinFmod(1,344,380,105,120,L);
											end
										else
											return 0;
										end
									elseif SN > "REPVITALITYH" then
										if SN < "REPWILLH" then
											if SN == "REPVITALITYL" then
												return CalcStat("RepMainL",L);
											else
												return 0;
											end
										elseif SN > "REPWILLH" then
											if SN == "REPWILLL" then
												return CalcStat("RepMainL",L);
											else
												return 0;
											end
										else
											return CalcStat("RepMainH",L);
										end
									else
										return CalcStat("RepMainH",L);
									end
								else
									if Lm <= 50 then
										return LinFmod(1,187,427,1,50,L);
									elseif Lm <= 85 then
										return LinFmod(1,427,599,50,85,L);
									elseif Lm <= 105 then
										return LinFmod(1,599,697,85,105,L);
									else
										return LinFmod(1,697,770,105,120,L);
									end
								end
							elseif SN > "RESIST" then
								if SN < "RESISTPRATPC" then
									if SN < "RESISTPPRAT" then
										if SN > "RESISTADDT" then
											if SN == "RESISTPBONUS" then
												return 0;
											else
												return 0;
											end
										elseif SN == "RESISTADDT" then
											return CalcStat("ResistT",L,N);
										else
											return 0;
										end
									elseif SN > "RESISTPPRAT" then
										if SN < "RESISTPRATPA" then
											if SN == "RESISTPRATP" then
												return CalcPercAB(CalcStat("ResistPRatPA",L),CalcStat("ResistPRatPB",L),CalcStat("ResistPRatPCap",L),N);
											else
												return 0;
											end
										elseif SN > "RESISTPRATPA" then
											if SN == "RESISTPRATPB" then
												return CalcStat("BRatRounded",L,"BRatMedium");
											else
												return 0;
											end
										else
											return 150;
										end
									else
										return CalcRatAB(CalcStat("ResistPRatPA",L),CalcStat("ResistPRatPB",L),CalcStat("ResistPRatPCapR",L),N);
									end
								elseif SN > "RESISTPRATPC" then
									if SN < "RESISTT" then
										if SN > "RESISTPRATPCAP" then
											if SN == "RESISTPRATPCAPR" then
												return CalcStat("ResistPRatPB",L)*CalcStat("ResistPRatPC",L);
											else
												return 0;
											end
										elseif SN == "RESISTPRATPCAP" then
											return 50;
										else
											return 0;
										end
									elseif SN > "RESISTT" then
										if SN < "RIVERHOBBITRDPSVONENAME" then
											if SN == "REVERSE" then
												return ReverseCalc(C,L);
											else
												return 0;
											end
										elseif SN > "RIVERHOBBITRDPSVONENAME" then
											if SN == "RIVERHOBBITRDPSVONEWILL" then
												return CalcStat("RivHobSeenWorldWill",L);
											else
												return 0;
											end
										else
											return "Seen the World";
										end
									else
										return StatLinInter("PntMPResist","TraitProg","ProgBResist","",L,N,0);
									end
								else
									return 0.5;
								end
							else
								return StatLinInter("PntMPResist","ItemProg","ProgBResist","",L,N,0);
							end
						elseif SN > "RIVERHOBBITRDPSVTWONAME" then
							if SN < "RUNEKEEPERCDAGILITYTOPARRY" then
								if SN < "RIVHOBSEENWORLDWILL" then
									if SN < "RIVERHOBBITRDTRAITMORALE" then
										if SN > "RIVERHOBBITRDTRAITAGILITY" then
											if SN == "RIVERHOBBITRDTRAITFROSTMITP" then
												return CalcStat("RivHobSwimmerFrostMitP",L);
											else
												return 0;
											end
										elseif SN == "RIVERHOBBITRDTRAITAGILITY" then
											return CalcStat("RivHobSlipperyAgility",L);
										else
											return 0;
										end
									elseif SN > "RIVERHOBBITRDTRAITMORALE" then
										if SN < "RIVHOBHARDYHOLBMORALE" then
											if SN == "RIVERHOBBITRDTRAITWILL" then
												return CalcStat("RivHobSeclusionWill",L);
											else
												return 0;
											end
										elseif SN > "RIVHOBHARDYHOLBMORALE" then
											if SN == "RIVHOBSECLUSIONWILL" then
												return -CalcStat("WillT",L,0.4);
											else
												return 0;
											end
										else
											return CalcStat("MoraleT",L,1.0);
										end
									else
										return CalcStat("RivHobHardyHolbMorale",L);
									end
								elseif SN > "RIVHOBSEENWORLDWILL" then
									if SN < "RKDETERMINATIONWILL" then
										if SN > "RIVHOBSLIPPERYAGILITY" then
											if SN == "RIVHOBSWIMMERFROSTMITP" then
												return 1;
											else
												return 0;
											end
										elseif SN == "RIVHOBSLIPPERYAGILITY" then
											return CalcStat("AgilityT",L,1.0);
										else
											return 0;
										end
									elseif SN > "RKDETERMINATIONWILL" then
										if SN < "RUNEKEEPERCDAGILITYTOCRITHIT" then
											if SN == "RKFORTUNESMILESFATE" then
												return CalcStat("FateT",L,CalcStat("Trait567810Choice",N)*0.4);
											else
												return 0;
											end
										elseif SN > "RUNEKEEPERCDAGILITYTOCRITHIT" then
											if SN == "RUNEKEEPERCDAGILITYTOEVADE" then
												return 3;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return CalcStat("WillT",L,CalcStat("Trait567810Choice",N)*0.4);
									end
								else
									return CalcStat("WillT",L,1.0);
								end
							elseif SN > "RUNEKEEPERCDAGILITYTOPARRY" then
								if SN < "RUNEKEEPERCDBASEICMR" then
									if SN < "RUNEKEEPERCDARMOURTOTACMIT" then
										if SN > "RUNEKEEPERCDARMOURTOOFMIT" then
											if SN == "RUNEKEEPERCDARMOURTOPHYMIT" then
												return 1;
											else
												return 0;
											end
										elseif SN == "RUNEKEEPERCDARMOURTOOFMIT" then
											return 0.2;
										else
											return 0;
										end
									elseif SN > "RUNEKEEPERCDARMOURTOTACMIT" then
										if SN < "RUNEKEEPERCDBASEAGILITY" then
											if SN == "RUNEKEEPERCDARMOURTYPE" then
												return 1;
											else
												return 0;
											end
										elseif SN > "RUNEKEEPERCDBASEAGILITY" then
											if SN == "RUNEKEEPERCDBASEFATE" then
												return CalcStat("ClassBaseFate",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseAgilityL",L);
										end
									else
										return 0.2;
									end
								elseif SN > "RUNEKEEPERCDBASEICMR" then
									if SN < "RUNEKEEPERCDBASENCMR" then
										if SN < "RUNEKEEPERCDBASEMIGHT" then
											if SN == "RUNEKEEPERCDBASEICPR" then
												return CalcStat("ClassBaseICPR",L);
											else
												return 0;
											end
										elseif SN > "RUNEKEEPERCDBASEMIGHT" then
											if SN == "RUNEKEEPERCDBASEMORALE" then
												return CalcStat("ClassBaseMorale",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseMightM",L);
										end
									elseif SN > "RUNEKEEPERCDBASENCMR" then
										if SN < "RUNEKEEPERCDBASEPOWER" then
											if SN == "RUNEKEEPERCDBASENCPR" then
												return CalcStat("ClassBaseNCPR",L);
											else
												return 0;
											end
										elseif SN > "RUNEKEEPERCDBASEPOWER" then
											if SN == "RUNEKEEPERCDBASEVITALITY" then
												return CalcStat("ClassBaseVitality",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBasePower",L);
										end
									else
										return CalcStat("ClassBaseNCMRL",L);
									end
								else
									return CalcStat("ClassBaseICMRL",L);
								end
							else
								return 2;
							end
						else
							return "";
						end
					else
						return CalcStat("RepMainH",L);
					end
				elseif SN > "RUNEKEEPERCDBASEWILL" then
					if SN < "T2PENARMOUR" then
						if SN < "STDMORALEH" then
							if SN < "RUNEKEEPERCDVITALITYTORESIST" then
								if SN < "RUNEKEEPERCDHASPOWER" then
									if SN < "RUNEKEEPERCDFATETONCPR" then
										if SN > "RUNEKEEPERCDFATETOCRITHIT" then
											if SN == "RUNEKEEPERCDFATETOICMR" then
												return 0.025;
											else
												return 0;
											end
										elseif SN == "RUNEKEEPERCDFATETOCRITHIT" then
											return 1.5;
										else
											return 0;
										end
									elseif SN > "RUNEKEEPERCDFATETONCPR" then
										if SN < "RUNEKEEPERCDFATETORESIST" then
											if SN == "RUNEKEEPERCDFATETOPOWER" then
												return 1;
											else
												return 0;
											end
										elseif SN > "RUNEKEEPERCDFATETORESIST" then
											if SN == "RUNEKEEPERCDFATETOTACMIT" then
												return 0.5;
											else
												return 0;
											end
										else
											return 0.5;
										end
									else
										return 0.05;
									end
								elseif SN > "RUNEKEEPERCDHASPOWER" then
									if SN < "RUNEKEEPERCDPHYMITTOOFMIT" then
										if SN > "RUNEKEEPERCDMIGHTTOBLOCK" then
											if SN == "RUNEKEEPERCDMIGHTTOPARRY" then
												return 2;
											else
												return 0;
											end
										elseif SN == "RUNEKEEPERCDMIGHTTOBLOCK" then
											return 3;
										else
											return 0;
										end
									elseif SN > "RUNEKEEPERCDPHYMITTOOFMIT" then
										if SN < "RUNEKEEPERCDVITALITYTOMORALE" then
											if SN == "RUNEKEEPERCDTACMASTOOUTHEAL" then
												return 1;
											else
												return 0;
											end
										elseif SN > "RUNEKEEPERCDVITALITYTOMORALE" then
											if SN == "RUNEKEEPERCDVITALITYTONCMR" then
												return 0.12;
											else
												return 0;
											end
										else
											return 4;
										end
									else
										return 1;
									end
								else
									return 1;
								end
							elseif SN > "RUNEKEEPERCDVITALITYTORESIST" then
								if SN < "SHADOWMIT" then
									if SN < "RUNEKEEPERCDWILLTOFINESSE" then
										if SN > "RUNEKEEPERCDVITALITYTOTACMIT" then
											if SN == "RUNEKEEPERCDWILLTOEVADE" then
												return 1;
											else
												return 0;
											end
										elseif SN == "RUNEKEEPERCDVITALITYTOTACMIT" then
											return 0.5;
										else
											return 0;
										end
									elseif SN > "RUNEKEEPERCDWILLTOFINESSE" then
										if SN < "RUNEKEEPERCDWILLTOTACMAS" then
											if SN == "RUNEKEEPERCDWILLTORESIST" then
												return 2;
											else
												return 0;
											end
										elseif SN > "RUNEKEEPERCDWILLTOTACMAS" then
											if SN == "RUNEKEEPERCDWILLTOTACMIT" then
												return 1;
											else
												return 0;
											end
										else
											return 3;
										end
									else
										return 1;
									end
								elseif SN > "SHADOWMIT" then
									if SN < "SHIELDBRAWLERBLOCK" then
										if SN > "SHADOWMITT" then
											if SN == "SHIELDBLOCK" then
												return StatLinInter("PntMPShieldBlock","ItemProg","ProgBBPE","",L,N,0);
											else
												return 0;
											end
										elseif SN == "SHADOWMITT" then
											return CalcStat("DmgTypeMitT",L,N);
										else
											return 0;
										end
									elseif SN > "SHIELDBRAWLERBLOCK" then
										if SN < "SONGRESISTT" then
											if SN == "SKILLPOWERCOST" then
												return CalcStat("CombatDamageModEnergy",L,0.64*N);
											else
												return 0;
											end
										elseif SN > "SONGRESISTT" then
											if SN == "STATC" then
												return CalcStat(C,L);
											else
												return 0;
											end
										else
											return CalcStat("ResistAddT",L,N);
										end
									else
										return CalcStat("DwarfShieldBrwlBlock",L);
									end
								else
									return CalcStat("DmgTypeMit",L,N);
								end
							else
								return 0.5;
							end
						elseif SN > "STDMORALEH" then
							if SN < "STOUTAXERDTRAITMIGHT" then
								if SN < "STDPROG" then
									if SN < "STDMORALERAW" then
										if SN > "STDMORALEL" then
											if SN == "STDMORALEM" then
												if Lm <= 105 then
													return RoundDbl(1.5*CalcStat("StdMoraleRaw",L));
												else
													return CalcStat("ProgExtLowExpRnd",L,CalcStat("StdMoraleM",105));
												end
											else
												return 0;
											end
										elseif SN == "STDMORALEL" then
											if Lm <= 105 then
												return RoundDbl(CalcStat("StdMoraleRaw",L));
											else
												return CalcStat("ProgExtLowExpRnd",L,CalcStat("StdMoraleL",105));
											end
										else
											return 0;
										end
									elseif SN > "STDMORALERAW" then
										if SN < "STDPOWERL" then
											if SN == "STDPOWERH" then
												if Lm <= 105 then
													return RoundDbl(2*CalcStat("StdPowerRaw",L));
												else
													return CalcStat("ProgExtLowExpRnd",L,CalcStat("StdPowerH",105));
												end
											else
												return 0;
											end
										elseif SN > "STDPOWERL" then
											if SN == "STDPOWERRAW" then
												if Lm <= 50 then
													return LinFmod(1,3,91.0375,1,50,L);
												else
													return LinFmod(1,91.0375,421,50,105,L);
												end
											else
												return 0;
											end
										else
											if Lm <= 105 then
												return RoundDbl(CalcStat("StdPowerRaw",L));
											else
												return CalcStat("ProgExtLowExpRnd",L,CalcStat("StdPowerL",105));
											end
										end
									else
										if Lm <= 50 then
											return LinFmod(1,7.51,227.59,1,50,L);
										else
											return LinFmod(1,227.59,1327.5,50,105,L);
										end
									end
								elseif SN > "STDPROG" then
									if SN < "STOUTAXERDPSVTWONAME" then
										if SN > "STOUTAXERDPSVONENAME" then
											if SN == "STOUTAXERDPSVONEVITALITY" then
												return CalcStat("StoutUnwritDestVitality",L);
											else
												return 0;
											end
										elseif SN == "STOUTAXERDPSVONENAME" then
											return "Unwritten Destiny";
										else
											return 0;
										end
									elseif SN > "STOUTAXERDPSVTWONAME" then
										if SN < "STOUTAXERDTRAITDISEASERESISTP" then
											if SN == "STOUTAXERDTRAITAGILITY" then
												return CalcStat("StoutWrBlackLAgility",L);
											else
												return 0;
											end
										elseif SN > "STOUTAXERDTRAITDISEASERESISTP" then
											if SN == "STOUTAXERDTRAITFATE" then
												return CalcStat("StoutDoomDrasaFate",L);
											else
												return 0;
											end
										else
											return CalcStat("StoutWrBlackLDiseaseResistP",L);
										end
									else
										return "";
									end
								else
									if Lm <= 50 then
										return LinFmod(1,1,10,1,50,L);
									elseif Lm <= 60 then
										return LinFmod(1,10,15,50,60,L);
									elseif Lm <= 65 then
										return LinFmod(1,15,20,60,65,L);
									elseif Lm <= 75 then
										return LinFmod(1,20,30,65,75,L);
									elseif Lm <= 85 then
										return LinFmod(1,30,45,75,85,L);
									elseif Lm <= 95 then
										return LinFmod(1,45,65,85,95,L);
									elseif Lm <= 100 then
										return LinFmod(1,65,90,95,100,L);
									elseif Lm <= 105 then
										return LinFmod(1,90,120,100,105,L);
									elseif Lm <= 115 then
										return LinFmod(1,132,180,106,115,L);
									elseif Lm <= 120 then
										return LinFmod(1,207,225,116,120,L);
									elseif Lm <= 130 then
										return LinFmod(1,259,340,121,130,L);
									elseif Lm <= 140 then
										return LinFmod(1,390,680,131,140,L);
									else
										return LinFmod(1,780,1360,141,150,L);
									end
								end
							elseif SN > "STOUTAXERDTRAITMIGHT" then
								if SN < "STOUTUNWRITDESTVITALITY" then
									if SN < "STOUTAXERDTRAITVITALITY" then
										if SN > "STOUTAXERDTRAITPHYMITP" then
											if SN == "STOUTAXERDTRAITSHADOWMITP" then
												return CalcStat("StoutWrBlackLShadowMitP",L);
											else
												return 0;
											end
										elseif SN == "STOUTAXERDTRAITPHYMITP" then
											return CalcStat("StoutUnyieldingPhyMitP",L);
										else
											return 0;
										end
									elseif SN > "STOUTAXERDTRAITVITALITY" then
										if SN < "STOUTDOOMDRASAFATE" then
											if SN == "STOUTAXERDTRAITWILL" then
												return CalcStat("StoutUnyieldingWill",L);
											else
												return 0;
											end
										elseif SN > "STOUTDOOMDRASAFATE" then
											if SN == "STOUTSHADOWEYEVITALITY" then
												return -CalcStat("VitalityT",L,0.4);
											else
												return 0;
											end
										else
											return -CalcStat("FateT",L,0.4);
										end
									else
										return CalcStat("StoutShadowEyeVitality",L);
									end
								elseif SN > "STOUTUNWRITDESTVITALITY" then
									if SN < "STOUTWRBLACKLAGILITY" then
										if SN > "STOUTUNYIELDINGPHYMITP" then
											if SN == "STOUTUNYIELDINGWILL" then
												return CalcStat("WillT",L,1.0);
											else
												return 0;
											end
										elseif SN == "STOUTUNYIELDINGPHYMITP" then
											return 1;
										else
											return 0;
										end
									elseif SN > "STOUTWRBLACKLAGILITY" then
										if SN < "STOUTWRBLACKLMIGHT" then
											if SN == "STOUTWRBLACKLDISEASERESISTP" then
												return 1;
											else
												return 0;
											end
										elseif SN > "STOUTWRBLACKLMIGHT" then
											if SN == "STOUTWRBLACKLSHADOWMITP" then
												return 1;
											else
												return 0;
											end
										else
											return CalcStat("MightT",L,1.0);
										end
									else
										return CalcStat("AgilityT",L,1.0);
									end
								else
									return CalcStat("VitalityT",L,1.0);
								end
							else
								return CalcStat("StoutWrBlackLMight",L);
							end
						else
							if Lm <= 105 then
								return RoundDbl(2*CalcStat("StdMoraleRaw",L));
							else
								return CalcStat("ProgExtLowExpRnd",L,CalcStat("StdMoraleH",105));
							end
						end
					elseif SN > "T2PENARMOUR" then
						if SN < "TACMITLPRATPB" then
							if SN < "TACMAST" then
								if SN < "TACDMGPRATPA" then
									if SN < "T2PENRESIST" then
										if SN > "T2PENBPE" then
											if SN == "T2PENMIT" then
												if Lm <= 115 then
													return RoundDblDown(L*13.5)*-5;
												else
													return CalcStat("ProgExtComLowRaw",L,CalcStat("T2PenMit",115));
												end
											else
												return 0;
											end
										elseif SN == "T2PENBPE" then
											if Lm <= 115 then
												return (-40)*L;
											else
												return CalcStat("ProgExtComLowRaw",L,CalcStat("T2PenBPE",115));
											end
										else
											return 0;
										end
									elseif SN > "T2PENRESIST" then
										if SN < "TACDMGPPRAT" then
											if SN == "TACDMGPBONUS" then
												return CalcStat("OutDmgPBonus",L);
											else
												return 0;
											end
										elseif SN > "TACDMGPPRAT" then
											if SN == "TACDMGPRATP" then
												return CalcStat("OutDmgPRatP",L,N);
											else
												return 0;
											end
										else
											return CalcStat("OutDmgPPRat",L,N);
										end
									else
										if Lm <= 115 then
											return (-90)*L;
										else
											return CalcStat("ProgExtComLowRaw",L,CalcStat("T2PenResist",115));
										end
									end
								elseif SN > "TACDMGPRATPA" then
									if SN < "TACDMGPRATPCAP" then
										if SN > "TACDMGPRATPB" then
											if SN == "TACDMGPRATPC" then
												return CalcStat("OutDmgPRatPC",L);
											else
												return 0;
											end
										elseif SN == "TACDMGPRATPB" then
											return CalcStat("OutDmgPRatPB",L);
										else
											return 0;
										end
									elseif SN > "TACDMGPRATPCAP" then
										if SN < "TACMAS" then
											if SN == "TACDMGPRATPCAPR" then
												return CalcStat("OutDmgPRatPCapR",L);
											else
												return 0;
											end
										elseif SN > "TACMAS" then
											if SN == "TACMASOLD" then
												return CalcStat("Mastery",L,N);
											else
												return 0;
											end
										else
											return CalcStat("Mastery",L,N);
										end
									else
										return CalcStat("OutDmgPRatPCap",L);
									end
								else
									return CalcStat("OutDmgPRatPA",L);
								end
							elseif SN > "TACMAST" then
								if SN < "TACMITHPRATPC" then
									if SN < "TACMITHPPRAT" then
										if SN > "TACMIT" then
											if SN == "TACMITHPBONUS" then
												return CalcStat("MitHeavyPBonus",L);
											else
												return 0;
											end
										elseif SN == "TACMIT" then
											return StatLinInter("PntMPTacMit","ItemProg","ProgBMitigation","",L,N,0);
										else
											return 0;
										end
									elseif SN > "TACMITHPPRAT" then
										if SN < "TACMITHPRATPA" then
											if SN == "TACMITHPRATP" then
												return CalcStat("MitHeavyPRatP",L,N);
											else
												return 0;
											end
										elseif SN > "TACMITHPRATPA" then
											if SN == "TACMITHPRATPB" then
												return CalcStat("MitHeavyPRatPB",L);
											else
												return 0;
											end
										else
											return CalcStat("MitHeavyPRatPA",L);
										end
									else
										return CalcStat("MitHeavyPPRat",L,N);
									end
								elseif SN > "TACMITHPRATPC" then
									if SN < "TACMITLPBONUS" then
										if SN > "TACMITHPRATPCAP" then
											if SN == "TACMITHPRATPCAPR" then
												return CalcStat("MitHeavyPRatPCapR",L);
											else
												return 0;
											end
										elseif SN == "TACMITHPRATPCAP" then
											return CalcStat("MitHeavyPRatPCap",L);
										else
											return 0;
										end
									elseif SN > "TACMITLPBONUS" then
										if SN < "TACMITLPRATP" then
											if SN == "TACMITLPPRAT" then
												return CalcStat("MitLightPPRat",L,N);
											else
												return 0;
											end
										elseif SN > "TACMITLPRATP" then
											if SN == "TACMITLPRATPA" then
												return CalcStat("MitLightPRatPA",L);
											else
												return 0;
											end
										else
											return CalcStat("MitLightPRatP",L,N);
										end
									else
										return CalcStat("MitLightPBonus",L);
									end
								else
									return CalcStat("MitHeavyPRatPC",L);
								end
							else
								return CalcStat("MasteryT",L,N);
							end
						elseif SN > "TACMITLPRATPB" then
							if SN < "TOMEFATE" then
								if SN < "TACMITMPRATPA" then
									if SN < "TACMITLPRATPCAPR" then
										if SN > "TACMITLPRATPC" then
											if SN == "TACMITLPRATPCAP" then
												return CalcStat("MitLightPRatPCap",L);
											else
												return 0;
											end
										elseif SN == "TACMITLPRATPC" then
											return CalcStat("MitLightPRatPC",L);
										else
											return 0;
										end
									elseif SN > "TACMITLPRATPCAPR" then
										if SN < "TACMITMPPRAT" then
											if SN == "TACMITMPBONUS" then
												return CalcStat("MitMediumPBonus",L);
											else
												return 0;
											end
										elseif SN > "TACMITMPPRAT" then
											if SN == "TACMITMPRATP" then
												return CalcStat("MitMediumPRatP",L,N);
											else
												return 0;
											end
										else
											return CalcStat("MitMediumPPRat",L,N);
										end
									else
										return CalcStat("MitLightPRatPCapR",L);
									end
								elseif SN > "TACMITMPRATPA" then
									if SN < "TACMITMPRATPCAP" then
										if SN > "TACMITMPRATPB" then
											if SN == "TACMITMPRATPC" then
												return CalcStat("MitMediumPRatPC",L);
											else
												return 0;
											end
										elseif SN == "TACMITMPRATPB" then
											return CalcStat("MitMediumPRatPB",L);
										else
											return 0;
										end
									elseif SN > "TACMITMPRATPCAP" then
										if SN < "TACMITT" then
											if SN == "TACMITMPRATPCAPR" then
												return CalcStat("MitMediumPRatPCapR",L);
											else
												return 0;
											end
										elseif SN > "TACMITT" then
											if SN == "TACRESISTT" then
												return CalcStat("ResistAddT",L,N);
											else
												return 0;
											end
										else
											return StatLinInter("PntMPTacMit","TraitProg","ProgBMitigation","",L,N,0);
										end
									else
										return CalcStat("MitMediumPRatPCap",L);
									end
								else
									return CalcStat("MitMediumPRatPA",L);
								end
							elseif SN > "TOMEFATE" then
								if SN < "TOMETOTALMAIN" then
									if SN < "TOMEMAINDEC" then
										if SN > "TOMEFATEDEC" then
											if SN == "TOMEMAIN" then
												return CalcStat("TomeMainDec",RomanRankDecode(C));
											else
												return 0;
											end
										elseif SN == "TOMEFATEDEC" then
											return CalcStat("TomeTotalFateDec",L)-CalcStat("TomeTotalFateDec",L-1);
										else
											return 0;
										end
									elseif SN > "TOMEMAINDEC" then
										if SN < "TOMETOTALFATEDEC" then
											if SN == "TOMETOTALFATE" then
												return CalcStat("TomeTotalFateDec",RomanRankDecode(C));
											else
												return 0;
											end
										elseif SN > "TOMETOTALFATEDEC" then
											if SN == "TOMETOTALLEVEL" then
												if Lm <= 0 then
													return 0;
												elseif Lm <= 3 then
													return 6*L+1;
												elseif Lm <= 10 then
													return 5*L+5;
												elseif Lm <= 11 then
													return 5*L+10;
												elseif Lm <= 18 then
													return 5*L+15;
												elseif Lm <= 22 then
													return RoundDbl(3.2*L+45.4);
												else
													return 0*L+118;
												end
											else
												return 0;
											end
										else
											return CalcStat("FateT",CalcStat("TomeTotalLevel",L),2.0);
										end
									else
										return CalcStat("TomeTotalMainDec",L)-CalcStat("TomeTotalMainDec",L-1);
									end
								elseif SN > "TOMETOTALMAIN" then
									if SN < "TOMEVITALITY" then
										if SN < "TOMETOTALVITALITY" then
											if SN == "TOMETOTALMAINDEC" then
												return CalcStat("MainT",CalcStat("TomeTotalLevel",L),2.0);
											else
												return 0;
											end
										elseif SN > "TOMETOTALVITALITY" then
											if SN == "TOMETOTALVITALITYDEC" then
												return CalcStat("VitalityT",CalcStat("TomeTotalLevel",L),2.0);
											else
												return 0;
											end
										else
											return CalcStat("TomeTotalVitalityDec",RomanRankDecode(C));
										end
									elseif SN > "TOMEVITALITY" then
										if SN < "TPENARMOUR" then
											if SN == "TOMEVITALITYDEC" then
												return CalcStat("TomeTotalVitalityDec",L)-CalcStat("TomeTotalVitalityDec",L-1);
											else
												return 0;
											end
										elseif SN > "TPENARMOUR" then
											if SN == "TPENBPE" then
												return -CalcStat("BPET",L,CalcStat("TpenChoice",N));
											else
												return 0;
											end
										else
											return -CalcStat("ArmourPenT",L,CalcStat("TpenChoice",N));
										end
									else
										return CalcStat("TomeVitalityDec",RomanRankDecode(C));
									end
								else
									return CalcStat("TomeTotalMainDec",RomanRankDecode(C));
								end
							else
								return CalcStat("TomeFateDec",RomanRankDecode(C));
							end
						else
							return CalcStat("MitLightPRatPB",L);
						end
					else
						return CalcStat("T2penMit",L);
					end
				else
					return CalcStat("ClassBaseWillH",L);
				end
			else
				return 0.75;
			end
		elseif SN > "TPENCHOICE" then
			if SN < "WARDINGLOREPHYMIT" then
				if SN < "VITALITYT" then
					if SN < "VIRTHONOURCRITDEF" then
						if SN < "VIRTCONFIDENCEVPPHYMAS" then
							if SN < "TRAITPROG" then
								if SN < "TRAIT23456CHOICE" then
									if SN < "TRAIT12347CHOICE" then
										if SN > "TPENRESIST" then
											if SN == "TRAIT12345CHOICE" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({1,2,3,4,5},L);
												end
											else
												return 0;
											end
										elseif SN == "TPENRESIST" then
											return -CalcStat("ResistT",L,CalcStat("TpenChoice",N)*2);
										else
											return 0;
										end
									elseif SN > "TRAIT12347CHOICE" then
										if SN < "TRAIT123CHOICE" then
											if SN == "TRAIT1234CHOICE" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({1,2,3,4},L);
												end
											else
												return 0;
											end
										elseif SN > "TRAIT123CHOICE" then
											if SN == "TRAIT13510CHOICE" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({1,3,5,10},L);
												end
											else
												return 0;
											end
										else
											if Lm <= 0 then
												return 0;
											else
												return DataTableValue({1,2,3},L);
											end
										end
									else
										if Lm <= 0 then
											return 0;
										else
											return DataTableValue({1,2,3,4,7},L);
										end
									end
								elseif SN > "TRAIT23456CHOICE" then
									if SN < "TRAIT47101316CHOICE" then
										if SN > "TRAIT234CHOICE" then
											if SN == "TRAIT357912CHOICE" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({3,5,7,9,12},L);
												end
											else
												return 0;
											end
										elseif SN == "TRAIT234CHOICE" then
											if Lm <= 0 then
												return 0;
											else
												return DataTableValue({2,3,4},L);
											end
										else
											return 0;
										end
									elseif SN > "TRAIT47101316CHOICE" then
										if SN < "TRAIT56789CHOICE" then
											if SN == "TRAIT567810CHOICE" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({5,6,7,8,10},L);
												end
											else
												return 0;
											end
										elseif SN > "TRAIT56789CHOICE" then
											if SN == "TRAIT58121620CHOICE" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({5,8,12,16,20},L);
												end
											else
												return 0;
											end
										else
											if Lm <= 0 then
												return 0;
											else
												return DataTableValue({5,6,7,8,9},L);
											end
										end
									else
										if Lm <= 0 then
											return 0;
										else
											return DataTableValue({4,7,10,13,16},L);
										end
									end
								else
									if Lm <= 0 then
										return 0;
									else
										return DataTableValue({2,3,4,5,6},L);
									end
								end
							elseif SN > "TRAITPROG" then
								if SN < "VIRTCOMPASSIONARMOUR" then
									if SN < "VIRTCHARITYPHYMIT" then
										if SN > "TRAITPROGVITAL" then
											if SN == "VARMOUR" then
												return RoundDbl(StatLinInter("PntMPArmourVirtues","ItemProg","ProgBArmourLight","",L,N,0));
											else
												return 0;
											end
										elseif SN == "TRAITPROGVITAL" then
											return {{1,25,50,60,65,75,85,95,100,105,115,120,130,140,150},{1,25,50,60,65,75,85,95,100,105,115,120,130,140,150}};
										else
											return 0;
										end
									elseif SN > "VIRTCHARITYPHYMIT" then
										if SN < "VIRTCHARITYVITALITY" then
											if SN == "VIRTCHARITYRESIST" then
												return CalcStat("VSResistH",L);
											else
												return 0;
											end
										elseif SN > "VIRTCHARITYVITALITY" then
											if SN == "VIRTCHARITYVPMORALE" then
												return CalcStat("VSVPMorale",L);
											else
												return 0;
											end
										else
											return CalcStat("VSVitalityL",L);
										end
									else
										return CalcStat("VSPhyMitM",L);
									end
								elseif SN > "VIRTCOMPASSIONARMOUR" then
									if SN < "VIRTCOMPASSIONVPMORALE" then
										if SN > "VIRTCOMPASSIONPHYMIT" then
											if SN == "VIRTCOMPASSIONTACMIT" then
												return CalcStat("VSTacMitM",L);
											else
												return 0;
											end
										elseif SN == "VIRTCOMPASSIONPHYMIT" then
											return CalcStat("VSPhyMitH",L);
										else
											return 0;
										end
									elseif SN > "VIRTCOMPASSIONVPMORALE" then
										if SN < "VIRTCONFIDENCEEVADE" then
											if SN == "VIRTCONFIDENCECRITHIT" then
												return CalcStat("VSCritHitH",L);
											else
												return 0;
											end
										elseif SN > "VIRTCONFIDENCEEVADE" then
											if SN == "VIRTCONFIDENCEFINESSE" then
												return CalcStat("VSFinesseM",L);
											else
												return 0;
											end
										else
											return CalcStat("VSEvadeL",L);
										end
									else
										return CalcStat("VSVPMorale",L);
									end
								else
									return CalcStat("VSArmourL",L);
								end
							else
								return {{1,25,50,60,65,75,85,95,100,105,115,120,130,131,140,141},{1,25,50,60,65,75,85,95,100,105,115,120,130,131,140,141}};
							end
						elseif SN > "VIRTCONFIDENCEVPPHYMAS" then
							if SN < "VIRTEMPATHYVPMORALE" then
								if SN < "VIRTDISCIPLINEINHEAL" then
									if SN < "VIRTDETERMINATIONCRITHIT" then
										if SN > "VIRTCONFIDENCEVPTACMAS" then
											if SN == "VIRTDETERMINATIONAGILITY" then
												return CalcStat("VSAgilityH",L);
											else
												return 0;
											end
										elseif SN == "VIRTCONFIDENCEVPTACMAS" then
											return CalcStat("VSVPTacMas",L);
										else
											return 0;
										end
									elseif SN > "VIRTDETERMINATIONCRITHIT" then
										if SN < "VIRTDETERMINATIONVPPHYMAS" then
											if SN == "VIRTDETERMINATIONPHYMAS" then
												return CalcStat("VSPhyMasM",L);
											else
												return 0;
											end
										elseif SN > "VIRTDETERMINATIONVPPHYMAS" then
											if SN == "VIRTDETERMINATIONVPTACMAS" then
												return CalcStat("VSVPTacMas",L);
											else
												return 0;
											end
										else
											return CalcStat("VSVPPhyMas",L);
										end
									else
										return CalcStat("VSCritHitL",L);
									end
								elseif SN > "VIRTDISCIPLINEINHEAL" then
									if SN < "VIRTDISCIPLINEVPMORALE" then
										if SN > "VIRTDISCIPLINEPHYMIT" then
											if SN == "VIRTDISCIPLINERESIST" then
												return CalcStat("VSResistH",L);
											else
												return 0;
											end
										elseif SN == "VIRTDISCIPLINEPHYMIT" then
											return CalcStat("VSPhyMitL",L);
										else
											return 0;
										end
									elseif SN > "VIRTDISCIPLINEVPMORALE" then
										if SN < "VIRTEMPATHYCRITDEF" then
											if SN == "VIRTEMPATHYARMOUR" then
												return CalcStat("VSArmourH",L);
											else
												return 0;
											end
										elseif SN > "VIRTEMPATHYCRITDEF" then
											if SN == "VIRTEMPATHYRESIST" then
												return CalcStat("VSResistL",L);
											else
												return 0;
											end
										else
											return CalcStat("VSCritDefM",L);
										end
									else
										return CalcStat("VSVPMorale",L);
									end
								else
									return CalcStat("VSInHealM",L);
								end
							elseif SN > "VIRTEMPATHYVPMORALE" then
								if SN < "VIRTFORTITUDERESIST" then
									if SN < "VIRTFIDELITYVITALITY" then
										if SN > "VIRTFIDELITYPHYMIT" then
											if SN == "VIRTFIDELITYTACMIT" then
												return CalcStat("VSTacMitH",L);
											else
												return 0;
											end
										elseif SN == "VIRTFIDELITYPHYMIT" then
											return CalcStat("VSPhyMitL",L);
										else
											return 0;
										end
									elseif SN > "VIRTFIDELITYVITALITY" then
										if SN < "VIRTFORTITUDECRITDEF" then
											if SN == "VIRTFIDELITYVPMORALE" then
												return CalcStat("VSVPMorale",L);
											else
												return 0;
											end
										elseif SN > "VIRTFORTITUDECRITDEF" then
											if SN == "VIRTFORTITUDEMORALE" then
												return CalcStat("VSMoraleH",L);
											else
												return 0;
											end
										else
											return CalcStat("VSCritDefM",L);
										end
									else
										return CalcStat("VSVitalityM",L);
									end
								elseif SN > "VIRTFORTITUDERESIST" then
									if SN < "VIRTHONESTYTACMAS" then
										if SN > "VIRTFORTITUDEVPMORALE" then
											if SN == "VIRTHONESTYCRITHIT" then
												return CalcStat("VSCritHitL",L);
											else
												return 0;
											end
										elseif SN == "VIRTFORTITUDEVPMORALE" then
											return CalcStat("VSVPMorale",L);
										else
											return 0;
										end
									elseif SN > "VIRTHONESTYTACMAS" then
										if SN < "VIRTHONESTYVPTACMAS" then
											if SN == "VIRTHONESTYVPPHYMAS" then
												return CalcStat("VSVPPhyMas",L);
											else
												return 0;
											end
										elseif SN > "VIRTHONESTYVPTACMAS" then
											if SN == "VIRTHONESTYWILL" then
												return CalcStat("VSWillM",L);
											else
												return 0;
											end
										else
											return CalcStat("VSVPTacMas",L);
										end
									else
										return CalcStat("VSTacMasH",L);
									end
								else
									return CalcStat("VSResistL",L);
								end
							else
								return CalcStat("VSVPMorale",L);
							end
						else
							return CalcStat("VSVPPhyMas",L);
						end
					elseif SN > "VIRTHONOURCRITDEF" then
						if SN < "VIRTRNKCOST" then
							if SN < "VIRTJUSTICETACMIT" then
								if SN < "VIRTIDEALISMVPMORALE" then
									if SN < "VIRTHONOURVPMORALE" then
										if SN > "VIRTHONOURMORALE" then
											if SN == "VIRTHONOURTACMIT" then
												return CalcStat("VSTacMitM",L);
											else
												return 0;
											end
										elseif SN == "VIRTHONOURMORALE" then
											return CalcStat("VSMoraleH",L);
										else
											return 0;
										end
									elseif SN > "VIRTHONOURVPMORALE" then
										if SN < "VIRTIDEALISMINHEAL" then
											if SN == "VIRTIDEALISMFATE" then
												return CalcStat("VSFateH",L);
											else
												return 0;
											end
										elseif SN > "VIRTIDEALISMINHEAL" then
											if SN == "VIRTIDEALISMMORALE" then
												return CalcStat("VSMoraleL",L);
											else
												return 0;
											end
										else
											return CalcStat("VSInHealM",L);
										end
									else
										return CalcStat("VSVPMorale",L);
									end
								elseif SN > "VIRTIDEALISMVPMORALE" then
									if SN < "VIRTINNOCENCETACMIT" then
										if SN > "VIRTINNOCENCEPHYMIT" then
											if SN == "VIRTINNOCENCERESIST" then
												return CalcStat("VSResistM",L);
											else
												return 0;
											end
										elseif SN == "VIRTINNOCENCEPHYMIT" then
											return CalcStat("VSPhyMitH",L);
										else
											return 0;
										end
									elseif SN > "VIRTINNOCENCETACMIT" then
										if SN < "VIRTJUSTICEICMR" then
											if SN == "VIRTINNOCENCEVPMORALE" then
												return CalcStat("VSVPMorale",L);
											else
												return 0;
											end
										elseif SN > "VIRTJUSTICEICMR" then
											if SN == "VIRTJUSTICEMORALE" then
												return CalcStat("VSMoraleM",L);
											else
												return 0;
											end
										else
											return CalcStat("VSICMRH",L);
										end
									else
										return CalcStat("VSTacMitL",L);
									end
								else
									return CalcStat("VSVPMorale",L);
								end
							elseif SN > "VIRTJUSTICETACMIT" then
								if SN < "VIRTMERCYFATE" then
									if SN < "VIRTLOYALTYINHEAL" then
										if SN > "VIRTJUSTICEVPMORALE" then
											if SN == "VIRTLOYALTYARMOUR" then
												return CalcStat("VSArmourM",L);
											else
												return 0;
											end
										elseif SN == "VIRTJUSTICEVPMORALE" then
											return CalcStat("VSVPMorale",L);
										else
											return 0;
										end
									elseif SN > "VIRTLOYALTYINHEAL" then
										if SN < "VIRTLOYALTYVPMORALE" then
											if SN == "VIRTLOYALTYVITALITY" then
												return CalcStat("VSVitalityH",L);
											else
												return 0;
											end
										elseif SN > "VIRTLOYALTYVPMORALE" then
											if SN == "VIRTMERCYEVADE" then
												return CalcStat("VSEvadeH",L);
											else
												return 0;
											end
										else
											return CalcStat("VSVPMorale",L);
										end
									else
										return CalcStat("VSInHealL",L);
									end
								elseif SN > "VIRTMERCYFATE" then
									if SN < "VIRTPATIENCECRITHIT" then
										if SN > "VIRTMERCYVITALITY" then
											if SN == "VIRTMERCYVPMORALE" then
												return CalcStat("VSVPMorale",L);
											else
												return 0;
											end
										elseif SN == "VIRTMERCYVITALITY" then
											return CalcStat("VSVitalityL",L);
										else
											return 0;
										end
									elseif SN > "VIRTPATIENCECRITHIT" then
										if SN < "VIRTPATIENCEPOWER" then
											if SN == "VIRTPATIENCEEVADE" then
												return CalcStat("VSEvadeM",L);
											else
												return 0;
											end
										elseif SN > "VIRTPATIENCEPOWER" then
											if SN == "VIRTPATIENCEVPMORALE" then
												return CalcStat("VSVPMorale",L);
											else
												return 0;
											end
										else
											return CalcStat("VSPowerH",L);
										end
									else
										return CalcStat("VSCritHitL",L);
									end
								else
									return CalcStat("VSFateM",L);
								end
							else
								return CalcStat("VSTacMitL",L);
							end
						elseif SN > "VIRTRNKCOST" then
							if SN < "VIRTWISDOMVPTACMAS" then
								if SN < "VIRTVALOURFINESSE" then
									if SN < "VIRTTOLERANCERESIST" then
										if SN > "VIRTRNKCOSTTOT" then
											if SN == "VIRTTOLERANCEPHYMIT" then
												return CalcStat("VSPhyMitL",L);
											else
												return 0;
											end
										elseif SN == "VIRTRNKCOSTTOT" then
											if Lm <= 0 then
												return 0;
											else
												return CalcStat("VirtRnkCostTot",L-1)+CalcStat("VirtRnkCost",L);
											end
										else
											return 0;
										end
									elseif SN > "VIRTTOLERANCERESIST" then
										if SN < "VIRTTOLERANCEVPMORALE" then
											if SN == "VIRTTOLERANCETACMIT" then
												return CalcStat("VSTacMitH",L);
											else
												return 0;
											end
										elseif SN > "VIRTTOLERANCEVPMORALE" then
											if SN == "VIRTVALOURCRITHIT" then
												return CalcStat("VSCritHitL",L);
											else
												return 0;
											end
										else
											return CalcStat("VSVPMorale",L);
										end
									else
										return CalcStat("VSResistM",L);
									end
								elseif SN > "VIRTVALOURFINESSE" then
									if SN < "VIRTVALOURVPTACMAS" then
										if SN > "VIRTVALOURPHYMAS" then
											if SN == "VIRTVALOURVPPHYMAS" then
												return CalcStat("VSVPPhyMas",L);
											else
												return 0;
											end
										elseif SN == "VIRTVALOURPHYMAS" then
											return CalcStat("VSPhyMasH",L);
										else
											return 0;
										end
									elseif SN > "VIRTVALOURVPTACMAS" then
										if SN < "VIRTWISDOMTACMAS" then
											if SN == "VIRTWISDOMFINESSE" then
												return CalcStat("VSFinesseL",L);
											else
												return 0;
											end
										elseif SN > "VIRTWISDOMTACMAS" then
											if SN == "VIRTWISDOMVPPHYMAS" then
												return CalcStat("VSVPPhyMas",L);
											else
												return 0;
											end
										else
											return CalcStat("VSTacMasM",L);
										end
									else
										return CalcStat("VSVPTacMas",L);
									end
								else
									return CalcStat("VSFinesseM",L);
								end
							elseif SN > "VIRTWISDOMVPTACMAS" then
								if SN < "VIRTWITVPTACMAS" then
									if SN < "VIRTWITFINESSE" then
										if SN > "VIRTWISDOMWILL" then
											if SN == "VIRTWITCRITHIT" then
												return CalcStat("VSCritHitM",L);
											else
												return 0;
											end
										elseif SN == "VIRTWISDOMWILL" then
											return CalcStat("VSWillH",L);
										else
											return 0;
										end
									elseif SN > "VIRTWITFINESSE" then
										if SN < "VIRTWITTACMAS" then
											if SN == "VIRTWITPHYMAS" then
												return CalcStat("VSPhyMasL",L);
											else
												return 0;
											end
										elseif SN > "VIRTWITTACMAS" then
											if SN == "VIRTWITVPPHYMAS" then
												return CalcStat("VSVPPhyMas",L);
											else
												return 0;
											end
										else
											return CalcStat("VSTacMasL",L);
										end
									else
										return CalcStat("VSFinesseH",L);
									end
								elseif SN > "VIRTWITVPTACMAS" then
									if SN < "VIRTZEALVPPHYMAS" then
										if SN < "VIRTZEALMIGHT" then
											if SN == "VIRTZEALCRITHIT" then
												return CalcStat("VSCritHitL",L);
											else
												return 0;
											end
										elseif SN > "VIRTZEALMIGHT" then
											if SN == "VIRTZEALPHYMAS" then
												return CalcStat("VSPhyMasM",L);
											else
												return 0;
											end
										else
											return CalcStat("VSMightH",L);
										end
									elseif SN > "VIRTZEALVPPHYMAS" then
										if SN < "VITALITY" then
											if SN == "VIRTZEALVPTACMAS" then
												return CalcStat("VSVPTacMas",L);
											else
												return 0;
											end
										elseif SN > "VITALITY" then
											if SN == "VITALITYADJ" then
												if Lm <= 25 then
													return 0.5;
												elseif Lm <= 50 then
													return 0.6;
												elseif Lm <= 60 then
													return 0.7;
												elseif Lm <= 79 then
													return 0.8;
												elseif Lm <= 80 then
													return 0.9;
												else
													return 1;
												end
											else
												return 0;
											end
										else
											return RoundDblDown(StatLinInter("PntMPVitality","ItemProgVital","ProgBVitality","VitalityAdj",L,N,0));
										end
									else
										return CalcStat("VSVPPhyMas",L);
									end
								else
									return CalcStat("VSVPTacMas",L);
								end
							else
								return CalcStat("VSVPTacMas",L);
							end
						else
							if Lm <= 0 then
								return 0;
							elseif Lm <= 10 then
								return 1000;
							elseif Lm <= 60 then
								return RoundDbl(18*L+878,-2);
							elseif Lm <= 73 then
								return RoundDbl(18.75*L+878,-2);
							else
								return RoundDbl(17.45*L+878,-2);
							end
						end
					else
						return CalcStat("VSCritDefL",L);
					end
				elseif SN > "VITALITYT" then
					if SN < "VSPOWERM" then
						if SN < "VSEVADEL" then
							if SN < "VRNKTOILVL" then
								if SN < "VMMASTERYPSV" then
									if SN < "VMASTERYADJ" then
										if SN > "VITALITYTADJ" then
											if SN == "VMASTERY" then
												return StatLinInter("PntMPMastery","ItemProgVirtueMastery","ProgBMastery","VMasteryAdj",L,N,0);
											else
												return 0;
											end
										elseif SN == "VITALITYTADJ" then
											if Lm <= 25 then
												return 0.5;
											elseif Lm <= 50 then
												return 0.6;
											elseif Lm <= 60 then
												return 0.7;
											elseif Lm <= 65 then
												return 0.8;
											elseif Lm <= 75 then
												return 0.9;
											else
												return 1;
											end
										else
											return 0;
										end
									elseif SN > "VMASTERYADJ" then
										if SN < "VMHIGH" then
											if SN == "VMASTERYOLD" then
												return CalcStat("VMastery",L,N);
											else
												return 0;
											end
										elseif SN > "VMHIGH" then
											if SN == "VMLOW" then
												if Lm <= 0 then
													return 0;
												else
													return CalcStat(C,CalcStat("VRnkToILvl",L),0.6);
												end
											else
												return 0;
											end
										else
											if Lm <= 0 then
												return 0;
											else
												return CalcStat(C,CalcStat("VRnkToILvl",L),2.0);
											end
										end
									else
										if Lm <= 0 then
											return 0;
										else
											return 1;
										end
									end
								elseif SN > "VMMASTERYPSV" then
									if SN < "VMORALE" then
										if SN > "VMMEDIUM" then
											if SN == "VMMORALEPSV" then
												if Lm <= 0 then
													return 0;
												else
													return CalcStat("VMorale",CalcStat("VRnkToILvl",L),0.3);
												end
											else
												return 0;
											end
										elseif SN == "VMMEDIUM" then
											if Lm <= 0 then
												return 0;
											else
												return CalcStat(C,CalcStat("VRnkToILvl",L),1.0);
											end
										else
											return 0;
										end
									elseif SN > "VMORALE" then
										if SN < "VRNKCAP" then
											if SN == "VMORALEADJ" then
												if Lm <= 0 then
													return 0;
												elseif Lm <= 2 then
													return 1;
												elseif Lm <= 50 then
													return 1.5;
												elseif Lm <= 80 then
													return 1.028;
												elseif Lm <= 349 then
													return 1;
												elseif Lm <= 350 then
													return 1.042;
												elseif Lm <= 399 then
													return 93.72/99;
												elseif Lm <= 400 then
													return 86/99;
												elseif Lm <= 449 then
													return 0.9475;
												elseif Lm <= 450 then
													return 86/99;
												elseif Lm <= 499 then
													return 0.9475;
												else
													return 86/99;
												end
											else
												return 0;
											end
										elseif SN > "VRNKCAP" then
											if SN == "VRNKLVLCAP" then
												if Lm <= 4 then
													return 2;
												elseif Lm <= 110 then
													return RoundDblDown(L/2);
												elseif Lm <= 139 then
													return L-55;
												else
													return 88;
												end
											else
												return 0;
											end
										else
											return 85;
										end
									else
										return StatLinInter("PntMPMoraleVirtues","ItemProgVirtueMorale","ProgBMorale","VMoraleAdj",L,N,0);
									end
								else
									if Lm <= 0 then
										return 0;
									else
										return CalcStat("VMastery",CalcStat("VRnkToILvl",L),0.2);
									end
								end
							elseif SN > "VRNKTOILVL" then
								if SN < "VSCRITDEFH" then
									if SN < "VSAGILITYM" then
										if SN > "VSAGILITYH" then
											if SN == "VSAGILITYL" then
												return CalcStat("VMLow",L,"Agility");
											else
												return 0;
											end
										elseif SN == "VSAGILITYH" then
											return CalcStat("VMHigh",L,"Agility");
										else
											return 0;
										end
									elseif SN > "VSAGILITYM" then
										if SN < "VSARMOURL" then
											if SN == "VSARMOURH" then
												return CalcStat("VMHigh",L,"Varmour");
											else
												return 0;
											end
										elseif SN > "VSARMOURL" then
											if SN == "VSARMOURM" then
												return CalcStat("VMMedium",L,"Varmour");
											else
												return 0;
											end
										else
											return CalcStat("VMLow",L,"Varmour");
										end
									else
										return CalcStat("VMMedium",L,"Agility");
									end
								elseif SN > "VSCRITDEFH" then
									if SN < "VSCRITHITH" then
										if SN > "VSCRITDEFL" then
											if SN == "VSCRITDEFM" then
												return CalcStat("VMMedium",L,"CritDef");
											else
												return 0;
											end
										elseif SN == "VSCRITDEFL" then
											return CalcStat("VMLow",L,"CritDef");
										else
											return 0;
										end
									elseif SN > "VSCRITHITH" then
										if SN < "VSCRITHITM" then
											if SN == "VSCRITHITL" then
												return CalcStat("VMLow",L,"CritHit");
											else
												return 0;
											end
										elseif SN > "VSCRITHITM" then
											if SN == "VSEVADEH" then
												return CalcStat("VMHigh",L,"Evade");
											else
												return 0;
											end
										else
											return CalcStat("VMMedium",L,"CritHit");
										end
									else
										return CalcStat("VMHigh",L,"CritHit");
									end
								else
									return CalcStat("VMHigh",L,"CritDef");
								end
							else
								if Lm <= 0 then
									return 0;
								elseif Lm <= 38 then
									return LinFmod(1,4,78,1,38,L);
								elseif Lm <= 48 then
									return LinFmod(1,78,178,38,48,L);
								elseif Lm <= 49 then
									return LinFmod(1,178,190,48,49,L);
								elseif Lm <= 50 then
									return LinFmod(1,190,210,49,50,L);
								elseif Lm <= 51 then
									return LinFmod(1,210,222,50,51,L);
								elseif Lm <= 52 then
									return LinFmod(1,222,236,51,52,L);
								elseif Lm <= 53 then
									return LinFmod(1,236,260,52,53,L);
								elseif Lm <= 55 then
									return LinFmod(1,260,292,53,55,L);
								elseif Lm <= 68 then
									return LinFmod(1,292,396,55,68,L);
								else
									return LinFmod(1,396,706,68,130,L);
								end
							end
						elseif SN > "VSEVADEL" then
							if SN < "VSMIGHTH" then
								if SN < "VSFINESSEM" then
									if SN < "VSFATEL" then
										if SN > "VSEVADEM" then
											if SN == "VSFATEH" then
												return CalcStat("VMHigh",L,"Fate");
											else
												return 0;
											end
										elseif SN == "VSEVADEM" then
											return CalcStat("VMMedium",L,"Evade");
										else
											return 0;
										end
									elseif SN > "VSFATEL" then
										if SN < "VSFINESSEH" then
											if SN == "VSFATEM" then
												return CalcStat("VMMedium",L,"Fate");
											else
												return 0;
											end
										elseif SN > "VSFINESSEH" then
											if SN == "VSFINESSEL" then
												return CalcStat("VMLow",L,"Finesse");
											else
												return 0;
											end
										else
											return CalcStat("VMHigh",L,"Finesse");
										end
									else
										return CalcStat("VMLow",L,"Fate");
									end
								elseif SN > "VSFINESSEM" then
									if SN < "VSICMRM" then
										if SN > "VSICMRH" then
											if SN == "VSICMRL" then
												return CalcStat("VMLow",L,"ICMR");
											else
												return 0;
											end
										elseif SN == "VSICMRH" then
											return CalcStat("VMHigh",L,"ICMR");
										else
											return 0;
										end
									elseif SN > "VSICMRM" then
										if SN < "VSINHEALL" then
											if SN == "VSINHEALH" then
												return CalcStat("VMHigh",L,"InHeal");
											else
												return 0;
											end
										elseif SN > "VSINHEALL" then
											if SN == "VSINHEALM" then
												return CalcStat("VMMedium",L,"InHeal");
											else
												return 0;
											end
										else
											return CalcStat("VMLow",L,"InHeal");
										end
									else
										return CalcStat("VMMedium",L,"ICMR");
									end
								else
									return CalcStat("VMMedium",L,"Finesse");
								end
							elseif SN > "VSMIGHTH" then
								if SN < "VSPHYMASL" then
									if SN < "VSMORALEH" then
										if SN > "VSMIGHTL" then
											if SN == "VSMIGHTM" then
												return CalcStat("VMMedium",L,"Might");
											else
												return 0;
											end
										elseif SN == "VSMIGHTL" then
											return CalcStat("VMLow",L,"Might");
										else
											return 0;
										end
									elseif SN > "VSMORALEH" then
										if SN < "VSMORALEM" then
											if SN == "VSMORALEL" then
												return CalcStat("VMLow",L,"VMorale");
											else
												return 0;
											end
										elseif SN > "VSMORALEM" then
											if SN == "VSPHYMASH" then
												return CalcStat("VMHigh",L,"PhyMas");
											else
												return 0;
											end
										else
											return CalcStat("VMMedium",L,"VMorale");
										end
									else
										return CalcStat("VMHigh",L,"VMorale");
									end
								elseif SN > "VSPHYMASL" then
									if SN < "VSPHYMITL" then
										if SN > "VSPHYMASM" then
											if SN == "VSPHYMITH" then
												return CalcStat("VMHigh",L,"PhyMit");
											else
												return 0;
											end
										elseif SN == "VSPHYMASM" then
											return CalcStat("VMMedium",L,"PhyMas");
										else
											return 0;
										end
									elseif SN > "VSPHYMITL" then
										if SN < "VSPOWERH" then
											if SN == "VSPHYMITM" then
												return CalcStat("VMMedium",L,"PhyMit");
											else
												return 0;
											end
										elseif SN > "VSPOWERH" then
											if SN == "VSPOWERL" then
												return CalcStat("VMLow",L,"Power");
											else
												return 0;
											end
										else
											return CalcStat("VMHigh",L,"Power");
										end
									else
										return CalcStat("VMLow",L,"PhyMit");
									end
								else
									return CalcStat("VMLow",L,"PhyMas");
								end
							else
								return CalcStat("VMHigh",L,"Might");
							end
						else
							return CalcStat("VMLow",L,"Evade");
						end
					elseif SN > "VSPOWERM" then
						if SN < "WARDENCDBASEFATE" then
							if SN < "VSVPPHYMAS" then
								if SN < "VSTACMITH" then
									if SN < "VSRESISTM" then
										if SN > "VSRESISTH" then
											if SN == "VSRESISTL" then
												return CalcStat("VMLow",L,"Resist");
											else
												return 0;
											end
										elseif SN == "VSRESISTH" then
											return CalcStat("VMHigh",L,"Resist");
										else
											return 0;
										end
									elseif SN > "VSRESISTM" then
										if SN < "VSTACMASL" then
											if SN == "VSTACMASH" then
												return CalcStat("VMHigh",L,"TacMas");
											else
												return 0;
											end
										elseif SN > "VSTACMASL" then
											if SN == "VSTACMASM" then
												return CalcStat("VMMedium",L,"TacMas");
											else
												return 0;
											end
										else
											return CalcStat("VMLow",L,"TacMas");
										end
									else
										return CalcStat("VMMedium",L,"Resist");
									end
								elseif SN > "VSTACMITH" then
									if SN < "VSVITALITYH" then
										if SN > "VSTACMITL" then
											if SN == "VSTACMITM" then
												return CalcStat("VMMedium",L,"TacMit");
											else
												return 0;
											end
										elseif SN == "VSTACMITL" then
											return CalcStat("VMLow",L,"TacMit");
										else
											return 0;
										end
									elseif SN > "VSVITALITYH" then
										if SN < "VSVITALITYM" then
											if SN == "VSVITALITYL" then
												return CalcStat("VMLow",L,"Vitality");
											else
												return 0;
											end
										elseif SN > "VSVITALITYM" then
											if SN == "VSVPMORALE" then
												return CalcStat("VMMoralePsv",L);
											else
												return 0;
											end
										else
											return CalcStat("VMMedium",L,"Vitality");
										end
									else
										return CalcStat("VMHigh",L,"Vitality");
									end
								else
									return CalcStat("VMHigh",L,"TacMit");
								end
							elseif SN > "VSVPPHYMAS" then
								if SN < "WARDENCDAGILITYTOPARRY" then
									if SN < "VSWILLL" then
										if SN > "VSVPTACMAS" then
											if SN == "VSWILLH" then
												return CalcStat("VMHigh",L,"Will");
											else
												return 0;
											end
										elseif SN == "VSVPTACMAS" then
											return CalcStat("VMMasteryPsv",L);
										else
											return 0;
										end
									elseif SN > "VSWILLL" then
										if SN < "WARDENCDAGILITYTOCRITHIT" then
											if SN == "VSWILLM" then
												return CalcStat("VMMedium",L,"Will");
											else
												return 0;
											end
										elseif SN > "WARDENCDAGILITYTOCRITHIT" then
											if SN == "WARDENCDAGILITYTOEVADE" then
												return 3;
											else
												return 0;
											end
										else
											return 1;
										end
									else
										return CalcStat("VMLow",L,"Will");
									end
								elseif SN > "WARDENCDAGILITYTOPARRY" then
									if SN < "WARDENCDARMOURTOPHYMIT" then
										if SN > "WARDENCDAGILITYTOPHYMAS" then
											if SN == "WARDENCDARMOURTOOFMIT" then
												return 0.2;
											else
												return 0;
											end
										elseif SN == "WARDENCDAGILITYTOPHYMAS" then
											return 3;
										else
											return 0;
										end
									elseif SN > "WARDENCDARMOURTOPHYMIT" then
										if SN < "WARDENCDARMOURTYPE" then
											if SN == "WARDENCDARMOURTOTACMIT" then
												return 0.2;
											else
												return 0;
											end
										elseif SN > "WARDENCDARMOURTYPE" then
											if SN == "WARDENCDBASEAGILITY" then
												return CalcStat("ClassBaseAgilityH",L);
											else
												return 0;
											end
										else
											return 2;
										end
									else
										return 1;
									end
								else
									return 2;
								end
							else
								return CalcStat("VMMasteryPsv",L);
							end
						elseif SN > "WARDENCDBASEFATE" then
							if SN < "WARDENCDFATETONCPR" then
								if SN < "WARDENCDBASEPOWER" then
									if SN < "WARDENCDBASEMIGHT" then
										if SN > "WARDENCDBASEICMR" then
											if SN == "WARDENCDBASEICPR" then
												return CalcStat("ClassBaseICPR",L);
											else
												return 0;
											end
										elseif SN == "WARDENCDBASEICMR" then
											return CalcStat("ClassBaseICMRH",L);
										else
											return 0;
										end
									elseif SN > "WARDENCDBASEMIGHT" then
										if SN < "WARDENCDBASENCMR" then
											if SN == "WARDENCDBASEMORALE" then
												return CalcStat("ClassBaseMorale",L);
											else
												return 0;
											end
										elseif SN > "WARDENCDBASENCMR" then
											if SN == "WARDENCDBASENCPR" then
												return CalcStat("ClassBaseNCPR",L);
											else
												return 0;
											end
										else
											return CalcStat("ClassBaseNCMRH",L);
										end
									else
										return CalcStat("ClassBaseMightM",L);
									end
								elseif SN > "WARDENCDBASEPOWER" then
									if SN < "WARDENCDCANBLOCK" then
										if SN > "WARDENCDBASEVITALITY" then
											if SN == "WARDENCDBASEWILL" then
												return CalcStat("ClassBaseWillL",L);
											else
												return 0;
											end
										elseif SN == "WARDENCDBASEVITALITY" then
											return CalcStat("ClassBaseVitality",L);
										else
											return 0;
										end
									elseif SN > "WARDENCDCANBLOCK" then
										if SN < "WARDENCDFATETOFINESSE" then
											if SN == "WARDENCDFATETOCRITHIT" then
												return 1.5;
											else
												return 0;
											end
										elseif SN > "WARDENCDFATETOFINESSE" then
											if SN == "WARDENCDFATETOICMR" then
												return 0.025;
											else
												return 0;
											end
										else
											return 0.5;
										end
									else
										return 1;
									end
								else
									return CalcStat("ClassBasePower",L);
								end
							elseif SN > "WARDENCDFATETONCPR" then
								if SN < "WARDENCDMIGHTTOPHYMAS" then
									if SN < "WARDENCDFATETOTACMIT" then
										if SN > "WARDENCDFATETOPOWER" then
											if SN == "WARDENCDFATETORESIST" then
												return 0.5;
											else
												return 0;
											end
										elseif SN == "WARDENCDFATETOPOWER" then
											return 1;
										else
											return 0;
										end
									elseif SN > "WARDENCDFATETOTACMIT" then
										if SN < "WARDENCDMIGHTTOBLOCK" then
											if SN == "WARDENCDHASPOWER" then
												return 1;
											else
												return 0;
											end
										elseif SN > "WARDENCDMIGHTTOBLOCK" then
											if SN == "WARDENCDMIGHTTOPARRY" then
												return 2;
											else
												return 0;
											end
										else
											return 3;
										end
									else
										return 0.5;
									end
								elseif SN > "WARDENCDMIGHTTOPHYMAS" then
									if SN < "WARDENCDVITALITYTONCMR" then
										if SN < "WARDENCDTACMASTOOUTHEAL" then
											if SN == "WARDENCDPHYMITTOOFMIT" then
												return 1;
											else
												return 0;
											end
										elseif SN > "WARDENCDTACMASTOOUTHEAL" then
											if SN == "WARDENCDVITALITYTOMORALE" then
												return 4.8;
											else
												return 0;
											end
										else
											return 1;
										end
									elseif SN > "WARDENCDVITALITYTONCMR" then
										if SN < "WARDENCDWILLTORESIST" then
											if SN == "WARDENCDVITALITYTORESIST" then
												return 0.5;
											else
												return 0;
											end
										elseif SN > "WARDENCDWILLTORESIST" then
											if SN == "WARDENCDWILLTOTACMIT" then
												return 1;
											else
												return 0;
											end
										else
											return 2;
										end
									else
										return 0.12;
									end
								else
									return 2;
								end
							else
								return 0.05;
							end
						else
							return CalcStat("ClassBaseFate",L);
						end
					else
						return CalcStat("VMMedium",L,"Power");
					end
				else
					return RoundDblDown(StatLinInter("PntMPVitalityT","TraitProgVital","ProgBVitality","VitalityTAdj",L,N,0));
				end
			elseif SN > "WARDINGLOREPHYMIT" then
				if SN < "WORTHVALA" then
					if SN < "WORTHTABBK" then
						if SN < "WORTHTABAL" then
							if SN < "WORTHMPJ" then
								if SN < "WORTHMPC" then
									if SN < "WILLT" then
										if SN > "WARDINGLORETACMIT" then
											if SN == "WILL" then
												return CalcStat("Main",L,N);
											else
												return 0;
											end
										elseif SN == "WARDINGLORETACMIT" then
											if Lm <= 105 then
												return CalcStat("Mitigation",L,1.6);
											elseif Lm <= 119 then
												return CalcStat("TacMitT",L,1.2);
											elseif Lm <= 120 then
												return CalcStat("TacMitT",L,1.6);
											elseif Lm <= 129 then
												return CalcStat("TacMitT",L,1.2);
											elseif Lm <= 130 then
												return CalcStat("TacMitT",L,1.6);
											elseif Lm <= 139 then
												return CalcStat("TacMitT",L,1.2);
											else
												return CalcStat("TacMitT",L,1.6);
											end
										else
											return 0;
										end
									elseif SN > "WILLT" then
										if SN < "WORTHMPA" then
											if SN == "WORTHEXT" then
												if Lm <= 360 then
													return RoundDbl(CalcStat("StatC",L,C));
												elseif Lm <= 501 then
													return RoundDbl(CalcStat("StatC",L-1,C));
												else
													return 0;
												end
											else
												return 0;
											end
										elseif SN > "WORTHMPA" then
											if SN == "WORTHMPB" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({1,1.2,2,3,4},L);
												end
											else
												return 0;
											end
										else
											if Lm <= 0 then
												return 0;
											else
												return DataTableValue({1,1.1,1.15,1.2,1.3},L);
											end
										end
									else
										return CalcStat("MainT",L,N);
									end
								elseif SN > "WORTHMPC" then
									if SN < "WORTHMPF" then
										if SN > "WORTHMPD" then
											if SN == "WORTHMPE" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({1,1.1,1.15,1.2,1.25},L);
												end
											else
												return 0;
											end
										elseif SN == "WORTHMPD" then
											if Lm <= 0 then
												return 0;
											else
												return DataTableValue({1,1,1,2,3},L);
											end
										else
											return 0;
										end
									elseif SN > "WORTHMPF" then
										if SN < "WORTHMPH" then
											if SN == "WORTHMPG" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({1,2,3,4,5},L);
												end
											else
												return 0;
											end
										elseif SN > "WORTHMPH" then
											if SN == "WORTHMPI" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({1,2,2.5,3,10},L);
												end
											else
												return 0;
											end
										else
											if Lm <= 0 then
												return 0;
											else
												return DataTableValue({1,1.2,1.8,3.2,5},L);
											end
										end
									else
										if Lm <= 0 then
											return 0;
										else
											return DataTableValue({0.5,1,1.25,1.5,2},L);
										end
									end
								else
									if Lm <= 0 then
										return 0;
									else
										return 1;
									end
								end
							elseif SN > "WORTHMPJ" then
								if SN < "WORTHTABAE" then
									if SN < "WORTHTABAA" then
										if SN > "WORTHMPK" then
											if SN == "WORTHTABA" then
												if Lm <= 1 then
													return 1;
												else
													return CalcStat("WorthTabAF",L);
												end
											else
												return 0;
											end
										elseif SN == "WORTHMPK" then
											if Lm <= 0 then
												return 0;
											else
												return DataTableValue({1,1.2,1.3,1.35,1.4},L);
											end
										else
											return 0;
										end
									elseif SN > "WORTHTABAA" then
										if SN < "WORTHTABAC" then
											if SN == "WORTHTABAB" then
												return 7*L+50;
											else
												return 0;
											end
										elseif SN > "WORTHTABAC" then
											if SN == "WORTHTABAD" then
												return 7*L+100;
											else
												return 0;
											end
										else
											return CalcStat("WorthTabE",L)-30;
										end
									else
										return CalcStat("WorthTabD",L)+20;
									end
								elseif SN > "WORTHTABAE" then
									if SN < "WORTHTABAH" then
										if SN > "WORTHTABAF" then
											if SN == "WORTHTABAG" then
												return CalcStat("WorthTabAF",L)+25;
											else
												return 0;
											end
										elseif SN == "WORTHTABAF" then
											if Lm <= 49 then
												return 2.5*L;
											else
												return 3*L-25;
											end
										else
											return 0;
										end
									elseif SN > "WORTHTABAH" then
										if SN < "WORTHTABAJ" then
											if SN == "WORTHTABAI" then
												if Lm <= 16 then
													return 10.73*L+54.3;
												elseif Lm <= 34 then
													return 10.735*L+54;
												elseif Lm <= 35 then
													return 429;
												elseif Lm <= 41 then
													return 10.65*L+57.1;
												elseif Lm <= 49 then
													return 10.7*L+55.3;
												else
													return 9*L+141;
												end
											else
												return 0;
											end
										elseif SN > "WORTHTABAJ" then
											if SN == "WORTHTABAK" then
												if Lm <= 49 then
													return CalcStat("WorthTabALBase",L+1);
												else
													return 9*L+78;
												end
											else
												return 0;
											end
										else
											return CalcStat("WorthTabAH",L);
										end
									else
										if Lm <= 49 then
											return CalcStat("WorthTabALBase",L+7)-66;
										else
											return 9*L+72;
										end
									end
								else
									return CalcStat("WorthTabE",L);
								end
							else
								if Lm <= 0 then
									return 0;
								else
									return DataTableValue({1,1,1,1,5},L);
								end
							end
						elseif SN > "WORTHTABAL" then
							if SN < "WORTHTABAY" then
								if SN < "WORTHTABAR" then
									if SN < "WORTHTABAN" then
										if SN > "WORTHTABALBASE" then
											if SN == "WORTHTABAM" then
												return CalcStat("WorthTabB",L);
											else
												return 0;
											end
										elseif SN == "WORTHTABALBASE" then
											return 9.86*L+23.51+RoundDbl(L*0.1+0.3)*0.4;
										else
											return 0;
										end
									elseif SN > "WORTHTABAN" then
										if SN < "WORTHTABAP" then
											if SN == "WORTHTABAO" then
												return CalcStat("WorthTabE",L);
											else
												return 0;
											end
										elseif SN > "WORTHTABAP" then
											if SN == "WORTHTABAQ" then
												if Lm <= 10 then
													return 7.5*L+60;
												elseif Lm <= 49 then
													return 5.5*L+80;
												else
													return 6*L+55;
												end
											else
												return 0;
											end
										else
											return CalcStat("WorthTabAQ",L);
										end
									else
										if Lm <= 50 then
											return 8.25*L+27.75;
										else
											return 8*L+40;
										end
									end
								elseif SN > "WORTHTABAR" then
									if SN < "WORTHTABAU" then
										if SN > "WORTHTABAS" then
											if SN == "WORTHTABAT" then
												if Lm <= 4 then
													return RoundDbl(3*L+20,-1);
												elseif Lm <= 7 then
													return 60;
												elseif Lm <= 10 then
													return 100;
												elseif Lm <= 13 then
													return 180;
												elseif Lm <= 16 then
													return 270;
												elseif Lm <= 19 then
													return 310;
												elseif Lm <= 40 then
													return RoundDbl(3.2*L+274,-1);
												elseif Lm <= 43 then
													return 400;
												elseif Lm <= 53 then
													return RoundDbl(1.9*L+334,-1);
												elseif Lm <= 56 then
													return 460;
												elseif Lm <= 59 then
													return 480;
												else
													return 20*L-680;
												end
											else
												return 0;
											end
										elseif SN == "WORTHTABAS" then
											return CalcStat("WorthTabU",L);
										else
											return 0;
										end
									elseif SN > "WORTHTABAU" then
										if SN < "WORTHTABAW" then
											if SN == "WORTHTABAV" then
												if Lm <= 4 then
													return RoundDbl(3*L+20,-1);
												elseif Lm <= 7 then
													return 70;
												elseif Lm <= 10 then
													return 140;
												elseif Lm <= 13 then
													return 270;
												elseif Lm <= 16 then
													return 400;
												elseif Lm <= 19 then
													return 460;
												elseif Lm <= 25 then
													return RoundDbl(3*L+447.5,-1);
												elseif Lm <= 46 then
													return RoundDbl(3.2*L+455,-1);
												elseif Lm <= 50 then
													return 620;
												else
													return 20*L-360;
												end
											else
												return 0;
											end
										elseif SN > "WORTHTABAW" then
											if SN == "WORTHTABAX" then
												if Lm <= 16 then
													return 10.75*L+54;
												elseif Lm <= 34 then
													return 10.75*L+53.7;
												elseif Lm <= 35 then
													return 429;
												elseif Lm <= 41 then
													return 10.65*L+57.1;
												elseif Lm <= 49 then
													return 10.68*L+56.25;
												else
													return 12*L-9;
												end
											else
												return 0;
											end
										else
											if Lm <= 1 then
												return 50;
											elseif Lm <= 49 then
												return 2.5*L+102.5;
											elseif Lm <= 80 then
												return 3*L+78;
											elseif Lm <= 120 then
												return 2.97*L+79.5;
											else
												return 3*L+75;
											end
										end
									else
										return CalcStat("WorthTabBN",L)*1.25;
									end
								else
									return CalcStat("WorthTabD",L)+37.5;
								end
							elseif SN > "WORTHTABAY" then
								if SN < "WORTHTABBD" then
									if SN < "WORTHTABB" then
										if SN > "WORTHTABAZ" then
											if SN == "WORTHTABAZBASE" then
												if Lm <= 44 then
													return RoundDbl(0.0525*L+0.7);
												elseif Lm <= 65 then
													return RoundDbl(0.19*L-4.85);
												elseif Lm <= 81 then
													return RoundDbl(0.19*L+28.15);
												else
													return RoundDbl(0.19*L+28.15+RoundDbl(L*0.05-4.55)*0.2);
												end
											else
												return 0;
											end
										elseif SN == "WORTHTABAZ" then
											if Lm <= 10 then
												return CalcStat("WorthTabAZBase",L)*62.5;
											elseif Lm <= 65 then
												return CalcStat("WorthTabAZBase",L)*125;
											else
												return CalcStat("WorthTabAZBase",L)*25;
											end
										else
											return 0;
										end
									elseif SN > "WORTHTABB" then
										if SN < "WORTHTABBB" then
											if SN == "WORTHTABBA" then
												return 5*L+385;
											else
												return 0;
											end
										elseif SN > "WORTHTABBB" then
											if SN == "WORTHTABBC" then
												if Lm <= 34 then
													return RoundDbl(L/15+0.8)*3750+1250;
												elseif Lm <= 35 then
													return 100000;
												else
													return 125500;
												end
											else
												return 0;
											end
										else
											if Lm <= 1 then
												return 40;
											elseif Lm <= 10 then
												return RoundDbl(0.35*L-0.1)*20;
											elseif Lm <= 13 then
												return 100;
											elseif Lm <= 19 then
												return RoundDbl(0.35*L+1.6)*20;
											elseif Lm <= 25 then
												return RoundDbl(2*L+150,-1);
											elseif Lm <= 40 then
												return RoundDbl(2*L+164,-1);
											elseif Lm <= 49 then
												return RoundDbl(L+201,-1);
											else
												return 20*L-740;
											end
										end
									else
										if Lm <= 50 then
											return 8.25*L+22.25;
										else
											return 8*L+35;
										end
									end
								elseif SN > "WORTHTABBD" then
									if SN < "WORTHTABBG" then
										if SN > "WORTHTABBE" then
											if SN == "WORTHTABBF" then
												return CalcStat("WorthTabAV",L)+20;
											else
												return 0;
											end
										elseif SN == "WORTHTABBE" then
											if Lm <= 1 then
												return 60;
											elseif Lm <= 7 then
												return RoundDbl(L/3)*40+30;
											elseif Lm <= 13 then
												return RoundDbl(L/3)*130-210;
											elseif Lm <= 19 then
												return RoundDbl(L/3)*60+140;
											elseif Lm <= 25 then
												return RoundDbl(L/3)*10+480;
											elseif Lm <= 46 then
												return RoundDbl(L/3)*10+490;
											elseif Lm <= 50 then
												return 660;
											else
												return 20*L-320;
											end
										else
											return 0;
										end
									elseif SN > "WORTHTABBG" then
										if SN < "WORTHTABBI" then
											if SN == "WORTHTABBH" then
												if Lm <= 80 then
													return RoundDbl(0.05*L-0.05)+RoundDbl(0.05*L+0.45);
												else
													return RoundDbl(0.05*L-0.1)+RoundDbl(0.05*L+0.45);
												end
											else
												return 0;
											end
										elseif SN > "WORTHTABBI" then
											if SN == "WORTHTABBJ" then
												return RoundDbl(0.1*L+0.45)*3;
											else
												return 0;
											end
										else
											return CalcStat("WorthTabG",L)-25;
										end
									else
										if Lm <= 7 then
											return RoundDbl(0.2*L-0.4)*2+1;
										elseif Lm <= 16 then
											return RoundDbl(L/3-2)*6;
										elseif Lm <= 22 then
											return RoundDbl(L/3+1)*3;
										elseif Lm <= 25 then
											return RoundDbl(L/3+1)*3-2;
										elseif Lm <= 80 then
											return RoundDbl(L/3+18)-2;
										else
											return L-37;
										end
									end
								else
									return CalcStat("WorthTabK",L)+1;
								end
							else
								return 5*L;
							end
						else
							if Lm <= 49 then
								return CalcStat("WorthTabALBase",L);
							else
								return 9*L+69;
							end
						end
					elseif SN > "WORTHTABBK" then
						if SN < "WORTHTABCL" then
							if SN < "WORTHTABBY" then
								if SN < "WORTHTABBR" then
									if SN < "WORTHTABBN" then
										if SN > "WORTHTABBL" then
											if SN == "WORTHTABBM" then
												if Lm <= 1 then
													return 10;
												else
													return 20*L-20;
												end
											else
												return 0;
											end
										elseif SN == "WORTHTABBL" then
											if Lm <= 35 then
												return 126600;
											elseif Lm <= 46 then
												return 150600;
											elseif Lm <= 47 then
												return 180720;
											else
												return 150600;
											end
										else
											return 0;
										end
									elseif SN > "WORTHTABBN" then
										if SN < "WORTHTABBP" then
											if SN == "WORTHTABBO" then
												if Lm <= 10 then
													return 10;
												elseif Lm <= 40 then
													return RoundDbl(0.1*L-0.55)*50-25;
												elseif Lm <= 80 then
													return RoundDbl(0.1*L-0.55)*50;
												else
													return RoundDbl(0.1*L-0.55)*25+175;
												end
											else
												return 0;
											end
										elseif SN > "WORTHTABBP" then
											if SN == "WORTHTABBQ" then
												if Lm <= 1 then
													return 50;
												elseif Lm <= 49 then
													return RoundDbl(2.5*L+100);
												else
													return 3*L+75;
												end
											else
												return 0;
											end
										else
											if Lm <= 10 then
												return 156.25*L+1562.5;
											elseif Lm <= 20 then
												return 312.5*L;
											elseif Lm <= 30 then
												return 625*L-6250;
											elseif Lm <= 40 then
												return 1250*L-25000;
											else
												return 2500*L-75000;
											end
										end
									else
										if Lm <= 1 then
											return 400;
										else
											return 20*L+800;
										end
									end
								elseif SN > "WORTHTABBR" then
									if SN < "WORTHTABBU" then
										if SN > "WORTHTABBS" then
											if SN == "WORTHTABBT" then
												return 62500;
											else
												return 0;
											end
										elseif SN == "WORTHTABBS" then
											return CalcStat("WorthTabBR",L)*2;
										else
											return 0;
										end
									elseif SN > "WORTHTABBU" then
										if SN < "WORTHTABBW" then
											if SN == "WORTHTABBV" then
												if Lm <= 29 then
													return 1250;
												else
													return RoundDbl(0.05*L-1)*2500;
												end
											else
												return 0;
											end
										elseif SN > "WORTHTABBW" then
											if SN == "WORTHTABBX" then
												if Lm <= 10 then
													return RoundDbl(0.1*L+0.45)*3;
												elseif Lm <= 140 then
													return RoundDbl(0.1*L-0.6)*6;
												else
													return RoundDbl(0.1*L+0.4)*4+22;
												end
											else
												return 0;
											end
										else
											if Lm <= 1 then
												return 645;
											elseif Lm <= 9 then
												return 20*L+980;
											else
												return 50*L+920;
											end
										end
									else
										if Lm <= 80 then
											return 20*L+300;
										else
											return 10*L+1100;
										end
									end
								else
									if Lm <= 49 then
										return CalcStat("WorthTabBQ",L)*2;
									else
										return 4*L+250;
									end
								end
							elseif SN > "WORTHTABBY" then
								if SN < "WORTHTABCE" then
									if SN < "WORTHTABCA" then
										if SN > "WORTHTABBZ" then
											if SN == "WORTHTABC" then
												return CalcStat("WorthTabD",L)+20;
											else
												return 0;
											end
										elseif SN == "WORTHTABBZ" then
											if Lm <= 10 then
												return 27.42*L+273.1;
											elseif Lm <= 20 then
												return 54.69*L;
											elseif Lm <= 30 then
												return 109.35*L-1093;
											elseif Lm <= 40 then
												return 218.75*L-4375;
											elseif Lm <= 80 then
												return 437.5*L-13125;
											else
												return 437*L-13085;
											end
										else
											return 0;
										end
									elseif SN > "WORTHTABCA" then
										if SN < "WORTHTABCC" then
											if SN == "WORTHTABCB" then
												return 0.1;
											else
												return 0;
											end
										elseif SN > "WORTHTABCC" then
											if SN == "WORTHTABCD" then
												return CalcStat("WorthTabBK",L)*25;
											else
												return 0;
											end
										else
											return CalcStat("WorthTabBK",L)*5;
										end
									else
										if Lm <= 10 then
											return 7.25*L+72.25;
										elseif Lm <= 20 then
											return 14.49*L+0.11;
										elseif Lm <= 30 then
											return 29*L-290;
										elseif Lm <= 35 then
											return 57.99*L-1160.16;
										elseif Lm <= 40 then
											return 57.99*L-1160.12;
										elseif Lm <= 80 then
											return 115.94*L-3478.2;
										else
											return 116*L-3483;
										end
									end
								elseif SN > "WORTHTABCE" then
									if SN < "WORTHTABCH" then
										if SN > "WORTHTABCF" then
											if SN == "WORTHTABCG" then
												return 20;
											else
												return 0;
											end
										elseif SN == "WORTHTABCF" then
											if Lm <= 20 then
												return RoundDbl(0.1*L-0.55)*600+200;
											elseif Lm <= 40 then
												return RoundDbl(0.1*L-0.55)*1000-500;
											elseif Lm <= 60 then
												return RoundDbl(0.1*L-0.55)*2000-4000;
											elseif Lm <= 70 then
												return 8500;
											elseif Lm <= 140 then
												return RoundDbl(0.1*L-0.55)*2500-7500;
											elseif Lm <= 200 then
												return RoundDbl(0.1*L-0.55)*3000-14000;
											else
												return RoundDbl(0.1*L-0.55)*2500-3500;
											end
										else
											return 0;
										end
									elseif SN > "WORTHTABCH" then
										if SN < "WORTHTABCJ" then
											if SN == "WORTHTABCI" then
												return 40000;
											else
												return 0;
											end
										elseif SN > "WORTHTABCJ" then
											if SN == "WORTHTABCK" then
												return 15000;
											else
												return 0;
											end
										else
											return 20000;
										end
									else
										return 50000;
									end
								else
									return CalcStat("WorthTabBN",L)*10;
								end
							else
								return 90000;
							end
						elseif SN > "WORTHTABCL" then
							if SN < "WORTHTABL" then
								if SN < "WORTHTABE" then
									if SN < "WORTHTABCO" then
										if SN > "WORTHTABCM" then
											if SN == "WORTHTABCN" then
												return RoundDbl(0.1*L+0.5)*10000;
											else
												return 0;
											end
										elseif SN == "WORTHTABCM" then
											return 7500;
										else
											return 0;
										end
									elseif SN > "WORTHTABCO" then
										if SN < "WORTHTABCQ" then
											if SN == "WORTHTABCP" then
												return 1;
											else
												return 0;
											end
										elseif SN > "WORTHTABCQ" then
											if SN == "WORTHTABD" then
												if Lm <= 49 then
													return 7.5*L;
												else
													return 8*L-25;
												end
											else
												return 0;
											end
										else
											if Lm <= 10 then
												return RoundDbl(0.3*L+0.2)*2;
											elseif Lm <= 16 then
												return RoundDbl(0.25*L-1)*6;
											elseif Lm <= 22 then
												return RoundDbl(0.3*L+5.5)*2;
											elseif Lm <= 50 then
												return RoundDbl((1/6)*L+8.75)*2;
											elseif Lm <= 80 then
												return RoundDbl((1/3)*L-11.5)*6;
											else
												return RoundDbl(0.25*L-4.6)*6;
											end
										end
									else
										return CalcStat("WorthTabAB",L);
									end
								elseif SN > "WORTHTABE" then
									if SN < "WORTHTABH" then
										if SN > "WORTHTABF" then
											if SN == "WORTHTABG" then
												if Lm <= 1 then
													return 50;
												else
													return CalcStat("WorthTabAF",L)+100;
												end
											else
												return 0;
											end
										elseif SN == "WORTHTABF" then
											return 0.1;
										else
											return 0;
										end
									elseif SN > "WORTHTABH" then
										if SN < "WORTHTABJ" then
											if SN == "WORTHTABI" then
												if Lm <= 4 then
													return 1;
												elseif Lm <= 10 then
													return 0.7*L-1;
												elseif Lm <= 15 then
													return 1.4*L-7;
												elseif Lm <= 24 then
													return 1.25*L-5;
												elseif Lm <= 49 then
													return 2.5*L-35;
												else
													return 3*L-60;
												end
											else
												return 0;
											end
										elseif SN > "WORTHTABJ" then
											if SN == "WORTHTABK" then
												if Lm <= 9 then
													return 12*L+24;
												else
													return 7*L+74;
												end
											else
												return 0;
											end
										else
											if Lm <= 4 then
												return 2.5*L+7.5;
											elseif Lm <= 5 then
												return 23;
											else
												return 4*L;
											end
										end
									else
										if Lm <= 2 then
											return L;
										elseif Lm <= 9 then
											return 1.48*L-2.85;
										elseif Lm <= 11 then
											return 2.5*L-13;
										elseif Lm <= 24 then
											return 2.5*L-10;
										else
											return 5*L-70;
										end
									end
								else
									if Lm <= 9 then
										return 30*L+50;
									else
										return 7*L+280;
									end
								end
							elseif SN > "WORTHTABL" then
								if SN < "WORTHTABS" then
									if SN < "WORTHTABO" then
										if SN > "WORTHTABM" then
											if SN == "WORTHTABN" then
												return CalcStat("WorthTabAF",L)+25;
											else
												return 0;
											end
										elseif SN == "WORTHTABM" then
											if Lm <= 9 then
												return 10*L+11;
											elseif Lm <= 49 then
												return 4*L+65;
											else
												return 5*L+15;
											end
										else
											return 0;
										end
									elseif SN > "WORTHTABO" then
										if SN < "WORTHTABQ" then
											if SN == "WORTHTABP" then
												return CalcStat("WorthTabE",L);
											else
												return 0;
											end
										elseif SN > "WORTHTABQ" then
											if SN == "WORTHTABR" then
												if Lm <= 9 then
													return 12*L+30;
												else
													return 7*L+75;
												end
											else
												return 0;
											end
										else
											return 7*L+25;
										end
									else
										return CalcStat("WorthTabB",L)+11;
									end
								elseif SN > "WORTHTABS" then
									if SN < "WORTHTABW" then
										if SN < "WORTHTABU" then
											if SN == "WORTHTABT" then
												if Lm <= 1 then
													return 54;
												elseif Lm <= 17 then
													return 10.73*L+43.57;
												elseif Lm <= 35 then
													return 10.735*L+43.265;
												elseif Lm <= 36 then
													return 429;
												elseif Lm <= 42 then
													return 10.65*L+46.45;
												elseif Lm <= 49 then
													return 10.7*L+44.6;
												else
													return 9*L+130;
												end
											else
												return 0;
											end
										elseif SN > "WORTHTABU" then
											if SN == "WORTHTABV" then
												return CalcStat("WorthTabB",L)-2.75;
											else
												return 0;
											end
										else
											if Lm <= 10 then
												return 9*L+20;
											elseif Lm <= 49 then
												return 5.5*L+55;
											else
												return 6*L+30;
											end
										end
									elseif SN > "WORTHTABW" then
										if SN < "WORTHTABY" then
											if SN == "WORTHTABX" then
												return CalcStat("WorthTabAF",L)+75;
											else
												return 0;
											end
										elseif SN > "WORTHTABY" then
											if SN == "WORTHTABZ" then
												return CalcStat("WorthTabR",L)-15;
											else
												return 0;
											end
										else
											return CalcStat("WorthTabD",L)+30;
										end
									else
										return CalcStat("WorthTabD",L)+25;
									end
								else
									return CalcStat("WorthTabD",L)+17.5;
								end
							else
								return CalcStat("WorthTabB",L)+19.25;
							end
						else
							return 12500;
						end
					else
						if Lm <= 10 then
							return RoundDbl(0.1*L+0.45);
						else
							return RoundDbl(0.1*L-0.6)*2;
						end
					end
				elseif SN > "WORTHVALA" then
					if SN < "WORTHVALCB" then
						if SN < "WORTHVALBA" then
							if SN < "WORTHVALAN" then
								if SN < "WORTHVALAG" then
									if SN < "WORTHVALAC" then
										if SN > "WORTHVALAA" then
											if SN == "WORTHVALAB" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAB"));
											else
												return 0;
											end
										elseif SN == "WORTHVALAA" then
											return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAA"));
										else
											return 0;
										end
									elseif SN > "WORTHVALAC" then
										if SN < "WORTHVALAE" then
											if SN == "WORTHVALAD" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAD"));
											else
												return 0;
											end
										elseif SN > "WORTHVALAE" then
											if SN == "WORTHVALAF" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAF"));
											else
												return 0;
											end
										else
											return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAE"));
										end
									else
										return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAC"));
									end
								elseif SN > "WORTHVALAG" then
									if SN < "WORTHVALAJ" then
										if SN > "WORTHVALAH" then
											if SN == "WORTHVALAI" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAI"));
											else
												return 0;
											end
										elseif SN == "WORTHVALAH" then
											return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAH"));
										else
											return 0;
										end
									elseif SN > "WORTHVALAJ" then
										if SN < "WORTHVALAL" then
											if SN == "WORTHVALAK" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAK"));
											else
												return 0;
											end
										elseif SN > "WORTHVALAL" then
											if SN == "WORTHVALAM" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAM"));
											else
												return 0;
											end
										else
											return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAL"));
										end
									else
										return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAJ"));
									end
								else
									return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAG"));
								end
							elseif SN > "WORTHVALAN" then
								if SN < "WORTHVALAU" then
									if SN < "WORTHVALAQ" then
										if SN > "WORTHVALAO" then
											if SN == "WORTHVALAP" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAP"));
											else
												return 0;
											end
										elseif SN == "WORTHVALAO" then
											return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAO"));
										else
											return 0;
										end
									elseif SN > "WORTHVALAQ" then
										if SN < "WORTHVALAS" then
											if SN == "WORTHVALAR" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAR"));
											else
												return 0;
											end
										elseif SN > "WORTHVALAS" then
											if SN == "WORTHVALAT" then
												return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAT"));
											else
												return 0;
											end
										else
											return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAS"));
										end
									else
										return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAQ"));
									end
								elseif SN > "WORTHVALAU" then
									if SN < "WORTHVALAX" then
										if SN > "WORTHVALAV" then
											if SN == "WORTHVALAW" then
												return RoundDbl(CalcStat("WorthMpA",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAW"));
											else
												return 0;
											end
										elseif SN == "WORTHVALAV" then
											return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAV"));
										else
											return 0;
										end
									elseif SN > "WORTHVALAX" then
										if SN < "WORTHVALAZ" then
											if SN == "WORTHVALAY" then
												return RoundDbl(CalcStat("WorthMpA",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAY"));
											else
												return 0;
											end
										elseif SN > "WORTHVALAZ" then
											if SN == "WORTHVALB" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabB"));
											else
												return 0;
											end
										else
											return RoundDbl(CalcStat("WorthMpA",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAZ"));
										end
									else
										return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAX"));
									end
								else
									return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAU"));
								end
							else
								return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabAN"));
							end
						elseif SN > "WORTHVALBA" then
							if SN < "WORTHVALBO" then
								if SN < "WORTHVALBH" then
									if SN < "WORTHVALBD" then
										if SN > "WORTHVALBB" then
											if SN == "WORTHVALBC" then
												return RoundDbl(CalcStat("WorthMpE",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBC"));
											else
												return 0;
											end
										elseif SN == "WORTHVALBB" then
											return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBB"));
										else
											return 0;
										end
									elseif SN > "WORTHVALBD" then
										if SN < "WORTHVALBF" then
											if SN == "WORTHVALBE" then
												return RoundDbl(CalcStat("WorthMpJ",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBE"));
											else
												return 0;
											end
										elseif SN > "WORTHVALBF" then
											if SN == "WORTHVALBG" then
												return RoundDbl(CalcStat("WorthMpA",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBG"));
											else
												return 0;
											end
										else
											return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBF"));
										end
									else
										return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBD"));
									end
								elseif SN > "WORTHVALBH" then
									if SN < "WORTHVALBK" then
										if SN > "WORTHVALBI" then
											if SN == "WORTHVALBJ" then
												return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBJ"));
											else
												return 0;
											end
										elseif SN == "WORTHVALBI" then
											return RoundDbl(CalcStat("WorthMpA",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBI"));
										else
											return 0;
										end
									elseif SN > "WORTHVALBK" then
										if SN < "WORTHVALBM" then
											if SN == "WORTHVALBL" then
												return RoundDbl(CalcStat("WorthMpE",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBL"));
											else
												return 0;
											end
										elseif SN > "WORTHVALBM" then
											if SN == "WORTHVALBN" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBN"));
											else
												return 0;
											end
										else
											return RoundDbl(CalcStat("WorthMpA",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBM"));
										end
									else
										return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBK"));
									end
								else
									return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBH"));
								end
							elseif SN > "WORTHVALBO" then
								if SN < "WORTHVALBV" then
									if SN < "WORTHVALBR" then
										if SN > "WORTHVALBP" then
											if SN == "WORTHVALBQ" then
												return RoundDbl(CalcStat("WorthMpE",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBQ"));
											else
												return 0;
											end
										elseif SN == "WORTHVALBP" then
											return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBP"));
										else
											return 0;
										end
									elseif SN > "WORTHVALBR" then
										if SN < "WORTHVALBT" then
											if SN == "WORTHVALBS" then
												return RoundDbl(CalcStat("WorthMpE",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBS"));
											else
												return 0;
											end
										elseif SN > "WORTHVALBT" then
											if SN == "WORTHVALBU" then
												return RoundDbl(CalcStat("WorthMpF",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBU"));
											else
												return 0;
											end
										else
											return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBT"));
										end
									else
										return RoundDbl(CalcStat("WorthMpE",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBR"));
									end
								elseif SN > "WORTHVALBV" then
									if SN < "WORTHVALBY" then
										if SN > "WORTHVALBW" then
											if SN == "WORTHVALBX" then
												return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBX"));
											else
												return 0;
											end
										elseif SN == "WORTHVALBW" then
											return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBW"));
										else
											return 0;
										end
									elseif SN > "WORTHVALBY" then
										if SN < "WORTHVALC" then
											if SN == "WORTHVALBZ" then
												return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBZ"));
											else
												return 0;
											end
										elseif SN > "WORTHVALC" then
											if SN == "WORTHVALCA" then
												return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCA"));
											else
												return 0;
											end
										else
											return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabC"));
										end
									else
										return RoundDbl(CalcStat("WorthMpE",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBY"));
									end
								else
									return RoundDbl(CalcStat("WorthMpD",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBV"));
								end
							else
								return RoundDbl(CalcStat("WorthMpG",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBO"));
							end
						else
							return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabBA"));
						end
					elseif SN > "WORTHVALCB" then
						if SN < "WORTHVALP" then
							if SN < "WORTHVALCP" then
								if SN < "WORTHVALCI" then
									if SN < "WORTHVALCE" then
										if SN > "WORTHVALCC" then
											if SN == "WORTHVALCD" then
												return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCD"));
											else
												return 0;
											end
										elseif SN == "WORTHVALCC" then
											return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCC"));
										else
											return 0;
										end
									elseif SN > "WORTHVALCE" then
										if SN < "WORTHVALCG" then
											if SN == "WORTHVALCF" then
												return RoundDbl(CalcStat("WorthMpA",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCF"));
											else
												return 0;
											end
										elseif SN > "WORTHVALCG" then
											if SN == "WORTHVALCH" then
												return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCH"));
											else
												return 0;
											end
										else
											return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCG"));
										end
									else
										return RoundDbl(CalcStat("WorthMpH",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCE"));
									end
								elseif SN > "WORTHVALCI" then
									if SN < "WORTHVALCL" then
										if SN > "WORTHVALCJ" then
											if SN == "WORTHVALCK" then
												return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCK"));
											else
												return 0;
											end
										elseif SN == "WORTHVALCJ" then
											return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCJ"));
										else
											return 0;
										end
									elseif SN > "WORTHVALCL" then
										if SN < "WORTHVALCN" then
											if SN == "WORTHVALCM" then
												return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCM"));
											else
												return 0;
											end
										elseif SN > "WORTHVALCN" then
											if SN == "WORTHVALCO" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCO"));
											else
												return 0;
											end
										else
											return RoundDbl(CalcStat("WorthMpI",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCN"));
										end
									else
										return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCL"));
									end
								else
									return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCI"));
								end
							elseif SN > "WORTHVALCP" then
								if SN < "WORTHVALI" then
									if SN < "WORTHVALE" then
										if SN > "WORTHVALCQ" then
											if SN == "WORTHVALD" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabD"));
											else
												return 0;
											end
										elseif SN == "WORTHVALCQ" then
											return RoundDbl(CalcStat("WorthMpK",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCQ"));
										else
											return 0;
										end
									elseif SN > "WORTHVALE" then
										if SN < "WORTHVALG" then
											if SN == "WORTHVALF" then
												return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabF"));
											else
												return 0;
											end
										elseif SN > "WORTHVALG" then
											if SN == "WORTHVALH" then
												return RoundDbl(CalcStat("WorthMpA",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabH"));
											else
												return 0;
											end
										else
											return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabG"));
										end
									else
										return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabE"));
									end
								elseif SN > "WORTHVALI" then
									if SN < "WORTHVALL" then
										if SN > "WORTHVALJ" then
											if SN == "WORTHVALK" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabK"));
											else
												return 0;
											end
										elseif SN == "WORTHVALJ" then
											return RoundDbl(CalcStat("WorthMpA",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabJ"));
										else
											return 0;
										end
									elseif SN > "WORTHVALL" then
										if SN < "WORTHVALN" then
											if SN == "WORTHVALM" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabM"));
											else
												return 0;
											end
										elseif SN > "WORTHVALN" then
											if SN == "WORTHVALO" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabO"));
											else
												return 0;
											end
										else
											return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabN"));
										end
									else
										return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabL"));
									end
								else
									return RoundDbl(CalcStat("WorthMpA",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabI"));
								end
							else
								return RoundDbl(CalcStat("WorthMpA",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCP"));
							end
						elseif SN > "WORTHVALP" then
							if SN < "WPNDMGMIN" then
								if SN < "WORTHVALW" then
									if SN < "WORTHVALS" then
										if SN > "WORTHVALQ" then
											if SN == "WORTHVALR" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabR"));
											else
												return 0;
											end
										elseif SN == "WORTHVALQ" then
											return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabQ"));
										else
											return 0;
										end
									elseif SN > "WORTHVALS" then
										if SN < "WORTHVALU" then
											if SN == "WORTHVALT" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabT"));
											else
												return 0;
											end
										elseif SN > "WORTHVALU" then
											if SN == "WORTHVALV" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabV"));
											else
												return 0;
											end
										else
											return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabU"));
										end
									else
										return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabS"));
									end
								elseif SN > "WORTHVALW" then
									if SN < "WORTHVALZ" then
										if SN > "WORTHVALX" then
											if SN == "WORTHVALY" then
												return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabY"));
											else
												return 0;
											end
										elseif SN == "WORTHVALX" then
											return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabX"));
										else
											return 0;
										end
									elseif SN > "WORTHVALZ" then
										if SN < "WPNDMGMAX" then
											if SN == "WOUNDRESISTT" then
												return CalcStat("ResistAddT",L,N);
											else
												return 0;
											end
										elseif SN > "WPNDMGMAX" then
											if SN == "WPNDMGMAXMPTYPE" then
												if Lm <= 0 then
													return 0;
												else
													return DataTableValue({1.25,1.25,40/31},L);
												end
											else
												return 0;
											end
										else
											return CalcStat("CombatBase",L,C)*CalcStat("WpnDmgMaxMPType",WpnCodeIndex(C,2));
										end
									else
										return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabZ"));
									end
								else
									return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabW"));
								end
							elseif SN > "WPNDMGMIN" then
								if SN < "WRDPHYMAS" then
									if SN < "WRDBATSTRIKESCRITDEF" then
										if SN > "WPNDMGMINMPTYPE" then
											if SN == "WPNDPS" then
												return CalcStat("CombatBase",L,C);
											else
												return 0;
											end
										elseif SN == "WPNDMGMINMPTYPE" then
											if Lm <= 0 then
												return 0;
											else
												return DataTableValue({0.75,0.75,22/31},L);
											end
										else
											return 0;
										end
									elseif SN > "WRDBATSTRIKESCRITDEF" then
										if SN < "WRDFINESSE" then
											if SN == "WRDCRITDEF" then
												return CalcStat("CritDefT",L,1.0);
											else
												return 0;
											end
										elseif SN > "WRDFINESSE" then
											if SN == "WRDIMPRBLADESPARRY" then
												return CalcStat("ParryT",L,2.8);
											else
												return 0;
											end
										else
											return CalcStat("FinesseT",L,CalcStat("Trait12345Choice",N)*0.4);
										end
									else
										return CalcStat("CritDefT",L,CalcStat("Trait123Choice",N)*0.4);
									end
								elseif SN > "WRDPHYMAS" then
									if SN < "WRDSSSHPIERCERBLOCK" then
										if SN < "WRDSHIELDMASBLOCK" then
											if SN == "WRDRECKLESSNCRITHIT" then
												return CalcStat("CritHitT",L,2.4);
											else
												return 0;
											end
										elseif SN > "WRDSHIELDMASBLOCK" then
											if SN == "WRDSHIELDTACTCRITDEF" then
												return CalcStat("CritDefT",L,2);
											else
												return 0;
											end
										else
											return CalcStat("BlockT",L,2.8);
										end
									elseif SN > "WRDSSSHPIERCERBLOCK" then
										if SN < "WRDSTDYOURGREVADE" then
											if SN == "WRDSTDYOURGRBLOCK" then
												return CalcStat("BlockT",L,CalcStat("Trait1234Choice",N)*0.4);
											else
												return 0;
											end
										elseif SN > "WRDSTDYOURGREVADE" then
											if SN == "WRDSTDYOURGRPARRY" then
												return CalcStat("ParryT",L,CalcStat("Trait1234Choice",N)*0.4);
											else
												return 0;
											end
										else
											return -CalcStat("EvadeT",L,CalcStat("Trait1234Choice",N)*0.4);
										end
									else
										return -CalcStat("BlockT",L,4);
									end
								else
									return CalcStat("PhyMasT",L,CalcStat("Trait12345Choice",N)*0.4);
								end
							else
								return CalcStat("CombatBase",L,C)*CalcStat("WpnDmgMinMPType",WpnCodeIndex(C,2));
							end
						else
							return RoundDbl(CalcStat("WorthMpB",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabP"));
						end
					else
						return RoundDbl(CalcStat("WorthMpC",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabCB"));
					end
				else
					return RoundDbl(CalcStat("WorthMpA",QualityCodeIndex(C))*CalcStat("WorthExt",L,"WorthTabA"));
				end
			else
				if Lm <= 105 then
					return CalcStat("Mitigation",L,1.6);
				elseif Lm <= 119 then
					return CalcStat("PhyMitT",L,1.2);
				elseif Lm <= 120 then
					return CalcStat("PhyMitT",L,1.6);
				elseif Lm <= 129 then
					return CalcStat("PhyMitT",L,1.2);
				elseif Lm <= 130 then
					return CalcStat("PhyMitT",L,1.6);
				elseif Lm <= 139 then
					return CalcStat("PhyMitT",L,1.2);
				else
					return CalcStat("PhyMitT",L,1.6);
				end
			end
		else
			return DataTableValue({0,1,2},L);
		end
	else
		return 1.5;
	end

end

-- Support functions for CalcStat. These consist of implementations of more complex calculation types, decode methods for parameter "C" and rounding/min/max/compare functions for floating point numbers.

-- ****************** Calculation Type support functions ******************

-- DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
-- DataTableValue: Takes a value from an array table.

function DataTableValue(vDataArray, dIndex)

	local lIndex = RoundDbl(dIndex);
	if lIndex <= 1 then
		return vDataArray[1];
	elseif lIndex > #vDataArray then
		return vDataArray[#vDataArray];
	else
		return vDataArray[lIndex];
	end

end

-- EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
-- ExpFmod: Exponential function based on percentage.
-- Common percentage values are around ~5.5% for between levels and ~20% jumps between level segments.

function ExpFmod(dVal, dLstart, dPlvl, dLvl, vDec, vAdd)

	local dRng = dLvl-dLstart+1;
	if dRng <= DblCalcDev then
		return dVal;
	else
		local dFac = 1+dPlvl/100;
		local dAdd;
		if vAdd == nil then
			dAdd = 0;
		else
			dAdd = vAdd;
		end
		if vDec == nil then
			local dFacExp = dFac^dRng;
			return dVal*dFacExp+dAdd*((dFacExp-1)/(dFac-1));
		else
			local dResult = dVal;
			local dLm = dLstart-DblCalcDev;
			while dLm <= dLvl do
				dResult = RoundDbl(dResult*dFac+dAdd,vDec);
				dLm = dLm+1;
			end
			return dResult;
		end
	end

end

-- PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
-- CalcPercAB: Calculates the percentage out of a rating based on the AB formula.

function CalcPercAB(dA, dB, dPCap, dR)

	if dR <= DblCalcDev then
		return 0.0;
	else
		local dResult = dA/(1+dB/dR);
		if dResult >= dPCap-DblCalcDev then
			return dPCap;
		else
			return dResult;
		end
	end

end

-- RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
-- CalcRatAB: Calculates the rating out of a percentage based on the AB formula.

function CalcRatAB(dA, dB, dCapR, dP)

	if dP <= DblCalcDev then
		return 0.0;
	else
		local dResult = dB/(dA/dP-1);
		if dResult >= dCapR-DblCalcDev then
			return dCapR;
		else
			return dResult;
		end
	end

end

-- SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
-- StatLinInter: (Normalized) Stat Linear Interpolating

function StatLinInter(sPntMP, sProgScheme, sProgBase, sAdj, dLvl, vNorC, vRoundType)

	-- parameter processing
	local dN = 1;
	local sC = "";
	if type(vNorC) == "number" then
		dN = vNorC;
	elseif type(vNorC) == "string" then
		sC = vNorC;
	end

	local dRoundType = 0;
	if type(vRoundType) == "number" then
		dRoundType = vRoundType;
	end
	
	local dProgScheme = CalcStat(sProgScheme,dLvl);
	if type(dProgScheme) ~= "table" then
		return 0.0;
	end

	-- find level interval
	local dLvlMinus = dLvl-DblCalcDev;
	local iPointIndexHigh = 2;
	local iPointIndexMax = #dProgScheme[1];
	while iPointIndexHigh < iPointIndexMax do
		if dLvlMinus <= dProgScheme[1][iPointIndexHigh] then
			break;
		end
		iPointIndexHigh = iPointIndexHigh+1;
	end
	local iPointIndexLow = iPointIndexHigh-1;
		
	local dAccessLvlLow = dProgScheme[1][iPointIndexLow];
	local dAccessLvlHigh = dProgScheme[1][iPointIndexHigh];
	local dBaseLvlLow = dProgScheme[2][iPointIndexLow];
	local dBaseLvlHigh = dProgScheme[2][iPointIndexHigh];
	
	-- get values from base progression
	local dValLow = CalcStat(sProgBase,dBaseLvlLow,sC);
	local dValHigh = CalcStat(sProgBase,dBaseLvlHigh,sC);

	-- graph point multiplications
	if type(sPntMP) == "string" and sPntMP ~= "" then
		dValLow = dValLow*CalcStat(sPntMP,dAccessLvlLow,sC);
		dValHigh = dValHigh*CalcStat(sPntMP,dAccessLvlHigh,sC);
	end
	if type(sAdj) == "string" and sAdj ~= "" then
		dValLow = dValLow*CalcStat(sAdj,dAccessLvlLow,sC);
		dValHigh = dValHigh*CalcStat(sAdj,dAccessLvlHigh,sC);
	end
	dValLow = dValLow*dN;
	dValHigh = dValHigh*dN;

	-- graph point roundings
	if dRoundType == 0 then
		dValLow = RoundDblLotro(dValLow);
		dValHigh = RoundDblLotro(dValHigh);
	elseif dRoundType == 1 then
		if -1000.0 <= dValLow and dValLow <= 1000.0 then
			dValLow = RoundDblUp(dValLow,2);
		else
			dValLow = RoundDblLotro(dValLow);
		end
		if -1000.0 <= dValHigh and dValHigh <= 1000.0 then
			dValHigh = RoundDblUp(dValHigh,2);
		else
			dValHigh = RoundDblLotro(dValHigh);
		end
	elseif dRoundType == 2 then
		dValLow = RoundDblLotro(dValLow);
		if dValLow == -1 then
			dValLow = -2;
		end
		dValHigh = RoundDblLotro(dValHigh);
		if dValHigh == -1 then
			dValHigh = -2;
		end
	end

	-- return interpolated value from the calculated graph points
	return LinFmod(1,dValLow,dValHigh,dAccessLvlLow,dAccessLvlHigh,dLvl);

end

-- TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
-- LinFmod: Linear line function between 2 points with some optional modifications.
-- Connects point (dLstart,dVal*dFstart) with (dLend,dVal*dFend).
-- Usually used with dVal=1 and dFstart/dFend containing unrelated points or dVal=# and dFstart/dFend containing multiplier factors.
-- Modification for in-between points on the line: rounding.

function LinFmod(dVal, dFstart, dFend, dLstart, dLend, dLvl, vDec)

	if dLstart-DblCalcDev <= dLvl and dLvl <= dLstart+DblCalcDev then
		return dVal*dFstart;
	elseif dLend-DblCalcDev <= dLvl and dLvl <= dLend+DblCalcDev then
		return dVal*dFend;
	elseif dLstart == dLend then
		return 0.0;
	elseif vDec == nil then
		return dVal*(dFstart*(dLend-dLvl)+(dLvl-dLstart)*dFend)/(dLend-dLstart);
	else
		return RoundDbl(dVal*(dFstart*(dLend-dLvl)+(dLvl-dLstart)*dFend)/(dLend-dLstart),vDec);
	end

end

-- ****************** Parameter "C" decode support functions ******************

-- ArmCodeIndex: returns a specified index from an Armour Code.
-- sACode string:
-- 1st position: H=heavy, M=medium, L=light
-- 2nd position: H=head, S=shoulders, CL=cloak/back, C=chest, G=gloves, L=leggings, B=boots, Sh=shield
-- 3rd position: W=white/common, Y=yellow/uncommon, P=purple/rare, T=teal/blue/incomparable, G=gold/legendary/epic
-- Note: no such thing exists as a heavy, medium or light cloak, so no H/M/L in cloak codes (cloaks go automatically in the M class since U23, although historically this was L)

function ArmCodeIndex(sACode, iI)

	if sACode == nil or iI == nil then
		return 0;
	end
	if type(sACode) ~= "string" or type(iI) ~= "number" then
		return 0;
	end

	local sArmCode = string.match(sACode,"(%a+)");
	if not sArmCode then
		return 0;
	end
	sArmCode = string.upper(sArmCode).."    ";
	
	local sArmCat = string.sub(sArmCode,1,1);
	local sArmType = string.sub(sArmCode,2,2);
	local sArmCol = string.sub(sArmCode,3,3);

	if sArmType == "S" and sArmCol == "H" then
		sArmType = "SH";
		sArmCol = string.sub(sArmCode,4,4);
	elseif sArmCat == "C" and sArmType == "L" then
		sArmCat = "M";
		sArmType = "CL";
	elseif sArmType then
		sArmType = " "..sArmType;
	end
	
	local result = 0;
	if iI == 1 then
		if sArmCat then
			result = string.find("HML",sArmCat);
		end
	elseif iI == 2 then
		if sArmType then
			result = string.find(" H SCL C G L BSH",sArmType);
			if result then
				result = (result+1)/2;
			end
		end
	elseif iI == 3 then
		if sArmCol then
			result = string.find("WYPTG",sArmCol);
		end
	end

	if result then
		return result;
	else
		return 0;
	end
	
end

-- QualityCodeIndex: returns a quality index from a Quality Code.
-- sQCode string: W=white/common, Y=yellow/uncommon, P=purple/rare, T=teal/blue/incomparable, G=gold/legendary/epic

function QualityCodeIndex(sQCode)

	if sQCode == nil then
		return 0;
	end
	if type(sQCode) ~= "string" then
		return 0;
	end

	local sQtyCode = string.match(sQCode,"(%a+)");
	if not sQtyCode then
		return 0;
	end
	sQtyCode = string.upper(sQtyCode).." ";

	local sQtyCol = string.sub(sQtyCode,1,1);
	
	local result = 0;
	if sQtyCol then
		result = string.find("WYPTG",sQtyCol);
	end
	
	if result then
		return result;
	else
		return 0;
	end
	
end

-- WpnCodeIndex: returns a specified index from a Weapon Code.
-- sWCode string:
-- 1st position: H=heavy, L=light
-- 2nd position: O=one-handed, T=two-handed, B=bow
-- 3rd position: W=white/common, Y=yellow/uncommon, P=purple/rare, T=teal/blue/incomparable, G=gold/legendary/epic

function WpnCodeIndex(sWCode, iI)

	if sWCode == nil or iI == nil then
		return 0;
	end
	if type(sWCode) ~= "string" or type(iI) ~= "number" then
		return 0;
	end

	local sWpnCode = string.match(sWCode,"(%a+)");
	if not sWpnCode then
		return 0;
	end
	sWpnCode = string.upper(sWpnCode).."   ";
	
	local sWpnCat = string.sub(sWpnCode,1,1);
	local sWpnType = string.sub(sWpnCode,2,2);
	local sWpnCol = string.sub(sWpnCode,3,3);

	local result = 0;
	if iI == 1 then
		if sWpnCat then
			result = string.find("HL",sWpnCat);
		end
	elseif iI == 2 then
		if sWpnType then
			result = string.find("OTB",sWpnType);
		end
	elseif iI == 3 then
		if sWpnCol then
			result = string.find("WYPTG",sWpnCol);
		end
	end

	if result then
		return result;
	else
		return 0;
	end
	
end

-- RomanRankDecode: converts a string with a Roman number in characters, to an integer number.
-- used for Legendary Item Title calculation.

local RomanCharsToValues = {["M"]=1000,["CM"]=900,["D"]=500,["CD"]=400,["C"]=100,["XC"]=90,["L"]=50,["XL"]=40,["X"]=10,["IX"]=9,["V"]=5,["IV"]=4,["I"]=1};

function RomanRankDecode(sNumber)

	if sNumber ~= nil and type(sNumber) == "string" and sNumber ~= "" then
		for sRomanRankChar, iRomanRankValue in pairs(RomanCharsToValues) do
			if string.sub(string.upper(sNumber),1,string.len(sRomanRankChar)) == sRomanRankChar then
				return iRomanRankValue+RomanRankDecode(string.sub(sNumber,string.len(sRomanRankChar)+1));
			end
		end
	end
	
	return 0;
	
end

-- ReverseCalc: tries to calculate back a calculation result to the original (integer) level.
-- Does not support N.

function ReverseCalc(sStat, dNum)

	if string.len(string.match(sStat,"([-%w]+)")) > 0 then
		local dNumMinus = dNum-DblCalcDev;
		local dNumPlus = dNum+DblCalcDev;
		local minlvl = 1;
		local maxlvl = 549;
		local devlvl = 3;
	
		local left = minlvl-1;
		local right = maxlvl;
		local middle;
		
		local count = minlvl;

		while right > left+1 and count <= maxlvl do
			count = count+1;
			middle = math.floor((left+right)/2);
			if CalcStat(sStat,middle) >= dNumMinus then
				right = middle;
			else
				left = middle;
			end
		end

		local mintest = right-devlvl;
		if mintest < minlvl then
			mintest = minlvl;
		end
		local maxtest = right+devlvl;
		if maxtest > maxlvl then
			maxtest = maxlvl;
		end

		local dFound;
	
		-- we check nearby in case the progression is not completely ascending/sorted.
		for test = mintest, maxtest do
			dFound = CalcStat(sStat,test);
			if dNumMinus <= dFound and dFound <= dNumPlus then
				return test;
			end
		end
	end

	return 0;

end

-- ****************** Misc. floating point support functions ******************

-- Misc. functions for floating point rounding.
-- 2nd parameter is number of decimals.

function RoundDbl(dNum, vDec)

	local dCorrection = 0.5+DblCalcDev;
	local iSign = 1;
	if dNum < 0 then
		iSign = -1;
	end
	if vDec == nil or (-DblCalcDev <= vDec and vDec <= DblCalcDev) then
		return iSign*math.floor(iSign*dNum+dCorrection);
	else
		local dFactor = 10^vDec;
		return iSign*math.floor(iSign*dNum*dFactor+dCorrection)/dFactor;
	end
	
end

function RoundDblDown(dNum, vDec)

	local dCorrection = DblCalcDev;
	local iSign = 1;
	if dNum < 0 then
		iSign = -1;
	end
	if vDec == nil or (-DblCalcDev <= vDec and vDec <= DblCalcDev) then
		return iSign*math.floor(iSign*dNum+dCorrection);
	else
		local dFactor = 10^vDec;
		return iSign*math.floor(iSign*dNum*dFactor+dCorrection)/dFactor;
	end
	
end

function RoundDblUp(dNum, vDec)

	local dCorrection = 1-DblCalcDev;
	local iSign = 1;
	if dNum < 0 then
		iSign = -1;
	end
	if vDec == nil or (-DblCalcDev <= vDec and vDec <= DblCalcDev) then
		return iSign*math.floor(iSign*dNum+dCorrection);
	else
		local dFactor = 10^vDec;
		return iSign*math.floor(iSign*dNum*dFactor+dCorrection)/dFactor;
	end
	
end

function RoundDblLotro(dNum)

	local dCorrection = 1-DblCalcDev;
	local iSign = 1;
	if dNum < 0 then
		iSign = -1;
	end

	local iNumCeiled = math.floor(iSign*dNum+dCorrection);
	if iNumCeiled <= 1000 then
		return iSign*iNumCeiled;
	end

	local iFactor = 1;
	local iTestNum = math.floor(iNumCeiled/1000);
	while iTestNum > 0 do
		iTestNum = math.floor(iTestNum/10);
		iFactor = iFactor*10;
	end

	return iSign*math.floor(iNumCeiled/iFactor+dCorrection)*iFactor;

end

-- ******************************* End CalcStat *******************************